<?php
// +---------------------------------------------------------------------------+
// | Media Gallery Plugin 1.5                                                  |
// +---------------------------------------------------------------------------+
// | $Id:: cfgedit.php 1053 2007-06-21 07:31:08Z mevans0263                   $|
// | Set configuration options for Media Gallery Plugin.                       |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2006 by the following authors:                              |
// |                                                                           |
// | Author: mevans@ecsnet.com                                                 |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');
require_once($_MG_CONF['path_admin'] . 'envcheck.php');
require_once($_MG_CONF['path_admin'] . 'navigation.php');
require_once($_MG_CONF['path_html'] . 'classFrame.php');

// $display = '';

// Only let admin users access this page
if (!SEC_hasRights('mediagallery.config')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Media Gallery Configuration page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display  = COM_siteHeader();
    $display .= COM_startBlock($LANG_MG00['access_denied']);
    $display .= $LANG_MG00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

function MG_editConfig( ) {
    global $_CONF, $_MG_CONF, $_TABLES, $_USER, $LANG_MG00, $LANG_MG01, $LANG_DIRECTION,$LANG04,$glversion;

    $retval = '';
    $T = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $T->set_file ('admin','cfgedit.thtml');
    $T->set_var('site_url', $_MG_CONF['site_url']);
    $T->set_var('site_admin_url', $_CONF['site_admin_url']);

    // build our graphics package select...

    $gp_select =  "<select name='graphicspackage'>";
    $gp_select .= "<option value='0'" . ($_MG_CONF['graphicspackage'] == 0 ? " SELECTED" : "") . ">ImageMagick</option>";
    $gp_select .= "<option value='1'" . ($_MG_CONF['graphicspackage'] == 1 ? " SELECTED" : "") . ">NetPBM</option>";
    $gp_select .= "<option value='2'" . ($_MG_CONF['graphicspackage'] == 2 ? " SELECTED" : "") . ">GD Libraries</option>";
    $gp_select .= "</select>";

    $block_select =  '<select name="displayblocks">';
    $block_select .= '<option value="0"' . ($_MG_CONF['displayblocks'] == 0 ? " SELECTED" : "") . '>' . $LANG_MG01['left_blocks_only'] . '</option>';
    $block_select .= '<option value="1"' . ($_MG_CONF['displayblocks'] == 1 ? " SELECTED" : "") . '>' . $LANG_MG01['right_blocks_only'] . '</option>';
    $block_select .= '<option value="2"' . ($_MG_CONF['displayblocks'] == 2 ? " SELECTED" : "") . '>' . $LANG_MG01['left_right_blocks'] . '</option>';
    $block_select .= '<option value="3"' . ($_MG_CONF['displayblocks'] == 3 ? " SELECTED" : "") . '>' . $LANG_MG01['none'] . '</option>';
    $block_select .= '</select>';

    $dfid_select   = '<select name="dfid"><option value="99">' . $LANG_MG00['no_date'] . '</option>' . COM_optionList ($_TABLES['dateformats'], 'dfid,description',$_MG_CONF['dfid'],0) . '</select>';

    if ($_MG_CONF['loginrequired'] == 1 ) {
        $T->set_var('lr_yes_checked', " CHECKED ");
    } else {
        $T->set_var('lr_no_checked'," CHECKED ");
    }

    if ($_MG_CONF['moderation'] == 1 ) {
        $T->set_var('au_yes_checked', " CHECKED ");
    } else {
        $T->set_var('au_no_checked'," CHECKED ");
    }
    if ($_MG_CONF['htmlallowed'] == 1 ) {
        $T->set_var('ha_yes_checked', " CHECKED ");
    } else {
        $T->set_var('ha_no_checked'," CHECKED ");
    }

    if ($_MG_CONF['whatsnew'] == 1 ) {
        $T->set_var('wn_yes_checked', " CHECKED ");
    } else {
        $T->set_var('wn_no_checked'," CHECKED ");
    }

    if ($_MG_CONF['usage_tracking'] == 1 ) {
        $T->set_var('ut_yes_checked', " CHECKED ");
    } else {
        $T->set_var('ut_no_checked'," CHECKED ");
    }

    // new in v1.3.6

    if ($_MG_CONF['preserve_filename'] == 1 ) {
        $T->set_var('pf_yes_checked', " CHECKED ");
    } else {
        $T->set_var('pf_no_checked'," CHECKED ");
    }
    if ($_MG_CONF['discard_original'] == 1 ) {
        $T->set_var('do_yes_checked', " CHECKED ");
    } else {
        $T->set_var('do_no_checked'," CHECKED ");
    }
    if ($_MG_CONF['verbose'] == 1 ) {
        $T->set_var('verbose_yes_checked', " CHECKED ");
    } else {
        $T->set_var('verbose_no_checked'," CHECKED ");
    }
    if ($_MG_CONF['disable_whatsnew_comments'] == 1 ) {
        $T->set_var('dwnc_yes_checked', " CHECKED ");
    } else {
        $T->set_var('dwnc_no_checked'," CHECKED ");
    }
    if ($_MG_CONF['enable_media_id'] == 1 ) {
        $T->set_var('emid_yes_checked', " CHECKED ");
    } else {
        $T->set_var('emid_no_checked'," CHECKED ");
    }
    if ($_MG_CONF['full_in_popup'] == 1 ) {
        $T->set_var('fip_yes_checked', " CHECKED ");
    } else {
        $T->set_var('fip_no_checked'," CHECKED ");
    }
    if ($_MG_CONF['commentbar'] == 1 ) {
        $T->set_var('cmtbar_yes_checked', " CHECKED ");
    } else {
        $T->set_var('cmtbar_no_checked'," CHECKED ");
    }
    if ($_MG_CONF['profile_hook'] == 1 ) {
        $T->set_var('ph_yes_checked', " CHECKED ");
    } else {
        $T->set_var('ph_no_checked'," CHECKED ");
    }
    if ($_MG_CONF['subalbum_select'] == 1 ) {
        $T->set_var('sa_yes_checked', " CHECKED ");
    } else {
        $T->set_var('sa_no_checked', " CHECKED ");
    }

    $T->set_var('wn_length', $_MG_CONF['title_length']);

    // end of new vars in 1.3.6

    $wn_time_select =  '<select name="whatsnew_time">';
    $wn_time_select .= '<option value="1"' . ($_MG_CONF['whatsnew_time'] == 1 ? " SELECTED" : "") . '>1 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="2"' . ($_MG_CONF['whatsnew_time'] == 2 ? " SELECTED" : "") . '>2 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="3"' . ($_MG_CONF['whatsnew_time'] == 3 ? " SELECTED" : "") . '>3 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="4"' . ($_MG_CONF['whatsnew_time'] == 4 ? " SELECTED" : "") . '>4 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="5"' . ($_MG_CONF['whatsnew_time'] == 5 ? " SELECTED" : "") . '>5 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="6"' . ($_MG_CONF['whatsnew_time'] == 6 ? " SELECTED" : "") . '>6 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="7"' . ($_MG_CONF['whatsnew_time'] == 7 ? " SELECTED" : "") . '>7 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="8"' . ($_MG_CONF['whatsnew_time'] == 8 ? " SELECTED" : "") . '>8 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="9"' . ($_MG_CONF['whatsnew_time'] == 9 ? " SELECTED" : "") . '>9 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="10"' . ($_MG_CONF['whatsnew_time'] == 10 ? " SELECTED" : "") . '>10 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="11"' . ($_MG_CONF['whatsnew_time'] == 11 ? " SELECTED" : "") . '>11 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="12"' . ($_MG_CONF['whatsnew_time'] == 12 ? " SELECTED" : "") . '>12 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="13"' . ($_MG_CONF['whatsnew_time'] == 13 ? " SELECTED" : "") . '>13 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="14"' . ($_MG_CONF['whatsnew_time'] == 14 ? " SELECTED" : "") . '>14 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="15"' . ($_MG_CONF['whatsnew_time'] == 15 ? " SELECTED" : "") . '>15 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="16"' . ($_MG_CONF['whatsnew_time'] == 16 ? " SELECTED" : "") . '>16 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="17"' . ($_MG_CONF['whatsnew_time'] == 17 ? " SELECTED" : "") . '>17 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="18"' . ($_MG_CONF['whatsnew_time'] == 18 ? " SELECTED" : "") . '>18 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="19"' . ($_MG_CONF['whatsnew_time'] == 19 ? " SELECTED" : "") . '>19 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="20"' . ($_MG_CONF['whatsnew_time'] == 20 ? " SELECTED" : "") . '>20 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="21"' . ($_MG_CONF['whatsnew_time'] == 21 ? " SELECTED" : "") . '>21 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="22"' . ($_MG_CONF['whatsnew_time'] == 22 ? " SELECTED" : "") . '>22 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="23"' . ($_MG_CONF['whatsnew_time'] == 23 ? " SELECTED" : "") . '>23 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="24"' . ($_MG_CONF['whatsnew_time'] == 24 ? " SELECTED" : "") . '>24 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="25"' . ($_MG_CONF['whatsnew_time'] == 25 ? " SELECTED" : "") . '>25 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="26"' . ($_MG_CONF['whatsnew_time'] == 26 ? " SELECTED" : "") . '>26 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="27"' . ($_MG_CONF['whatsnew_time'] == 27 ? " SELECTED" : "") . '>27 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="28"' . ($_MG_CONF['whatsnew_time'] == 28 ? " SELECTED" : "") . '>28 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="29"' . ($_MG_CONF['whatsnew_time'] == 29 ? " SELECTED" : "") . '>29 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '<option value="30"' . ($_MG_CONF['whatsnew_time'] == 30 ? " SELECTED" : "") . '>30 ' . $LANG_MG01['days'] . '</option>';
    $wn_time_select .= '</select>';

    $rating_select =  '<select name="rating_max">';
    $rating_select .= '<option value="5"' . ($_MG_CONF['rating_max'] == 5 ? " SELECTED" : "") . '>5</option>';
    $rating_select .= '<option value="10"' . ($_MG_CONF['rating_max'] == 10 ? " SELECTED" : "") . '>10</option>';
    $rating_select .= '<option value="15"' . ($_MG_CONF['rating_max'] == 15 ? " SELECTED" : "") . '>15</option>';
    $rating_select .= '<option value="20"' . ($_MG_CONF['rating_max'] == 20 ? " SELECTED" : "") . '>20</option>';
    $rating_select .= '</select>';

    $gallery_tn_size_select  = '<select name="gallery_tn_size">';
    $gallery_tn_size_select .= '<option value="0"' . ($_MG_CONF['gallery_tn_size']==0 ? 'selected="SELECTED"' : '') . '>' . $LANG_MG01['small'] . '</option>';
    $gallery_tn_size_select .= '<option value="1"' . ($_MG_CONF['gallery_tn_size']==1 ? 'selected="SELECTED"' : '') . '>' . $LANG_MG01['medium'] . '</option>';
    $gallery_tn_size_select .= '<option value="2"' . ($_MG_CONF['gallery_tn_size']==2 ? 'selected="SELECTED"' : '') . '>' . $LANG_MG01['large'] . '</option>';
    $gallery_tn_size_select .= '</select>';

    $mp3_select  = '<select name="mp3_player">';
    $mp3_select .= '<option value="0"' . ($_MG_CONF['mp3_player']==0 ? 'selected="SELECTED"' : '') . '>' . $LANG_MG01['windows_media_player'] . '</option>';
    $mp3_select .= '<option value="1"' . ($_MG_CONF['mp3_player']==1 ? 'selected="SELECTED"' : '') . '>' . $LANG_MG01['quicktime'] . '</option>';
    $mp3_select .= '<option value="2"' . ($_MG_CONF['mp3_player']==2 ? 'selected="SELECTED"' : '') . '>' . $LANG_MG01['flashplayer'] . '</option>';
    $mp3_select .= '</select>';

    $T->set_var(array(
        'popupfromalbum_selected'  => $_MG_CONF['popup_from_album'] ? ' CHECKED' : '',
        'autotag_caption_selected' => $_MG_CONF['autotag_caption'] ? ' CHECKED' : '',
        'up_dr_selected'        => $_MG_CONF['up_display_rows_enabled'] ? ' CHECKED' : '',
        'up_dc_selected'        => $_MG_CONF['up_display_columns_enabled'] ? ' CHECKED' : '',
        'up_mp3_selected'       => $_MG_CONF['up_mp3_player_enabled'] ? ' CHECKED' : '',
        'up_playback_selected'  => $_MG_CONF['up_av_playback_enabled'] ? ' CHECKED' : '',
        'up_tn_size_selected'   => $_MG_CONF['up_thumbnail_size_enabled'] ? ' CHECKED' : '',
        'jh_selected'           => $_MG_CONF['jhead_enabled'] ? ' CHECKED' : '',
        'jt_selected'           => $_MG_CONF['jpegtran_enabled'] ? ' CHECKED' : '',
        'zip_selected'          => $_MG_CONF['zip_enabled'] ? ' CHECKED' : '',
        'ffmpeg_selected'       => $_MG_CONF['ffmpeg_enabled'] ? ' CHECKED' : '',
    ));

    if ( $_MG_CONF['up_display_rows_enabled'] == 1 ) {
        $T->set_var('up_dr_yes_checked', " CHECKED ");
    } else {
        $T->set_var('up_dr_no_checked', " CHECKED ");
    }

    if ( ini_get('safe_mode') != 1 && $_MG_CONF['skip_file_find'] == 0 ) {  // don't check in safe mode, the file_exists() will fail

        // see if we can find some paths to jhead and jpegtran...

        if (PHP_OS == "WINNT") {
            $binary = "/jhead.exe";
        } else {
            $binary = "/jhead";
        }

        clearstatcache();
        if ( file_exists( $_MG_CONF['jhead_path'] . $binary ) ) {
            // do nothing..
        } else {
            clearstatcache();
            $_MG_CONF['jhead_path'] = '/usr/bin';
            if ( file_exists( $_MG_CONF['jhead_path'] . $binary ) ) {
                // do nothing..
            } else {
                clearstatcache();
                $_MG_CONF['jhead_path'] = '/usr/local/bin';
                if ( file_exists( $_MG_CONF['jhead_path'] . $binary ) ) {
                    // do nothing..
                } else {
                    clearstatcache();
                    $_MG_CONF['jhead_path'] = '/usr/X11R6/bin';
                    if ( file_exists( $_MG_CONF['jhead_path'] . $binary ) ) {
                        // do nothing..
                    }
                }
            }
        }

        if (PHP_OS == "WINNT") {
            $binary = "/jpegtran.exe";
        } else {
            $binary = "/jpegtran";
        }

        clearstatcache();
        if ( file_exists( $_MG_CONF['jpegtran_path'] . $binary ) ) {
            // do nothing..
        } else {
            clearstatcache();
            $_MG_CONF['jpegtran_path'] = '/usr/bin';
            if ( file_exists( $_MG_CONF['jpegtran_path'] . $binary ) ) {
                // do nothing..
            } else {
                clearstatcache();
                $_MG_CONF['jpegtran_path'] = '/usr/local/bin';
                if ( file_exists( $_MG_CONF['jpegtran_path'] . $binary ) ) {
                    // do nothing..
                } else {
                    clearstatcache();
                    $_MG_CONF['jpegtran_path'] = '/usr/X11R6/bin';
                    if ( file_exists( $_MG_CONF['jpegtran_path'] . $binary ) ) {
                        // do nothing..
                    }
                }
            }
        }

        if (PHP_OS == "WINNT") {
            $binary = "/unzip.exe";
        } else {
            $binary = "/unzip";
        }

        clearstatcache();
        if ( file_exists( $_MG_CONF['zip_path'] . $binary ) ) {
            // do nothing..
        } else {
            clearstatcache();
            $_MG_CONF['zip_path'] = '/usr/bin';
            if ( file_exists( $_MG_CONF['zip_path'] . $binary ) ) {
                // do nothing..
            } else {
                clearstatcache();
                $_MG_CONF['zip_path'] = '/usr/local/bin';
                if ( file_exists( $_MG_CONF['zip_path'] . $binary ) ) {
                    // do nothing..
                } else {
                    clearstatcache();
                    $_MG_CONF['zip_path'] = '/usr/X11R6/bin';
                    if ( file_exists( $_MG_CONF['zip_path'] . $binary ) ) {
                        // do nothing..
                    }
                }
            }
        }

        if (PHP_OS == "WINNT") {
            $binary = "/ffmpeg.exe";
        } else {
            $binary = "/ffmpeg";
        }

        clearstatcache();
        if ( file_exists( $_MG_CONF['ffmpeg_path'] . $binary ) ) {
            // do nothing..
        } else {
            clearstatcache();
            $_MG_CONF['ffmpeg_path'] = '/usr/bin';
            if ( file_exists( $_MG_CONF['ffmpeg_path'] . $binary ) ) {
                // do nothing..
            } else {
                clearstatcache();
                $_MG_CONF['ffmpeg_path'] = '/usr/local/bin';
                if ( file_exists( $_MG_CONF['ffmpeg_path'] . $binary ) ) {
                    // do nothing..
                } else {
                    clearstatcache();
                    $_MG_CONF['ffmpeg_path'] = '/usr/X11R6/bin';
                    if ( file_exists( $_MG_CONF['ffmpeg_path'] . $binary ) ) {
                        // do nothing..
                    }
                }
            }
        }
    }

    $frames = new mgFrame();
    $skins = array();
    $skins = $frames->getFrames();

    $skin_select = '<select name="skin">';
    for ( $i=0; $i < count($skins); $i++ ) {
        $skin_select .= '<option value="' . $skins[$i]['dir'] . '"' . ($_MG_CONF['indexskin'] == $skins[$i]['dir'] ? ' SELECTED ': '') .'>' . $skins[$i]['name'] .  '</option>';
    }
    $skin_select .= '</select>';

    if ( $glversion[1] < 4 ) {
        include_once($_MG_CONF['path_html'] . 'gl13compat.php');
    } else {
        include_once($_CONF['path_system']."classes/navbar.class.php");
    }
    $navbar = new navbar;
    $navbar->add_menuitem($LANG_MG01['general_options'],'showhideMGAdminEditorDiv("general",0);return false;',true);
    $navbar->add_menuitem($LANG_MG01['display_options'],'showhideMGAdminEditorDiv("display",1);return false;',true);
    $navbar->add_menuitem($LANG_MG01['batch_options'],'showhideMGAdminEditorDiv("batch",2);return false;',true);
    $navbar->add_menuitem($LANG_MG01['up_overrides'],'showhideMGAdminEditorDiv("userprefs",3);return false;',true);
    $navbar->add_menuitem($LANG_MG01['graphicspackage_prompt'],'showhideMGAdminEditorDiv("graphics",4);return false;',true);
    $navbar->set_selected($LANG_MG01['general_options']);
    $T->set_var ('navbar', $navbar->generate());

    $T->set_var(array(
        'no_javascript_warning'     => $LANG04[150],
        'lang_config_title'         => $LANG_MG01['configuration_title'],
        'lang_config_help'          => $LANG_MG01['configuration_help'],
        'lang_config_header'        => $LANG_MG01['configuration_header'],
        'lang_yes'                  => $LANG_MG01['yes'],
        'lang_no'                   => $LANG_MG01['no'],
        'lang_save'                 => $LANG_MG01['save'],
        'lang_cancel'               => $LANG_MG01['cancel'],
        'lang_reset'                => $LANG_MG01['reset'],
        'lang_album_columns'        => $LANG_MG01['album_display_columns_prompt'],
        'lang_album_colums_help'    => $LANG_MG01['album_display_columns_help'],
        'lang_album_rows'           => $LANG_MG01['album_display_rows'],
        'lang_subalbum_select'      => $LANG_MG01['subalbum_select'],
        'lang_loginrequired'        => $LANG_MG01['loginrequired_prompt'],
        'lang_loginrequired_help'   => $LANG_MG01['loginrequired_help'],
        'lang_anonymous_uploads'    => $LANG_MG01['anonymous_uploads_prompt'],
        'lang_anonymous_uploads_help'    => $LANG_MG01['anonymous_uploads_help'],
        'lang_comments'             => $LANG_MG01['comments_prompt'],
        'lang_comments_help'        => $LANG_MG01['comments_help'],
        'lang_graphicspackage'      => $LANG_MG01['graphicspackage_prompt'],
        'lang_graphicspackage_help' => $LANG_MG01['graphicspackage_help'],
        'lang_gp_path'              => $LANG_MG01['graphicspackage_path_prompt'],
        'lang_gp_path_help'         => $LANG_MG01['graphicspackage_path_help'],
        'lang_userpref_options'     => $LANG_MG01['up_overrides'],
        'lang_display_rows_enabled' => $LANG_MG01['up_rows_override'],
        'lang_display_columns_enabled' => $LANG_MG01['up_columns_override'],
        'lang_mp3_player_enabled'   => $LANG_MG01['up_mp3_override'],
        'lang_av_playback_enabled'  => $LANG_MG01['up_av_override'],
        'lang_thumbnail_size_enabled' => $LANG_MG01['up_tn_override'],
        'lang_album_skin'           => $LANG_MG01['index_album_skin'],
        'lang_display_rows'         => $LANG_MG01['album_display_rows'],
        'album_display_columns'     => $_MG_CONF['album_display_columns'],
        'album_display_rows'        => $_MG_CONF['album_display_rows'],
        'loginrequired'             => $_MG_CONF['loginrequired'],
        'anonymous_uploads'         => $_MG_CONF['moderation'],
        'graphicspackage'           => $gp_select,
        'graphicspackage_path'      => $_MG_CONF['graphicspackage_path'],
        'lang_displayblock'         => $LANG_MG01['displayblock_prompt'],
        'lang_displayblock_help'    => $LANG_MG01['displayblock_help'],
        'lang_jhead_enable'         => $LANG_MG01['jhead_enable'],
        'lang_jh_path'              => $LANG_MG01['jhead_path'],
        'lang_jpegtran_enable'      => $LANG_MG01['jpegtran_enable'],
        'lang_ffmpeg_enable'        => $LANG_MG01['ffmpeg_enable'],
        'lang_jt_path'              => $LANG_MG01['jpegtran_path'],
        'lang_zip_enable'           => $LANG_MG01['zip_enable'],
        'lang_zip_path'             => $LANG_MG01['zip_path'],
        'lang_tmp_path'             => $LANG_MG01['tmp_path'],
        'lang_ffmpeg_path'          => $LANG_MG01['ffmpeg_path'],
        'jhead_path'                => $_MG_CONF['jhead_path'],
        'jpegtran_path'             => $_MG_CONF['jpegtran_path'],
        'zip_path'                  => $_MG_CONF['zip_path'],
        'tmp_path'                  => $_MG_CONF['tmp_path'],
        'ftp_path'                  => $_MG_CONF['ftp_path'],
        'ffmpeg_path'               => $_MG_CONF['ffmpeg_path'],
        'displayblock'              => $block_select,
        'dfidselect'                => $dfid_select,
        'rating_select'             => $rating_select,
        'wn_time_select'            => $wn_time_select,
        'custom_image_height'       => $_MG_CONF['custom_image_height'],
        'random_width'              => $_MG_CONF['random_width'],
        'custom_image_width'        => $_MG_CONF['custom_image_width'],
        'refresh_rate'              => $_MG_CONF['def_refresh_rate'],
        'item_limit'                => $_MG_CONF['def_item_limit'],
        'time_limit'                => $_MG_CONF['def_time_limit'],
        'gallery_tn_size_select'    => $gallery_tn_size_select,
        'jpg_quality'               => $_MG_CONF['jpg_quality'],
        'tn_jpg_quality'            => $_MG_CONF['tn_jpg_quality'],
        'orig_jpg_quality'          => $_MG_CONF['jpg_orig_quality'],
        'truncate_breadcrumb'       => $_MG_CONF['truncate_breadcrumb'],
        'seperator'                 => $_MG_CONF['seperator'],
        'mp3_select'                => $mp3_select,
        'skin_select'               => $skin_select,
        'postcard_retention'        => $_MG_CONF['postcard_retention'],
        'lang_wn_time'              => $LANG_MG01['whatsnew_time'],
        'lang_gallery_tn_size'      => $LANG_MG01['gallery_tn_size'],
        'lang_jpg_quality'          => $LANG_MG01['jpg_quality'],
        'lang_tn_jpg_quality'       => $LANG_MG01['tn_jpg_quality'],
        'lang_orig_jpg_quality'     => $LANG_MG01['orig_jpg_quality'],
        'lang_truncate_breadcrumb'  => $LANG_MG01['truncate_breadcrumb'],
        'lang_seperator'            => $LANG_MG01['seperator'],
        'lang_mp3_player'           => $LANG_MG01['mp3_player'],
        'lang_htmlallowed'          => $LANG_MG01['htmlallowed'],
        'lang_whatsnew'             => $LANG_MG01['whatsnew'],
        'lang_dfid'                 => $LANG_MG01['dfid'],
        'lang_general_options'      => $LANG_MG01['general_options'],
        'lang_display_options'      => $LANG_MG01['display_options'],
        'lang_graphics_options'     => $LANG_MG01['graphics_options'],
        'lang_usage_tracking'       => $LANG_MG01['usage_tracking'],
        'lang_gallery_import'       => $LANG_MG01['gallery_import'],
        'lang_4images_import'       => $LANG_MG01['fourimages_import'],
        'lang_xppubwiz_install'     => $LANG_MG01['xppubwizard_install'],
        'lang_logviewer'            => $LANG_MG01['log_viewer'],
        'lang_preserve_filename'    => $LANG_MG01['preserve_filename'],
        'lang_discard_originals'    => $LANG_MG01['discard_originals'],
        'lang_custom_image_height'  => $LANG_MG01['custom_image_height'],
        'lang_custom_image_width'   => $LANG_MG01['custom_image_width'],
        'lang_verbose'              => $LANG_MG01['verbose'],
        'lang_dwnc'                 => $LANG_MG01['disable_wn_comments'],
        'lang_emid'                 => $LANG_MG01['enable_mid'],
        'lang_fip'                  => $LANG_MG01['full_in_popup'],
        'lang_cmtbar'               => $LANG_MG01['cmtbar'],
        'lang_wn_length'            => $LANG_MG01['wn_title_length'],
        'lang_batch_options'        => $LANG_MG01['batch_options'],
        'lang_refresh_rate'         => $LANG_MG01['refresh_rate'],
        'lang_time_limit'           => $LANG_MG01['time_limit'],
        'lang_item_limit'           => $LANG_MG01['item_limit'],
        'lang_ftp_path'             => $LANG_MG01['ftp_path'],
        'lang_characters'           => $LANG_MG01['characters'],
        'lang_postcard_retention' => $LANG_MG01['postcard_retention'],
        'lang_profile_hook'         => $LANG_MG01['profile_hook'],
        's_form_action'             => $_MG_CONF['admin_url'] . 'cfgedit.php',
        'rtl'                       => $LANG_DIRECTION == "rtl" ? "rtl" : "",
        'lang_autotag_caption'      => $LANG_MG01['autotag_caption'],
        'lang_popup_from_album'     => $LANG_MG01['popup_from_album'],
        'lang_random_size'          => $LANG_MG01['random_size'],
    ));

    $T->parse('output', 'admin');
    $retval .= $T->finish($T->get_var('output'));
    return $retval;
}

function MG_saveConfig( ) {
    global $display, $_CONF, $_MG_CONF, $_TABLES, $_USER, $_POST;

    $album_display_columns  = COM_applyFilter($_POST['albumdisplaycolumns'],true);
    $album_display_rows     = COM_applyFilter($_POST['albumdisplayrows'],true);
    $loginrequired          = COM_applyFilter($_POST['loginrequired'],true);
    $anonymous_uploads      = COM_applyFilter($_POST['anonymousuploads'],true);
    $graphicspackage        = COM_applyFilter($_POST['graphicspackage'],true);
    $graphicspackage_path   = COM_applyFilter($_POST['graphicspackage_path']);
    $jhead_path             = COM_applyFilter($_POST['jhead_path']);
    $jpegtran_path          = COM_applyFilter($_POST['jpegtran_path']);
    $zip_path               = COM_applyFilter($_POST['zip_path']);
    $ffmpeg_path            = COM_applyFilter($_POST['ffmpeg_path']);
    $tmp_path               = COM_applyFilter($_POST['tmp_path']);
    $ftp_path               = COM_applyFilter($_POST['ftp_path']);
    $displayblocks          = COM_applyFilter($_POST['displayblocks']);
    $usage_tracking         = COM_applyFilter($_POST['usagetracking']);
    $dfid                   = COM_applyFilter($_POST['dfid'],true);
    $htmlallowed            = COM_applyFilter($_POST['htmlallowed'],true);
    $whatsnew               = COM_applyFilter($_POST['whatsnew'],true);
    $orig_jpg_quality       = COM_applyFilter($_POST['orig_jpg_quality'],true);
    $jpg_quality            = COM_applyFilter($_POST['jpg_quality'],true);
    $tn_jpg_quality         = COM_applyFilter($_POST['tn_jpg_quality'],true);
    $truncate_breadcrumb    = COM_applyFilter($_POST['truncate_breadcrumb'],true);
    $seperator              = COM_applyFilter($_POST['seperator']);
    $whatsnew_time          = COM_applyFilter($_POST['whatsnew_time'],true);
    $gallery_tn_size        = COM_applyFilter($_POST['gallery_tn_size'],true);
    $mp3_player             = COM_applyFilter($_POST['mp3_player'],true);

    $preserve_filename      = COM_applyFilter($_POST['preserve_filename'],true);
    $discard_originals      = COM_applyFilter($_POST['discard_originals'],true);
    $verbose                = COM_applyFilter($_POST['verbose'],true);
    $dwnc                   = COM_applyFilter($_POST['dwnc'],true);
    $emid                   = COM_applyFilter($_POST['emid'],true);
    $fip                    = COM_applyFilter($_POST['fip'],true);
    $cmtbar                 = COM_applyFilter($_POST['cmtbar'],true);
    $wn_length              = COM_applyFilter($_POST['wn_length'],true);

    $custom_image_height    = COM_applyFilter($_POST['custom_image_height'],true);
    $custom_image_width     = COM_applyFilter($_POST['custom_image_width'],true);
    $random_width           = COM_applyFilter($_POST['random_width'],true);
    $time_limit             = COM_applyFilter($_POST['time_limit'],true);
    $item_limit             = COM_applyFilter($_POST['item_limit'],true);
    $refresh_rate           = COM_applyFilter($_POST['refresh_rate'],true);
    $postcard_retention     = COM_applyFilter($_POST['postcard_retention'],true);
    $profile_hook           = COM_applyFilter($_POST['profile_hook'],true);
    $index_album_skin       = COM_applyFilter($_POST['skin']);
    $subalbum_select        = COM_applyFilter($_POST['subalbum_select'],true);

    $popup_from_album       = COM_applyFilter($_POST['popupfromalbum'],true);
    $autotag_caption        = COM_applyFilter($_POST['autotag_caption'],true);

    if (isset($_POST['up_display_rows_enabled'])) {
        $up_display_rows_enabled = 1;
    } else {
        $up_display_rows_enabled = 0;
    }

    if (isset($_POST['up_display_columns_enabled'])) {
        $up_display_columns_enabled = 1;
    } else {
        $up_display_columns_enabled = 0;
    }

    if (isset($_POST['up_mp3_player_enabled'])) {
        $up_mp3_player_enabled = 1;
    } else {
        $up_mp3_player_enabled = 0;
    }
    if (isset($_POST['up_av_playback_enabled'])) {
        $up_av_playback_enabled = 1;
    } else {
        $up_av_playback_enabled = 0;
    }
    if (isset($_POST['up_thumbnail_size_enabled'])) {
        $up_thumbnail_size_enabled = 1;
    } else {
        $up_thumbnail_size_enabled = 0;
    }

    if ( isset($_POST['enable_jhead']) ) {
        $enable_jhead = 1;
    } else {
        $enable_jhead = 0;
    }

    if ( isset($_POST['enable_jpegtran']) ) {
        $enable_jpegtran = 1;
    } else {
        $enable_jpegtran = 0;
    }

    if ( isset($_POST['enable_zip']) ) {
        $enable_zip = 1;
    } else {
        $enable_zip = 0;
    }

    if ( isset($_POST['enable_ffmpeg']) ) {
        $enable_ffmpeg = 1;
    } else {
        $enable_ffmpeg = 0;
    }


    // sanity check on values...

    if ( $album_display_columns < 1 || $album_display_columns > 5 ) {
        $album_display_columns = 2;
    }
    if ( $loginrequired < 0 || $loginrequired > 1 ) {
        $loginrequired = 1;
    }
    if ( $displayblocks < 0 || $displayblocks > 3 ) {
        $displayblocks = 0;
    }
    if ( $usage_tracking < 0 || $usage_tracking > 1 ) {
        $usage_tracking = 0;
    }
    if ( $whatsnew < 0 || $whatsnew > 1 ) {
        $whatsnew = 0;
    }
    if ( $orig_jpg_quality < 25 || $orig_jpg_quality > 100 ) {
        $orig_jpg_quality = 75;
    }
    if ( $jpg_quality < 25 || $jpg_quality > 100 ) {
        $jpg_quality = 75;
    }

    if ( $tn_jpg_quality < 25 || $tn_jpg_quality > 100 ) {
        $tn_jpg_quality = 75;
    }
    if ( $truncate_breadcrumb == '' ) {
        $truncate_breadcrumb = 0;
    }
    if ( $seperator == '' ) {
        $seperator = '/';
    }

    // check the batch options...
    if ( $time_limit < 30 ) {
        $time_limit = 30;
    }
    if ( $item_limit < 5 ) {
        $item_limit = 5;
    }
    if ( $refresh_rate < 5 ) {
        $refresh_rate = 5;
    }

    DB_save($_TABLES['mg_config'],"config_name, config_value","'loginrequired',         '$loginrequired'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'anonymous_uploads',     '$anonymous_uploads'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'album_display_columns', '$album_display_columns'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'album_display_rows',    '$album_display_rows'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'graphicspackage',       '$graphicspackage'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'graphicspackage_path',  '$graphicspackage_path'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'displayblocks',         '$displayblocks'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'usage_tracking',        '$usage_tracking'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'dfid',                  '$dfid'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'htmlallowed',           '$htmlallowed'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'whatsnew',              '$whatsnew'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'jpg_orig_quality',      '$orig_jpg_quality'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'jpg_quality',           '$jpg_quality'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'tn_jpg_quality',        '$tn_jpg_quality'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'truncate_breadcrumb',   '$truncate_breadcrumb'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'whatsnew_time',         '$whatsnew_time'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'gallery_tn_size',       '$gallery_tn_size'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'mp3_player',            '$mp3_player'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'seperator',             '$seperator'");

    DB_save($_TABLES['mg_config'],"config_name, config_value","'up_display_rows_enabled',   '$up_display_rows_enabled'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'up_display_columns_enabled','$up_display_columns_enabled'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'up_mp3_player_enabled',     '$up_mp3_player_enabled'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'up_av_playback_enabled',    '$up_av_playback_enabled'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'up_thumbnail_size_enabled', '$up_thumbnail_size_enabled'");

    DB_save($_TABLES['mg_config'],"config_name, config_value","'jpegtran_enabled',      '$enable_jpegtran'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'jhead_enabled',         '$enable_jhead'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'jhead_path',            '$jhead_path'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'jpegtran_path',         '$jpegtran_path'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'zip_enabled',           '$enable_zip'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'zip_path',              '$zip_path'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'tmp_path',              '$tmp_path'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'ftp_path',              '$ftp_path'");

    DB_save($_TABLES['mg_config'],"config_name, config_value","'ffmpeg_enabled', '$enable_ffmpeg'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'ffmpeg_path', '$ffmpeg_path'");



    DB_save($_TABLES['mg_config'],"config_name, config_value","'preserve_filename',' $preserve_filename'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'discard_original','$discard_originals'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'verbose','$verbose'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'disable_whatsnew_comments','$dwnc'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'enable_media_id','$emid'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'full_in_popup','$fip'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'commentbar','$cmtbar'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'title_length','$wn_length'");

    DB_save($_TABLES['mg_config'],"config_name, config_value","'custom_image_height','$custom_image_height'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'custom_image_width','$custom_image_width'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'random_width','$random_width'");

    DB_save($_TABLES['mg_config'],"config_name, config_value","'def_refresh_rate','$refresh_rate'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'def_time_limit','$time_limit'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'def_item_limit','$item_limit'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'postcard_retention','$postcard_retention'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'profile_hook','$profile_hook'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'indexskin','$index_album_skin'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'subalbum_select','$subalbum_select'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'popup_from_album','$popup_from_album'");
    DB_save($_TABLES['mg_config'],"config_name, config_value","'autotag_caption','$autotag_caption'");

    // now reset anything in the prefs that need to be reset...

    if ( $up_display_rows_enabled == 0 ) {
        DB_query("UPDATE {$_TABLES['mg_userprefs']} SET display_rows=0");
    }
    if ( $up_display_columns_enabled == 0 ) {
        DB_query("UPDATE {$_TABLES['mg_userprefs']} SET display_columns=0");
    }
    if ( $up_mp3_player_enabled == 0 ) {
        DB_query("UPDATE {$_TABLES['mg_userprefs']} SET mp3_player=-1");
    }
    if ( $up_av_playback_enabled == 0 ) {
        DB_query("UPDATE {$_TABLES['mg_userprefs']} SET playback_mode=-1");
    }
    if ( $up_thumbnail_size_enabled == 0 ) {
        DB_query("UPDATE {$_TABLES['mg_userprefs']} SET tn_size=-1");
    }

    $result = DB_query("SELECT * FROM " . $_TABLES['mg_config'],1);
    $nRows  = DB_numRows($result);
    for ( $x=0; $x < $nRows ; $x++ ) {
        $row = DB_fetchArray($result);
        $_MG_CONF[$row['config_name']] = $row['config_value'];
    }

    // now check and see if the configuration is OK...

    $display .= MG_checkEnvironment();
    $display .= MG_siteFooter();
    echo $display;
    exit;
}

/**
* Main
*/

$mode = COM_applyFilter ($_REQUEST['mode']);
$display = '';
$mode = '';

if (isset ($_POST['mode'])) {
    $mode = $_POST['mode'];
} else if (isset ($_GET['mode'])) {
    $mode = $_GET['mode'];
}

if ( $glversion[1] < 4 ) {
    $display = COM_siteHeader();
} else {
    $display = COM_siteHeader('menu','',$meta);
}
$T = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
$T->set_file (array ('admin' => 'administration.thtml'));

$T->set_var(array(
    'site_admin_url'    => $_CONF['site_admin_url'],
    'site_url'          => $_MG_CONF['site_url'],
    'mg_navigation'     => MG_navigation(),
    'lang_admin'        => $LANG_MG00['admin'],
    'version'           => $_MG_CONF['version'],

));

if ($mode == $LANG_MG01['save'] && !empty ($LANG_MG01['save'])) {   // save the config
    $T->set_var(array(
        'admin_body'    => MG_saveConfig(),
        'mg_navigation' => MG_navigation()
    ));
} elseif ($mode == $LANG_MG01['cancel']) {
    echo COM_refresh ($_MG_CONF['admin_url'] . 'index.php');
    exit;
} elseif ($mode == $LANG_MG01['recheck']) {
    $T->set_var(array(
        'admin_body'    => MG_checkEnvironment(),
        'mg_navigation' => MG_navigation()
    ));
} elseif ($mode == $LANG_MG01['continue']) {
    echo COM_refresh ($_MG_CONF['admin_url'] . 'index.php?msg=2');
    exit;
} else {
    $T->set_var(array(
        'admin_body'    => MG_editConfig(),
        'title'         => $LANG_MG01['system_options'],
        'lang_help'     => '<img src="' . $_MG_CONF['site_url'] . '/images/button_help.png" border="0" alt="?">',
        'help_url'      => $_MG_CONF['site_url'] . '/docs/usage.html#System_Options',
    ));
}

$T->parse('output', 'admin');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter();
echo $display;
exit;
?>