<?php
// +---------------------------------------------------------------------------+
// | Media Gallery Plugin 1.5                                                  |
// +---------------------------------------------------------------------------+
// | $Id:: filecheck.php 1045 2007-06-21 05:25:26Z mevans0263                 $|
// |                                                                           |
// | this program will scan your media gallery installation directories        |
// | and locate old, stale files from previous installations.                  |
// | it will give you the opportunity to remove these files, just a nice       |
// | housekeeping exercise, it does not affect Media Gallery's performance     |
// | in any way.                                                               |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2006 by the following authors:                              |
// |                                                                           |
// | Author: mevans@ecsnet.com                                                 |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');
require_once($_MG_CONF['path_admin'] . 'navigation.php');

$display = '';

// Only let admin users access this page
if (!SEC_hasRights('mediagallery.config')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Media Gallery Configuration page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display  = COM_siteHeader();
    $display .= COM_startBlock($LANG_MG00['access_denied']);
    $display .= $LANG_MG00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

// List of files included in Media Gallery v1.4.9    distribution

// template files

$_MG_FILES['templates']['administration.thtml'] = 1;
$_MG_FILES['templates']['albumblock.thtml'] = 1;
$_MG_FILES['templates']['album_page.thtml'] = 1;
$_MG_FILES['templates']['album_page_body.thtml'] = 1;
$_MG_FILES['templates']['album_page_body_album_cell.thtml'] = 1;
$_MG_FILES['templates']['album_page_body_album_cell_1.thtml'] = 1;
$_MG_FILES['templates']['album_page_body_media_cell.thtml'] = 1;
$_MG_FILES['templates']['album_page_body_media_cell_1.thtml'] = 1;
$_MG_FILES['templates']['album_page_body_media_cell_comment.thtml'] = 1;
$_MG_FILES['templates']['album_page_body_media_cell_rating.thtml'] = 1;
$_MG_FILES['templates']['album_page_body_media_cell_view.thtml'] = 1;
$_MG_FILES['templates']['album_page_body_media_cell_keywords.thtml'] = 1;
$_MG_FILES['templates']['album_page_footer.thtml'] = 1;
$_MG_FILES['templates']['album_page_header.thtml'] = 1;
$_MG_FILES['templates']['album_page_noitems.thtml'] = 1;
$_MG_FILES['templates']['asf.thtml'] = 1;
$_MG_FILES['templates']['autotag.thtml'] = 1;
$_MG_FILES['templates']['autotag_nb.thtml'] = 1;
$_MG_FILES['templates']['autotag_ss.thtml'] = 1;
$_MG_FILES['templates']['batch_caption_edit.thtml'] = 1;
$_MG_FILES['templates']['batch_caption_media_items.thtml'] = 1;
$_MG_FILES['templates']['batch_percent.thtml'] = 1;
$_MG_FILES['templates']['batch_progress.thtml'] = 1;
$_MG_FILES['templates']['cat_noitems.thtml'] = 1;
$_MG_FILES['templates']['category.thtml'] = 1;
$_MG_FILES['templates']['catitems.thtml'] = 1;
$_MG_FILES['templates']['cb_featured_album.thtml'] = 1;
$_MG_FILES['templates']['cb_featured_album.thtml.2'] = 1;
$_MG_FILES['templates']['cfgedit.thtml'] = 1;
$_MG_FILES['templates']['cleanlist.thtml'] = 1;
$_MG_FILES['templates']['confirm.thtml'] = 1;
$_MG_FILES['templates']['convert_4images_settings.thtml'] = 1;
$_MG_FILES['templates']['convert_inmemoriam.thtml'] = 1;
$_MG_FILES['templates']['createmembers.thtml'] = 1;
$_MG_FILES['templates']['deletealbum.thtml'] = 1;
$_MG_FILES['templates']['digibug.thtml'] = 1;
$_MG_FILES['templates']['edit_album_perm_member.thtml'] = 1;
$_MG_FILES['templates']['edit_album_permissions.thtml'] = 1;
$_MG_FILES['templates']['edit_asf_options.thtml'] = 1;
$_MG_FILES['templates']['edit_mov_options.thtml'] = 1;
$_MG_FILES['templates']['edit_mp3_options.thtml'] = 1;
$_MG_FILES['templates']['edit_swf_options.thtml'] = 1;
$_MG_FILES['templates']['editalbum.thtml'] = 1;
$_MG_FILES['templates']['editalbum_admin.thtml'] = 1;
$_MG_FILES['templates']['editavdefaults.thtml'] = 1;
$_MG_FILES['templates']['editcategory.thtml'] = 1;
$_MG_FILES['templates']['editdefaults.thtml'] = 1;
$_MG_FILES['templates']['editmember.thtml'] = 1;
$_MG_FILES['templates']['embed.thtml'] = 1;
$_MG_FILES['templates']['enroll.thtml'] = 1;
$_MG_FILES['templates']['envcheck.thtml'] = 1;
$_MG_FILES['templates']['error.thtml'] = 1;
$_MG_FILES['templates']['exif_detail.thtml'] = 1;
$_MG_FILES['templates']['exif_tags.thtml'] = 1;
$_MG_FILES['templates']['featured_album.thtml'] = 1;
$_MG_FILES['templates']['filecheck.thtml'] = 1;
$_MG_FILES['templates']['filelist.thtml'] = 1;
$_MG_FILES['templates']['flv_stream.thtml'] = 1;
$_MG_FILES['templates']['fslideshow.thtml'] = 1;
$_MG_FILES['templates']['ftpimport.thtml'] = 1;
$_MG_FILES['templates']['ftpupload.thtml'] = 1;
$_MG_FILES['templates']['gallery_page.thtml'] = 1;
$_MG_FILES['templates']['gallery_page_body_1.thtml'] = 1;
$_MG_FILES['templates']['gallery_page_body_2.thtml'] = 1;
$_MG_FILES['templates']['gallery_page_body_3.thtml'] = 1;
$_MG_FILES['templates']['gallery_page_footer.thtml'] = 1;
$_MG_FILES['templates']['gallery_page_header.thtml'] = 1;
$_MG_FILES['templates']['gallery_page_noitems.thtml'] = 1;
$_MG_FILES['templates']['getcard.thtml'] = 1;
$_MG_FILES['templates']['global_album_attr.thtml'] = 1;
$_MG_FILES['templates']['global_album_perm.thtml'] = 1;
$_MG_FILES['templates']['import_config_dir.thtml'] = 1;
$_MG_FILES['templates']['import_gallery2_parms.thtml'] = 1;
$_MG_FILES['templates']['import_gallery_dir.thtml'] = 1;
$_MG_FILES['templates']['import_select_items.thtml'] = 1;
$_MG_FILES['templates']['install.thtml'] = 1;
$_MG_FILES['templates']['jupload.thtml'] = 1;
$_MG_FILES['templates']['massdelete.thtml'] = 1;
$_MG_FILES['templates']['mediaedit.thtml'] = 1;
$_MG_FILES['templates']['mediaitems.thtml'] = 1;
$_MG_FILES['templates']['mediamanage.thtml'] = 1;
$_MG_FILES['templates']['mg_navigation.thtml'] = 1;
$_MG_FILES['templates']['moderate.thtml'] = 1;
$_MG_FILES['templates']['mp3_podcast.thtml'] = 1;
$_MG_FILES['templates']['mp3_qt.thtml'] = 1;
$_MG_FILES['templates']['mp3_wmp.thtml'] = 1;
$_MG_FILES['templates']['pc-error.thtml'] = 1;
$_MG_FILES['templates']['pc_edit.thtml'] = 1;
$_MG_FILES['templates']['pc_preview.thtml'] = 1;
$_MG_FILES['templates']['postcard.thtml'] = 1;
$_MG_FILES['templates']['property.thtml'] = 1;
$_MG_FILES['templates']['purgealbums.thtml'] = 1;
$_MG_FILES['templates']['quicktime.thtml'] = 1;
$_MG_FILES['templates']['quotaconfirm.thtml'] = 1;
$_MG_FILES['templates']['quotareport.thtml'] = 1;
$_MG_FILES['templates']['random_block.thtml'] = 1;
$_MG_FILES['templates']['rate_entry.thtml'] = 1;
$_MG_FILES['templates']['rate_results.thtml'] = 1;
$_MG_FILES['templates']['remoteupload.thtml'] = 1;
$_MG_FILES['templates']['rssedit.thtml'] = 1;
$_MG_FILES['templates']['search.thtml'] = 1;
$_MG_FILES['templates']['search_results.thtml'] = 1;
$_MG_FILES['templates']['sess_noitems.thtml'] = 1;
$_MG_FILES['templates']['sessions.thtml'] = 1;
$_MG_FILES['templates']['sessitems.thtml'] = 1;
$_MG_FILES['templates']['slideshow.thtml'] = 1;
$_MG_FILES['templates']['sortalbum.thtml'] = 1;
$_MG_FILES['templates']['staticsort.thtml'] = 1;
$_MG_FILES['templates']['staticsortalbums.thtml'] = 1;
$_MG_FILES['templates']['staticsortmedia.thtml'] = 1;
$_MG_FILES['templates']['swf.thtml'] = 1;
$_MG_FILES['templates']['thumbs.thtml'] = 1;
$_MG_FILES['templates']['upload.thtml'] = 1;
$_MG_FILES['templates']['usage_menu.thtml'] = 1;
$_MG_FILES['templates']['usage_rpt.thtml'] = 1;
$_MG_FILES['templates']['useredit.thtml'] = 1;
$_MG_FILES['templates']['userprefs.thtml'] = 1;
$_MG_FILES['templates']['userupload.thtml'] = 1;
$_MG_FILES['templates']['useruploadstatus.thtml'] = 1;
$_MG_FILES['templates']['view_asf.thtml'] = 1;
$_MG_FILES['templates']['view_flv_stream.thtml'] = 1;
$_MG_FILES['templates']['view_image.thtml'] = 1;
$_MG_FILES['templates']['view_image_detail.thtml'] = 1;
$_MG_FILES['templates']['view_mp3_qt.thtml'] = 1;
$_MG_FILES['templates']['view_mp3_wmp.thtml'] = 1;
$_MG_FILES['templates']['view_quicktime.thtml'] = 1;
$_MG_FILES['templates']['view_swf.thtml'] = 1;
$_MG_FILES['templates']['wm_upload.thtml'] = 1;
$_MG_FILES['templates']['wmitems.thtml'] = 1;
$_MG_FILES['templates']['wmmanage.thtml'] = 1;
$_MG_FILES['templates']['xpcreate.thtml'] = 1;
$_MG_FILES['templates']['xplist.thtml'] = 1;
$_MG_FILES['templates']['xplogin.thtml'] = 1;
$_MG_FILES['templates']['xppublish.thtml'] = 1;
$_MG_FILES['templates']['albumrow.thtml'] = 1;
$_MG_FILES['templates']['mediablock.thtml'] = 1;
$_MG_FILES['templates']['mediarow.thtml'] = 1;
$_MG_FILES['templates']['modemail.thtml']  = 1;
$_MG_FILES['templates']['swfobject.thtml'] = 1;
$_MG_FILES['templates']['gl_story_import.thtml'] = 1;
$_MG_FILES['templates']['editalbum_formats.thtml'] = 1;
$_MG_FILES['templates']['slideshow_empty.thtml'] = 1;
$_MG_FILES['templates']['flv.thtml'] = 1;
$_MG_FILES['templates']['mp3_swf.thtml'] = 1;
$_MG_FILES['templates']['view_flv.thtml'] = 1;
$_MG_FILES['templates']['view_flv_light.thtml'] = 1;
$_MG_FILES['templates']['view_mp3_swf.thtml'] = 1;
$_MG_FILES['templates']['edit_flv_options.thtml'] = 1;
$_MG_FILES['templates']['import_coppermine.thtml'] = 1;
$_MG_FILES['templates']['export.thtml'] = 1;


// admin files

$_MG_FILES['admin']['avdefaults.php'] = 1;
$_MG_FILES['admin']['category.php'] = 1;
$_MG_FILES['admin']['cfgedit.php'] = 1;
$_MG_FILES['admin']['createmembers.php'] = 1;
$_MG_FILES['admin']['defaults.php'] = 1;
$_MG_FILES['admin']['edituser.php'] = 1;
$_MG_FILES['admin']['envcheck.php'] = 1;
$_MG_FILES['admin']['exif_admin.php'] = 1;
$_MG_FILES['admin']['filecheck.php'] = 1;
$_MG_FILES['admin']['index.php'] = 1;
$_MG_FILES['admin']['install.php'] = 1;
$_MG_FILES['admin']['install_doc.html'] = 1;
$_MG_FILES['admin']['logview.php'] = 1;
$_MG_FILES['admin']['maint.php'] = 1;
$_MG_FILES['admin']['massdelete.php'] = 1;
$_MG_FILES['admin']['member.php'] = 1;
$_MG_FILES['admin']['navigation.php'] = 1;
$_MG_FILES['admin']['purgealbums.php'] = 1;
$_MG_FILES['admin']['queue.php'] = 1;
$_MG_FILES['admin']['quota.php'] = 1;
$_MG_FILES['admin']['quotareport.php'] = 1;
$_MG_FILES['admin']['resetdefaults.php'] = 1;
$_MG_FILES['admin']['resetmembers.php'] = 1;
$_MG_FILES['admin']['rss.php'] = 1;
$_MG_FILES['admin']['rssrebuild.php'] = 1;
$_MG_FILES['admin']['sessions.php'] = 1;
$_MG_FILES['admin']['staticsortalbums.php'] = 1;
$_MG_FILES['admin']['staticsortmedia.php'] = 1;
$_MG_FILES['admin']['usage_rpt.php'] = 1;
$_MG_FILES['admin']['xppubwiz.php'] = 1;
$_MG_FILES['admin']['dvlpupdate.php'] = 1;
$_MG_FILES['admin']['export.php'] = 1;

// admin import files

$_MG_FILES['gallery1']['index.php']=1;
$_MG_FILES['inmemoriam']['index.php']=1;
$_MG_FILES['geekary']['index.php']=1;
$_MG_FILES['coppermine']['index.php']=1;
$_MG_FILES['4images']['index.php']=1;

// public_html

$_MG_FILES['public_html']['JPEG.php'] = 1;
$_MG_FILES['public_html']['admin.php'] = 1;
$_MG_FILES['public_html']['album.php'] = 1;
$_MG_FILES['public_html']['batch.php'] = 1;
$_MG_FILES['public_html']['classAlbum.php'] = 1;
$_MG_FILES['public_html']['classMedia.php'] = 1;
$_MG_FILES['public_html']['common.php'] = 1;
$_MG_FILES['public_html']['download.php'] = 1;
$_MG_FILES['public_html']['enroll.php'] = 1;
$_MG_FILES['public_html']['exif.php'] = 1;
$_MG_FILES['public_html']['fslideshow.php'] = 1;
$_MG_FILES['public_html']['getcard.php'] = 1;
$_MG_FILES['public_html']['index.php'] = 1;
$_MG_FILES['public_html']['jupload'] = 1;
$_MG_FILES['public_html']['lib-batch.php'] = 1;
$_MG_FILES['public_html']['lib-exif.php'] = 1;
$_MG_FILES['public_html']['lib-media.php'] = 1;
$_MG_FILES['public_html']['lib-upload.php'] = 1;
$_MG_FILES['public_html']['lib-watermark.php'] = 1;
$_MG_FILES['public_html']['media.php'] = 1;
$_MG_FILES['public_html']['media_popup.php'] = 1;
$_MG_FILES['public_html']['mediagallery.css'] = 1;
$_MG_FILES['public_html']['popup.php'] = 1;
$_MG_FILES['public_html']['postcard.php'] = 1;
$_MG_FILES['public_html']['property.php'] = 1;
$_MG_FILES['public_html']['search.php'] = 1;
$_MG_FILES['public_html']['slideshow.php'] = 1;
$_MG_FILES['public_html']['userprefs.php'] = 1;
$_MG_FILES['public_html']['video.php'] = 1;
$_MG_FILES['public_html']['watermarks'] = 1;
$_MG_FILES['public_html']['xppublish.php'] = 1;
$_MG_FILES['public_html']['gallery_remote2.php'] = 1;
$_MG_FILES['public_html']['gl13compat.css'] = 1;
$_MG_FILES['public_html']['gl13compat.php'] = 1;
$_MG_FILES['public_html']['classFrame.php'] = 1;
$_MG_FILES['public_html']['mad.php'] = 1;
$_MG_FILES['public_html']['phpinfo.php'] = 1;
$_MG_FILES['public_html']['xml.php'] = 1;


// mediaobjects

$_MG_FILES['mediaobjects']['audio.gif'] = 1;
$_MG_FILES['mediaobjects']['empty.gif'] = 1;
$_MG_FILES['mediaobjects']['flash.gif'] = 1;
$_MG_FILES['mediaobjects']['generic.gif'] = 1;
$_MG_FILES['mediaobjects']['index.html'] = 1;
$_MG_FILES['mediaobjects']['missing.png'] = 1;
$_MG_FILES['mediaobjects']['pdf.gif'] = 1;
$_MG_FILES['mediaobjects']['quicktime.gif'] = 1;
$_MG_FILES['mediaobjects']['video.gif'] = 1;
$_MG_FILES['mediaobjects']['wmp.gif'] = 1;
$_MG_FILES['mediaobjects']['zip.gif'] = 1;
$_MG_FILES['mediaobjects']['flv.png'] = 1;
$_MG_FILES['mediaobjects']['googlevideo.jpg'] = 1;
$_MG_FILES['mediaobjects']['remote.png'] = 1;
$_MG_FILES['mediaobjects']['youtube.gif'] =1 ;

// docs
$_MG_FILES['docs']['index.html'] = 1;
$_MG_FILES['docs']['mediaGallery_logo.png'] = 1;
$_MG_FILES['docs']['upgrade.html'] = 1;
$_MG_FILES['docs']['usage.html'] = 1;

// classes

$_MG_FILES['classes']['class.phpmailer.php'] = 1;
$_MG_FILES['classes']['class.smtp.php'] = 1;
$_MG_FILES['classes']['feedcreator.class.php'] = 1;
$_MG_FILES['classes']['index.html'] = 1;
$_MG_FILES['classes']['lgpl.txt'] = 1;

// javascript

$_MG_FILES['js']['client_sniff.js'] = 1;
$_MG_FILES['js']['index.html'] = 1;
$_MG_FILES['js']['qtobject.js'] = 1;
$_MG_FILES['js']['swfobject.js'] = 1;
$_MG_FILES['js']['admin_editor.js'] = 1;
$_MG_FILES['js']['avdefaults_editor.js'] = 1;
$_MG_FILES['js']['defaults_editor.js'] = 1;
$_MG_FILES['js']['memberalbums_editor.js'] = 1;
$_MG_FILES['js']['mootools.js'] = 1;
$_MG_FILES['js']['slimbox.js'] = 1;
$_MG_FILES['js']['mediagallery.js'] = 1;

// images

$_MG_FILES['images']['button_help.png'] = 1;
$_MG_FILES['images']['digibug.gif'] = 1;
$_MG_FILES['images']['feed.png'] = 1;
$_MG_FILES['images']['icon_envelopeSmall.gif'] = 1;
$_MG_FILES['images']['icon_small_envelope.gif'] = 1;
$_MG_FILES['images']['index.html'] = 1;
$_MG_FILES['images']['mediagallery.gif'] = 1;
$_MG_FILES['images']['powerby_mg-REVERSED.gif'] = 1;
$_MG_FILES['images']['powerby_mg.gif'] = 1;
$_MG_FILES['images']['progress_bar.gif'] = 1;
$_MG_FILES['images']['progress_bar_full.gif'] = 1;
$_MG_FILES['images']['rotate_left_icon.gif'] = 1;
$_MG_FILES['images']['rotate_right_icon.gif'] = 1;
$_MG_FILES['images']['shutterfly.jpeg'] = 1;
$_MG_FILES['images']['stamp.gif'] = 1;
$_MG_FILES['images']['closelabel.gif'] = 1;
$_MG_FILES['images']['loading.gif'] = 1;
$_MG_FILES['images']['nextlabel.gif'] = 1;
$_MG_FILES['images']['prevlabel.gif'] = 1;

// plugin

$_MG_FILES['plugin']['ChangeLog'] = 1;
$_MG_FILES['plugin']['INSTALL'] = 1;
$_MG_FILES['plugin']['UPGRADE'] = 1;
$_MG_FILES['plugin']['config.php'] = 1;
$_MG_FILES['plugin']['functions.inc'] = 1;
$_MG_FILES['plugin']['public_html'] = 1;
$_MG_FILES['plugin']['staticpage.txt'] = 1;
$_MG_FILES['plugin']['upgrade.inc'] = 1;
$_MG_FILES['plugin']['filelist'] = 1;
$_MG_FILES['plugin']['gpl.txt'] = 1;



function MG_maintScanDir ( $where ) {
    global $_CONF, $_MG_CONF, $_MG_FILES;

    switch ( $where ) {
        case 'admin' :
            $dir = $_MG_CONF['path_admin'];
            break;
        case 'templates' :
            $dir = $_CONF['path'] . 'plugins/mediagallery/templates/';
            break;
        case 'public_html' :
            $dir = $_MG_CONF['path_html'];
            break;
        case 'mediaobjects' :
            $dir = $_MG_CONF['path_html'] . 'mediaobjects/';
            break;
        case 'docs' :
            $dir = $_MG_CONF['path_html'] . 'docs/';
            break;
        case 'classes' :
            $dir = $_MG_CONF['path_html'] . 'classes/';
            break;
        case 'js' :
            $dir = $_MG_CONF['path_html'] . 'js/';
            break;
        case 'images' :
            $dir = $_MG_CONF['path_html'] . 'images/';
            break;
        case 'plugin' :
            $dir = $_CONF['path'] . 'plugins/mediagallery/';
            break;
        default :
            return ("Unknown directory");
            exit;
    }

    $directory = $dir;

    if (!@is_dir($directory)) {
        return;
    }
    if (!$dh = @opendir($directory)) {
        return;
    }

    $rowcounter = 0;

    $retval = '';

    $T = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $T->set_file (array(
        'filelist'  =>  'cleanlist.thtml',
    ));
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('site_admin_url', $_CONF['site_admin_url']);


   $T->set_block('filelist', 'fileRow','fRow');

    while ( ( $file = readdir($dh) ) != false ) {
        if ( $file == '..' || $file == '.' ) {
            continue;
        }
        $filename = $file;

        if (PHP_OS == "WINNT") {
            $filetmp = $directory . "\\" . $file;
        } else {
            $filetmp  = $directory . '/' . $file;
        }

        $filename = basename($file);

        $file_extension = strtolower(substr(strrchr($filename,"."),1));

        if ( is_dir($filetmp)) {
            continue;
        }
        if (!isset($_MG_FILES[$where][$filename])) {
            $T->set_var(array(
                'row_class'     =>      ($rowcounter % 2) ? '1' : '2',
                'filename'      =>      $filename,
                'dir'           =>      $where,
            ));
            $T->parse('fRow','fileRow',true);
            $rowcounter++;
        }
    }
    $T->parse('filelist','filelist');

    closedir($dh);
    $T->set_var(array(
        'directory' => $directory,
    ));
    $T->parse('output','filelist');
    $retval .= $T->finish($T->get_var('output'));

    if ( $rowcounter == 0 ) {
        return '';
    } else {
        return $retval;
    }
}

function MG_fileCheck() {
    global $_CONF, $_MG_CONF, $_MG_FILES, $LANG_MG00, $LANG_MG01;

    $retval = '';

    $T = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $T->set_file (array(
        'admin'  =>  'filecheck.thtml',
    ));
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('site_admin_url', $_CONF['site_admin_url']);

    $filelist .= MG_maintScanDir('templates');
    $filelist .= MG_maintScanDir('admin');
    $filelist .= MG_maintScanDir('public_html');
    $filelist .= MG_maintScanDir('mediaobjects');
    $filelist .= MG_maintScanDir('docs');
    $filelist .= MG_maintScanDir('classes');
    $filelist .= MG_maintScanDir('js');
    $filelist .= MG_maintScanDir('images');
    $filelist .= MG_maintScanDir('plugin');

    $T->set_var(array(
        's_form_action'         => $_MG_CONF['admin_url'] . '/filecheck.php?mode=clean',
        'filelist'              => $filelist,
        'lang_filecheck_disclaimer' => $LANG_MG00['filecheck_disclaimer'],
        'lang_cancel'           => $LANG_MG01['cancel'],
        'lang_delete'           => $LANG_MG01['delete'],
        'lang_checkall'         => $LANG_MG01['check_all'],
        'lang_uncheckall'       => $LANG_MG01['uncheck_all'],
        'lang_delete_confirm'   => $LANG_MG01['delete_item_confirm'],
    ));

    $T->parse('output', 'admin');
    $retval .= $T->finish($T->get_var('output'));
    return $retval;
}

function MG_fileCheckDelete( ) {
    global $_MG_CONF, $_CONF, $_POST;

    $numItems = count($_POST['sel']);
    for ($i=0; $i < $numItems; $i++) {
        $filename = COM_applyFilter($_POST['sel'][$i]);
        $where    = COM_applyFilter($_POST['dir'][$i]);

        switch ( $where ) {
            case 'admin' :
                $dir = $_MG_CONF['path_admin'];
                break;
            case 'templates' :
                $dir = $_CONF['path'] . 'plugins/mediagallery/templates/';
                break;
            case 'public_html' :
                $dir = $_MG_CONF['path_html'];
                break;
            case 'mediaobjects' :
                $dir = $_MG_CONF['path_html'] . 'mediaobjects/';
                break;
            case 'docs' :
                $dir = $_MG_CONF['path_html'] . 'docs/';
                break;
            case 'classes' :
                $dir = $_MG_CONF['path_html'] . 'classes/';
                break;
            case 'js' :
                $dir = $_MG_CONF['path_html'] . 'js/';
                break;
            case 'images' :
                $dir = $_MG_CONF['path_html'] . 'images/';
                break;
            case 'plugin' :
                $dir = $_CONF['path'] . 'plugins/mediagallery/';
                break;
            default :
                continue;
        }
        $fullName = $dir . $filename;
        COM_errorLog("Media Gallery: FileCheck removing " . $fullName);
        @unlink($fullName);
    }
    echo COM_refresh($_MG_CONF['admin_url'] . 'index.php?msg=17');
    exit;
}


/**
* Main
*/

$mode = COM_applyFilter ($_REQUEST['mode']);
$display = '';
$mode = '';

if (isset ($_POST['mode'])) {
    $mode = $_POST['mode'];
} else if (isset ($_GET['mode'])) {
    $mode = $_GET['mode'];
}

$display = COM_siteHeader();
$T = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
$T->set_file (array ('admin' => 'administration.thtml'));
$T->set_var(array(
    'site_admin_url'    => $_CONF['site_admin_url'],
    'site_url'          => $_MG_CONF['site_url'],
    'mg_navigation'     => MG_navigation(),
    'lang_admin'        => $LANG_MG00['admin'],
    'version'           => $_MG_CONF['version'],
));

if ($mode == $LANG_MG01['cancel']) {
    echo COM_refresh ($_MG_CONF['admin_url'] . 'index.php');
    exit;
} elseif ($mode == $LANG_MG01['delete'] && !empty ($LANG_MG01['delete'])) {
    MG_fileCheckDelete( )    ;
} else {
    $T->set_var(array(
        'admin_body'    => MG_fileCheck(),
        'title'         => $LANG_MG00['filecheck'],
    ));
}

$T->parse('output', 'admin');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter();
echo $display;
exit;
?>