<?php
// +---------------------------------------------------------------------------+
// | Media Gallery Plugin 1.5                                                  |
// +---------------------------------------------------------------------------+
// | $Id:: quotareport.php 1045 2007-06-21 05:25:26Z mevans0263               $|
// | Quota report.                                                             |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2006 by the following authors:                              |
// |                                                                           |
// | Author: mevans@ecsnet.com                                                 |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');
require_once($_MG_CONF['path_admin'] . 'navigation.php');

// Only let admin users access this page
if (!SEC_hasRights('mediagallery.config')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Media Gallery Quota Report.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display  = COM_siteHeader();
    $display .= COM_startBlock($LANG_MG00['access_denied']);
    $display .= $LANG_MG00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

function MG_quotaReport($page,$quotaquery,$usedquery) {
    global $glversion,$_TABLES, $_MG_CONF, $_CONF, $LANG_MG01,$LANG_MG03;

    $counter = 0;

    $retval = '';

    $T = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $T->set_file (array ('report' => 'quotareport.thtml'));

    $retval .= COM_startBlock ('', '',COM_getBlockTemplate ('_admin_block', 'header'));

    $T->set_var(array(
        'lang_username'     => $LANG_MG01['username'],
        'lang_active'       => $LANG_MG01['active'],
        'lang_quota'        => $LANG_MG01['quota'],
        'lang_used'         => $LANG_MG01['used'],
    ));

    $T->set_block('report', 'UserRow', 'uRow');

    if ( $glversion[1] < 4 ) {
        $result = DB_query("SELECT * FROM {$_TABLES['users']} WHERE uid > 2 ORDER BY username ASC");
    } else {
        $result = DB_query("SELECT * FROM {$_TABLES['users']} WHERE status=3 AND uid > 2 ORDER BY username ASC");
    }
    while ( $userRow = DB_fetchArray($result) ) {
        $uid = $userRow['uid'];
        $quota_mb = MG_getUserQuota($uid) / 1048676;
        $quota = number_format(($quota_mb),2);
        $used_mb = (float) MG_quotaUsage( $uid ) / 1048576;
        $used  = number_format(($used_mb),2);

        if ( $quotaquery > 0 ) { // limit based on quota
        	if ( $quota_mb >= $quotaquery ) {
	        	$show = 1;
        	} else {
	        	$show = 0;
        	}
    	} else {
	    	$show = 1;
    	}

    	if ( $usedquery > 0 ) {
	    	if ( $used_mb > $usedquery ) {
		    	$show = 1;
	    	} else {
		    	$show = 0;
	    	}
    	}
		if ($show) {
	        $T->set_var(array(
	            'result_row'    => $rowcounter,
	            'rowclass'      => ($rowcounter % 2) ? '2' : '1',
	            'username'      => '<a href="' . $_MG_CONF['admin_url'] . 'edituser.php?uid=' . $uid . '">' . $userRow['username'] . " (" . $userRow['fullname'] . ")</a>",
	            'uid'			=> $uid,
	            'quota'         => ($quota == 0 ? 'Unlimited' : $quota),
	            'used'          => $used, // COM_numberFormat($used),
	            'active'        => MG_getUserActive($uid),
	        ));
	        $T->parse('uRow','UserRow',true);
	        $rowcounter++;
	        $counter++;
    	}
    }

//    $navPageNumber = $page + 1;

//	$pagenav = COM_printPageNavigation( $_MG_CONF['admin_url'] . 'quotareport.php', $page+1, $totalPages,'page=', false, '','');

	$T->set_var(array(
		'used'			=> $usedquery,
		'quota'			=> $quotaquery,
		'lang_go'		=> $LANG_MG03['go'],
		'lang_quota'	=> $LANG_MG01['quota'],
		'lang_used'		=> $LANG_MG01['used'],
		'lang_batch_update'	=> $LANG_MG01['batch_quota_update'],
		'lang_update'		=> $LANG_MG01['update'],
	));

    $T->parse('output', 'report');
    $retval .= $T->finish($T->get_var('output'));
    $retval .= COM_endBlock (COM_getBlockTemplate ('_admin_block', 'footer'));
    return $retval;
}

if ( isset($_POST['mode']) ) {
	$mode = COM_applyFilter($_POST['mode']);
	$bquota = COM_applyFilter($_POST['bquota'],true);

    $numItems = count($_POST['uid']);

    for ($i=0; $i < $numItems; $i++) {
	    $sql = "UPDATE {$_TABLES['mg_userprefs']} SET quota=" . $bquota . " WHERE uid=" . $_POST['uid'][$i];
	    $result = DB_query($sql);
	    if ( DB_error() ) {
		    $sql = "INSERT INTO {$_TABLES['mg_userprefs']} (uid, active, display_rows, display_columns, mp3_player, playback_mode, tn_size, quota, member_gallery) VALUES (" . $uid . ",1,0,0,-1,-1,-1," . $bquota . ",0)";
    		DB_query($sql,1);
		}
	}
}

$page = COM_applyFilter($_GET['page'],true);
if ( $page <= 0 ) {
	$page = 0;
} else {
	$page--;
}

$quota  = COM_applyFilter($_POST['quota'],true);
$used   = COM_applyFilter($_POST['used'],true);

$display = COM_siteHeader($LANG_MG01['quota_report']);
$T = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
$T->set_file (array ('admin' => 'administration.thtml'));
$T->set_var(array(
    'site_admin_url'    => $_CONF['site_admin_url'],
    'site_url'          => $_MG_CONF['site_url'],
    'mg_navigation'     => MG_navigation(),
    'lang_admin'        => $LANG_MG00['admin'],
    'version'           => $_MG_CONF['version'],

));

$T->set_var(array(
    'admin_body'    => MG_quotaReport($page,$quota,$used),
    'title'         => $LANG_MG01['quota_report'],
    'lang_help'     => '<img src="' . $_MG_CONF['site_url'] . '/images/button_help.png" border="0" alt="?">',
    'help_url'      => $_MG_CONF['site_url'] . '/docs/usage.html#Member_Album_User_list',

));


$T->parse('output', 'admin');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter();
echo $display;
exit;
?>
