<?php
// +---------------------------------------------------------------------------+
// | Media Gallery Plugin 1.5                                                  |
// +---------------------------------------------------------------------------+
// | $Id:: config.php 1051 2007-06-21 07:30:14Z mevans0263                    $|
// +---------------------------------------------------------------------------+
// | Copyright (C) 2005, 2006 by the following authors:                        |
// |                                                                           |
// | Mark R. Evans               -    mevans@ecsnet.com                        |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//


// There are lots of versions of ffmpeg out there, some work with one set of switches
//  and some don't.  You can easily modify the commands used to create thumbnails from
//  videos by modifying the arguments below.  The first %s is the source video and the
//  second %s is the destination thumbnail, both %s need to be in the command.
$_MG_CONF['ffmpeg_command_args'] = ' -i %s -f mjpeg -t 0.01 -y %s';
// $_MG_CONF['ffmpeg_command_args'] = ' -i %s -f mjpeg -an -r 1 -ss 00:00:03 -vframes 1 -y %s';
// $_MG_CONF['ffmpeg_command_args'] = ' -i %s -f singlejpeg -an -r 1 -ss 00:00:03 -vframes 1 -y %s';
// RIVA FLV Encoded / converter command line
// $_MG_CONF['ffmpeg_command_args'] = ' -an -y  -i "%s" -t 0.001 -s 640x480 -deinterlace   -hq -f image2 "%s"';

// Path Configuration

$_MG_CONF['path_mg']            = 'mediagallery';  // You should only change this one!
$_MG_CONF['path_html']          = $_CONF['path_html'] . $_MG_CONF['path_mg'] . '/';
$_MG_CONF['site_url']           = $_CONF['site_url']  . '/' . $_MG_CONF['path_mg'];
$_MG_CONF['admin_url']          = $_CONF['site_admin_url'] . '/plugins/mediagallery/';
$_MG_CONF['path_admin']         = $_CONF['path_html'] . 'admin/plugins/mediagallery/';

// Global Options
$_MG_CONF['disable_version_check']   = 0;       // set this to 1 to disable external version check
$_MG_CONF['mediamanage_items']       = 200;     // number of items to display in Manage Media screen
$_MG_CONF['do_not_convert_original'] = 0;       // set to 1 to disable forced conversion of original images to JPG
$_MG_CONF['im_keep_profiles']        = 0;       // turns on / off keeping JPG profile data in thumbnails
                                                // when using ImageMagick - 0 keeps the +profile "*" switch
                                                // 1 disables (removes) the +profile "*" option from the convert command
$_MG_CONF['skip_file_find']          = 0;       // If you have openbasdir restriction errors set this to 1


// Auto Tag defaults - these will control how auto tags work if you do not add any options to the tag
$_MG_CONF['at_border']          = 1;
$_MG_CONF['at_align']           = 'auto';
$_MG_CONF['at_width']           = 0;
$_MG_CONF['at_height']          = 0;
$_MG_CONF['at_src']             = 'tn';
$_MG_CONF['at_autoplay']        = 0;
$_MG_CONF['at_enable_link']     = 1;
$_MG_CONF['at_delay']           = 5;
$_MG_CONF['at_transition']      = 'Fade';
$_MG_CONF['at_showtitle']       = 'false';

// --- DO NOT CHANGE ANYTHING BELOW THIS LINE
$_MG_CONF['menulabel']           = $LANG_MG00['menulabel'];
$_MG_CONF['version']             = '1.5.1';
$_MG_CONF['pi_name']             = 'mediagallery';

$_MG_table_prefix = $_DB_table_prefix;

$_TABLES['mg_albums']            = $_MG_table_prefix . 'mg_albums';
$_TABLES['mg_media_albums']      = $_MG_table_prefix . 'mg_media_albums';
$_TABLES['mg_media']             = $_MG_table_prefix . 'mg_media';
$_TABLES['mg_usage_tracking']    = $_MG_table_prefix . 'mg_usage_tracking';
$_TABLES['mg_config']            = $_MG_table_prefix . 'mg_config';
$_TABLES['mg_mediaqueue']        = $_MG_table_prefix . 'mg_media_queue';
$_TABLES['mg_media_album_queue'] = $_MG_table_prefix . 'mg_media_album_queue';
$_TABLES['mg_playback_options']  = $_MG_table_prefix . 'mg_playback_options';
$_TABLES['mg_userprefs']         = $_MG_table_prefix . 'mg_userprefs';
$_TABLES['mg_exif_tags']         = $_MG_table_prefix . 'mg_exif_tags';
$_TABLES['mg_watermarks']        = $_MG_table_prefix . 'mg_watermarks';
$_TABLES['mg_category']          = $_MG_table_prefix . 'mg_category';
$_TABLES['mg_sessions']          = $_MG_table_prefix . 'mg_batch_sessions';
$_TABLES['mg_session_items']     = $_MG_table_prefix . 'mg_batch_session_items';
$_TABLES['mg_session_items2']    = $_MG_table_prefix . 'mg_batch_session_items2';
$_TABLES['mg_session_log']       = $_MG_table_prefix . 'mg_batch_session_log';
$_TABLES['mg_sort']              = $_MG_table_prefix . 'mg_sort';
$_TABLES['mg_postcard']          = $_MG_table_prefix . 'mg_postcard';
?>