<?php
// +---------------------------------------------------------------------------+
// | Media Gallery Plugin 1.5                                                  |
// +---------------------------------------------------------------------------+
// | $Id:: classMedia.php 1046 2007-06-21 05:26:22Z mevans0263                $|
// +---------------------------------------------------------------------------+
// | Copyright (C) 2005 by the following authors:                              |
// |                                                                           |
// | Mark R. Evans              - mevans@ecsnet.com                            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

// this file can't be used on its own
if (!defined ('VERSION')) {
    die ('This file can not be used on its own.');
}

class Media {
    var $id;
    var $title;
    var $description;
    var $filename;
    var $keywords;
    var $mime_ext;
    var $mime_type;
    var $time;
    var $views;
    var $comments;
    var $votes;
    var $rating;
    var $tn_attached;
    var $tn_image;
    var $owner_id;
    var $type;
    var $upload_time;
    var $album_id;
    var $cat_id;
    var $watermarked;
    var $resolution_x;
    var $resolution_y;
    var $remote;
    var $remote_url;
    var $access;

    function Media () {
    }

    function constructor( $M, $aid ) {
        $this->id               = $M['media_id'];
        $this->title            = $M['media_title'];
        $this->description      = $M['media_desc'];
        $this->filename         = $M['media_filename'];
        $this->keywords         = $M['media_keywords'];
        $this->mime_ext         = $M['media_mime_ext'];
        $this->mime_type        = $M['mime_type'];
        $this->time             = $M['media_time'];
        $this->views            = $M['media_views'];
        $this->comments         = $M['media_comments'];
        $this->votes            = $M['media_votes'];
        $this->rating           = $M['media_rating'];
        $this->tn_attached      = $M['media_tn_attached'];
        $this->tn_image         = $M['media_tn_image'];
        $this->owner_id         = $M['media_user_id'];
        $this->type             = $M['media_type'];
        $this->upload_time      = $M['media_upload_time'];
        $this->cat_id           = $M['media_category'];
        $this->watermarked      = $M['media_watermarked'];
        $this->resolution_x     = $M['media_resolution_x'];
        $this->resolution_y     = $M['media_resolution_y'];
        $this->remote			= $M['remote_media'];
        $this->remote_url		= $M['remote_url'];
        $this->album_id         = $aid;
        $this->setAccessRights();

    }

    function setAccessRights() {
        global $MG_albums;

        $this->access = $MG_albums[$this->album_id]->access;
    }

    function displayThumb( $s, $sortOrder ) {
        global $_CONF, $_MG_CONF, $MG_albums, $_TABLES, $_MG_USERPREFS, $LANG_MG03, $LANG_MG01;

        $retval = '';

        $T = new Template($_CONF['path'] . 'plugins/mediagallery/templates');

        $T->set_file (array(
            'media_cell_image'      => $MG_albums[$this->album_id]->display_columns == 1 ? 'album_page_body_media_cell_1.thtml' : 'album_page_body_media_cell.thtml' ,
            'media_rate_results'    => 'album_page_body_media_cell_rating.thtml',
            'media_comments'        => 'album_page_body_media_cell_comment.thtml',
            'media_views'           => 'album_page_body_media_cell_view.thtml',
            'media_cell_keywords'   => 'album_page_body_media_cell_keywords.thtml',
            'mp3_podcast'			=> 'mp3_podcast.thtml',
        ));

        $F = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
        $F->set_var('media_frame',$MG_albums[$this->album_id]->imageFrameTemplate);
        // --- set the default thumbnail

        switch( $this->type ) {
            case 0 :    // standard image
                $default_thumbnail = 'tn/' . $this->filename[0] . '/' . $this->filename . '.jpg';
                break;
            case 1 :    // video file
                switch ( $this->mime_type ) {

                    case 'video/x-flv' :
                        $default_thumbnail = 'flv.png';
                        break;
                    case 'application/x-shockwave-flash' :
                        $default_thumbnail = 'flash.gif';
                        break;
                    case 'video/mpeg' :
                    case 'video/x-motion-jpeg' :
                    case 'video/quicktime' :
                    case 'video/mpeg' :
                    case 'video/x-mpeg' :
                    case 'video/x-mpeq2a' :
                    case 'video/x-qtc' :
                    case 'audio/mpeg' :
                        $default_thumbnail = 'quicktime.gif';
                        break;
                    case 'asf' :
                    case 'video/x-ms-asf' :
                    case 'video/x-ms-asf-plugin' :
                    case 'video/avi' :
                    case 'video/msvideo' :
                    case 'video/x-msvideo' :
                    case 'video/avs-video' :
                    case 'video/x-ms-wmv' :
                    case 'video/x-ms-wvx' :
                    case 'video/x-ms-wm' :
                    case 'application/x-troff-msvideo' :
                    case 'application/x-ms-wmz' :
                    case 'application/x-ms-wmd' :
                        $default_thumbnail = 'wmp.gif';
                        break;
                    default :
                        $default_thumbnail = 'video.gif';
                        break;
                }
                break;
            case 2 :    // music file
                $default_thumbnail = 'audio.gif';
                break;
            case 4 :    // other files
                switch ($this->mime_type) {
                    case 'application/zip' :
                    case 'zip' :
                    case 'arj' :
                    case 'rar' :
                    case 'gz'  :
                        $default_thumbnail = 'zip.gif';
                        break;
                    case 'pdf' :
                    case 'application/pdf' :
                        $default_thumbnail = 'pdf.gif';
                        break;
                    default :
                        switch ( $this->mime_ext ) {
                            case 'pdf' :
                                $default_thumbnail = 'pdf.gif';
                                break;
                            case 'arj' :
                                $default_thumbnail = 'zip.gif';
                                break;
                            case 'gz' :
                                $default_thumbnail = 'zip.gif';
                                break;
                            default :
                                $default_thumbnail = 'generic.gif';
                                break;
                        }
                        break;
                }
                break;
            case 5 :
                case 'embed' :
					if (preg_match("/youtube/i", $this->remote_url)) {
						$default_thumbnail = 'youtube.gif';
					} else if (preg_match("/google/i", $this->remote_url)) {
						$default_thumbnail = 'googlevideo.jpg';
					} else {
						$default_thumbnail = 'flv.png';
					}
					break;

        }

        if ( $this->tn_attached == 1 ) {
            $media_thumbnail      = $_MG_CONF['site_url']  . '/mediaobjects/tn/'.  $this->filename[0] . '/tn_' . $this->filename . '.jpg';
            $media_thumbnail_file = $_MG_CONF['path_html'] . 'mediaobjects/tn/'.  $this->filename[0] . '/tn_' . $this->filename . '.jpg';
        } else {
            $media_thumbnail      = $_MG_CONF['site_url']  . '/mediaobjects/' . $default_thumbnail;
            $media_thumbnail_file = $_MG_CONF['path_html'] . 'mediaobjects/' . $default_thumbnail;
        }

        // type == 1 video
        // type == 2 audio
        if ( ($this->type == 1 || $this->type == 2 || $this->type == 5 ) && ($MG_albums[$this->album_id]->playback_type == 0 || $MG_albums[$this->album_id]->playback_type == 1) && $_MG_CONF['popup_from_album'] == 1) {
	        if ( $MG_albums[$this->album_id]->playback_type == 0 ) {
	        	if ( $this->type == 2 ) {
			        // determine what type of player we will use (WMP, QT or Flash)
			        $player = $_MG_CONF['mp3_player'];
			        if ( isset($_MG_USERPREFS['mp3_player']) && $_MG_USERPREFS['mp3_player'] != -1 ) {
				        $player = $_MG_USERPREFS['mp3_player'];
			        }
			        switch ( $player ) {
				        case 0 :	// WMP
				        	$new_y = 60;
				        	$new_x = 350;
				        	break;
				        case 1 :	// QT
				        	$new_y = 25;
				        	$new_x = 350;
				        	break;
				        case 2 :
				        	$new_y = 360;
				        	$new_x = 580;
				        	break;
			        }
			        if ( $this->tn_attached == 1 && $player != 2) {
				        $tnsize = @getimagesize($media_thumbnail_file);
				        $new_y += $tnsize[0];
				        if ( $tnsize[1] > $new_x ) {
					        $new_x = $tnsize[1];
				        }
			        }
		            if ( $MG_albums[$this->album_id]->playback_type == 0 ) {
		                $url_display_item = "javascript:showVideo('" . $_MG_CONF['site_url'] . '/video.php?n=' . $this->id . "'," . $new_y . ',' . $new_x . ')';
		            } else {
		                $url_display_item = $_MG_CONF['site_url'] . '/download.php?mid=' . $this->id;
		            }
	            } else { // must be a video...
		            if ( $this->resolution_x > 0 ) {
		                $resolution_x = $this->resolution_x;
		                $resolution_y = $this->resolution_y;
		            } else {
		                if ( $this->media_resolution_x == 0 && $this->remote_media != 1) {
		                    require_once($_MG_CONF['path_html'] . '/getid3/getid3/getid3.php');
		                    // Needed for windows only
		                    define('GETID3_HELPERAPPSDIR', 'C:/helperapps/');
		                    $getID3 = new getID3;
		                    // Analyze file and store returned data in $ThisFileInfo
		                    $ThisFileInfo = $getID3->analyze($_MG_CONF['path_html'] . '/mediaobjects/orig/' . $this->filename[0] . '/' . $this->filename . '.' . $this->mime_ext);
		                    getid3_lib::CopyTagsToComments($ThisFileInfo);
		                    if ( $ThisFileInfo['video']['resolution_x'] < 1 || $ThisFileInfo['video']['resolution_y'] < 1 ) {
		                        if (isset($ThisFileInfo['meta']['onMetaData']['width']) && isset($ThisFileInfo['meta']['onMetaData']['height']) ) {
		                            $resolution_x = $ThisFileInfo['meta']['onMetaData']['width'];
		                            $resolution_y = $ThisFileInfo['meta']['onMetaData']['height'];
		                        } else {
		                            $resolution_x = -1;
		                            $resolution_y = -1;
		                        }
		                    } else {
		                        $resolution_x = $ThisFileInfo['video']['resolution_x'];
		                        $resolution_y = $ThisFileInfo['video']['resolution_y'];
		                    }
		                    if ( $resolution_x != 0 ) {
		                        $sql = "UPDATE " . $_TABLES['mg_media'] . " SET media_resolution_x=" . $resolution_x . ",media_resolution_y=" . $resolution_y . " WHERE media_id='" . $this->id . "'";
		                        DB_query( $sql,1 );
		                    }
		                } else {
		                    $resolution_x = $this->resolution_x;
		                    $resolution_y = $this->resolution_y;
		                }
		            }
		            if ( $resolution_x < 1 || $resolution_y < 1 ) {
		                $resolution_x = 480;
		                $resolution_y = 320;
		            } else {
		                $resolution_x = $resolution_x + 40;
		                $resolution_y = $resolution_y + 80;
		            }
	            	if ( $this->mime_type == 'video/x-flv' ) {
		            	if ( $resolution_x < 610 ) {
			            	$resolution_x = 610;
		            	}
		            	$resolution_y = $resolution_y + 190;
	            	}
	            	if ( $this->type == 5 ) {
		            	$resolution_x = 460;
		            	$resolution_y = 380;
	            	}
	                $url_display_item = "javascript:showVideo('" . $_MG_CONF['site_url'] . '/video.php?n=' . $this->id . "'," . $resolution_y . ',' . $resolution_x . ')';
                }
            } else {
                $url_display_item = $_MG_CONF['site_url'] . '/download.php?mid=' . $this->id;
            }
            // check to see if comments and rating are enabled, if not, put a link to edit...
	        if ( $MG_albums[$this->album_id]->enable_rating == 0 && $MG_albums[$this->album_id]->enable_comments == 0 ) {
		        if ( $MG_albums[$this->album_id]->access == 3 ) {
		    		$T->set_var(array(
		    			'edit_link'		=> '<br><a href="' . $_MG_CONF['site_url'] . '/admin.php?mode=mediaedit&s=1&amp;album_id=' . $this->album_id . '&amp;mid=' . $this->id . '">' . $LANG_MG01['edit'] . '</a>',
		    		));
	    		} else {
		    		$T->set_var(array(
		    			'edit_link'	=> '',
		    		));
	    		}
	    	} else {
		    	$T->set_var(array(
		    		'edit_link'		=> '',
		    	));
			}
        } else {
            $url_display_item  = $_MG_CONF['site_url'] . '/media.php?f=0' . '&amp;sort=' . $sortOrder . '&amp;s=' . $this->id ;
        }
        if ( $this->type == 4 ) { // other
            $url_display_item  = $_MG_CONF['site_url'] . '/download.php?mid=' . $this->id ;
        }

        $media_size        = @getimagesize($media_thumbnail_file);

        if ( $media_size == false ) {
            $default_thumbnail    = 'missing.png';
            $media_thumbnail      = $_MG_CONF['site_url']  . '/mediaobjects/' . $default_thumbnail;
            $media_thumbnail_file = $_MG_CONF['path_html'] . 'mediaobjects/' . $default_thumbnail;
            $media_size           = @getimagesize($media_thumbnail_file);
        }

        $media_time        = MG_getUserDateTimeFormat($this->time);

        $url_media_item = $url_display_item;

        // -- decide what thumbnail size to use, small, medium, large...

        if (isset($_MG_USERPREFS['tn_size']) && $_MG_USERPREFS['tn_size'] != -1 ) {
            $tn_size = $_MG_USERPREFS['tn_size'];
        } else {
            $tn_size = $MG_albums[$this->album_id]->tn_size;
        }

        switch ($tn_size ) {
            case '0' :      //small
                $tn_height = 100;
                break;
            case '1' :      //medium
                $tn_height = 150;
                break;
            case '2' :
                $tn_height = 200;
                break;
            default :
                $tn_height = 150;
                break;
        }
        if ( $media_size[0] > $media_size[1] ) {
            $ratio = $media_size[0] / $tn_height;
            $newwidth = $tn_height;
            $newheight = round($media_size[1] / $ratio);
        } else {
            $ratio = $media_size[1] / $tn_height;
            $newheight = $tn_height;
            $newwidth = round($media_size[0] / $ratio);
        }

        if ( $media_size[0] > $media_size[1] ) {
            $ratio = $media_size[0] / 50;
            $smallwidth = 50;
            $smallheight = round($media_size[1] / $ratio);
        } else {
            $ratio = $media_size[1] / 50;
            $smallheight = 50;
            $smallwidth = round($media_size[0] / $ratio);
        }

        if ( $this->owner_id != "" && $this->owner_id > 1 ) {
	        $username = DB_getItem($_TABLES['users'],'username',"uid=$this->owner_id");
        } else {
	        $username = 'anonymous';
        }

        if ( $this->mime_type == 'audio/mpeg' ) {
	    	$T->set_var(array(
	    		'play_now'		=> '',
	    		'download_now'	=> $_MG_CONF['site_url'] . '/download.php?mid=' . $this->id,
	    		'play_in_popup' => "javascript:showVideo('" . $_MG_CONF['site_url'] . '/video.php?n=' . $this->id . "'," . $resolution_y . ',' . $resolution_x . ')',
	    		'mp3_file' => $_MG_CONF['site_url'] . '/mediaobjects/orig/' . $this->filename[0] . '/' . $this->filename . '.' . $this->mime_ext,
	            'site_url'			=> $_MG_CONF['site_url'],
	            'id'				=> $this->mime_ext . rand(),
	    	));
            $T->parse('mp3_podcast','mp3_podcast');
    	} else {
	    	$T->set_var(array(
	    		'mp3_podcast' => '',
	    	));
    	}


        $T->set_var(array(
            'row_height'        =>  $tn_height + 40,
            'media_title'       =>  PLG_replaceTags($this->title),
            'media_description' =>  PLG_replaceTags($this->description),
            'media_tag'         =>  strip_tags($this->title),
            'media_time'        =>  $media_time[0],
            'media_owner'		=>  $username,
            'site_url'			=> $_MG_CONF['site_url'],
            'lang_published'	=> $LANG_MG03['published'],
            'lang_on'			=> $LANG_MG03['on'],
        ));

        // frame template variables
        $F->set_var(array(
            'media_link_start'  => '<a href="' . $url_media_item . '">',
            'media_link_end'    => '</a>',
            'url_media_item'    =>  $url_media_item,
            'url_display_item'  =>  $url_display_item,
            'media_thumbnail'   =>  $media_thumbnail,
            'media_size'        =>  'width="' . $newwidth . '" height="' . $newheight . '"',
            'media_height'      =>  $newheight,
            'media_width'       =>  $newwidth,
            'border_width'      =>  $newwidth + 15,
            'border_height'     =>  $newheight + 15,
            'row_height'        =>  $tn_height + 40,
            'frWidth'           =>  $newwidth  - $MG_albums[$this->album_id]->frWidth,
            'frHeight'          =>  $newheight - $MG_albums[$this->album_id]->frHeight,
            'media_tag'         =>  strip_tags($this->description),

        ));
        $F->parse('media','media_frame');
        $media_item_thumbnail = $F->finish($F->get_var('media'));

        $T->set_var(array(
            'media_item_thumbnail' => $media_item_thumbnail,
        ));

        if ( $MG_albums[$this->album_id]->enable_keywords) {
            if ( !empty($this->keywords ) ) {
                $T->set_var(array(
                    'media_keywords'  =>  $this->keywords,
                    'lang_keywords'   =>  $LANG_MG01['keywords'],
                ));
                $T->parse('media_cell_keywords','media_cell_keywords');
            } else {
                $T->set_var('lang_keywords','');
            }
        } else {
            $T->set_var(array(
                'media_cell_keywords'   => ''
            ));
        }

        if ( $MG_albums[$this->album_id]->enable_rating) {
            if ( $this->type == 4 || ($this->type == 1 && $MG_albums[$this->album_id]->playback_type != 2) || ($this->type == 2 && $MG_albums[$this->album_id]->playback_type != 2)  || ($this->type == 5 && $MG_albums[$this->album_id]->playback_type != 2)) {
                $rateLink = '<a href="' . $_MG_CONF['site_url'] . '/media.php?f=0' . '&amp;sort=' . $sortOrder . '&amp;s=' . $this->id . '">' . $LANG_MG03['rating'] . '</a>';
            } else {
                $rateLink = $LANG_MG03['rating'];
            }
            $T->set_var(array(
                'media_rating'  =>  $this->rating,
                'media_votes'   =>  $this->votes,
                'lang_rating'   =>  $rateLink,
                'lang_votes'    =>  $LANG_MG03['votes'],
            ));
            $T->parse('media_rate_results','media_rate_results');
        }
        if ( $MG_albums[$this->album_id]->enable_comments) {
            if ( $this->type == 4 || ($this->type == 1 && $MG_albums[$this->album_id]->playback_type != 2) || ($this->type == 2 && $MG_albums[$this->album_id]->playback_type != 2) || ($this->type == 5 && $MG_albums[$this->album_id]->playback_type != 2)) {
                $cmtLink  = '<a href="' . $_MG_CONF['site_url'] . '/media.php?f=0' . '&amp;sort=' . $sortOrder . '&amp;s=' . $this->id . '">' . $LANG_MG03['comments'] . '</a>';
            }  else {
                $cmtLink = $LANG_MG03['comments'];
            }
            $T->set_var(array(
                'media_comments_count'  =>  $this->comments,
                'lang_comments'         =>  $cmtLink
            ));
            $T->parse('media_comments','media_comments');
        }
        if ( $MG_albums[$this->album_id]->enable_views ) {
            $T->set_var(array(
                'media_views_count'     =>  $this->views,
                'lang_views'            =>  $LANG_MG03['views']
            ));
            $T->parse('media_views','media_views');
        }

        $T->parse('media_cell','media_cell_image');
        $retval = $T->finish($T->get_var('media_cell'));
        return $retval;
    }

    function displayRawThumb( $namesOnly=0 ) {
        global $_CONF, $_MG_CONF, $MG_albums, $_MG_USERPREFS, $LANG_MG03;

        switch( $this->type ) {
            case 0 :    // standard image
                $default_thumbnail = 'tn/' . $this->filename[0] . '/' . $this->filename . '.jpg';
                break;
            case 1 :    // video file
                switch ( $this->mime_type ) {
                    case 'video/x-flv' :
                        $default_thumbnail = 'flv.png';
                        break;
                    case 'application/x-shockwave-flash' :
                        $default_thumbnail = 'flash.gif';
                        break;
                        break;
                    case 'video/mpeg' :
                    case 'video/x-motion-jpeg' :
                    case 'video/quicktime' :
                    case 'video/mpeg' :
                    case 'video/x-mpeg' :
                    case 'video/x-mpeq2a' :
                    case 'video/x-qtc' :
                        $default_thumbnail = 'quicktime.gif';
                        break;
                    case 'video/x-ms-asf' :
                    case 'video/x-ms-asf-plugin' :
                    case 'video/avi' :
                    case 'video/msvideo' :
                    case 'video/x-msvideo' :
                    case 'video/avs-video' :
                    case 'video/x-ms-wmv' :
                    case 'video/x-ms-wvx' :
                    case 'video/x-ms-wm' :
                    case 'application/x-troff-msvideo' :
                    case 'application/x-ms-wmz' :
                    case 'application/x-ms-wmd' :
                        $default_thumbnail = 'wmp.gif';
                        break;
                    default :
                        $default_thumbnail = 'video.gif';
                        break;
                }
                break;
            case 2 :    // music file
                $default_thumbnail = 'audio.gif';
                break;
            case 4 :    // other files
                switch ($this->mime_type ) {
                    case 'application/zip' :
                    case 'application/x-gzip' :
                    case 'application/x-tar' :
                    case 'arj' :
                    case 'rar' :
                    case 'gz'  :
                        $default_thumbnail = 'zip.gif';
                        break;
                    case 'application/pdf' :
                    case 'pdf' :
                        $default_thumbnail = 'pdf.gif';
                        break;
                    case 'application/octet-stream' :
                        if ( $this->mime_ext == 'pdf' ) {
                            $default_thumbnail = 'pdf.gif';
                        } else if ( $this->mime_ext == 'arj' ) {
                            $default_thumbnail = 'zip.gif';
                        } else if ( $this->mime_ext == 'rar' ) {
                            $default_thumbnail = 'zip.gif';
                        } else {
                            $default_thumbnail = 'generic.gif';
                        }
                        break;
                    default :
                        $default_thumbnail = 'generic.gif';
                        break;
                }
                break;
			case 5 :
	            $default_thumbnail = 'remote.png';
	            break;

        }

        if ( $this->tn_attached == 1 ) {
            $media_thumbnail      = $_MG_CONF['site_url']  . '/mediaobjects/tn/'.  $this->filename[0] . '/tn_' . $this->filename . '.jpg';
            $media_thumbnail_file = $_MG_CONF['path_html'] . 'mediaobjects/tn/'.  $this->filename[0] . '/tn_' . $this->filename . '.jpg';
        } else {
            $media_thumbnail      = $_MG_CONF['site_url']  . '/mediaobjects/' . $default_thumbnail;
            $media_thumbnail_file = $_MG_CONF['path_html'] . 'mediaobjects/' . $default_thumbnail;
        }

        $media_size        = @getimagesize($media_thumbnail_file);

        if ( $media_size == false ) {
            $default_thumbnail    = 'generic.gif';
            $media_thumbnail      = $_MG_CONF['site_url']  . '/mediaobjects/' . $default_thumbnail;
            $media_thumbnail_file = $_MG_CONF['path_html'] . 'mediaobjects/' . $default_thumbnail;
            $media_size           = @getimagesize($media_thumbnail_file);
        }

        if ( $namesOnly == 1 ) {
            return (array($media_thumbnail,$media_thumbnail_file));
        }

        $tn_height = 100;
        if ( $media_size[0] > $media_size[1] ) {
            $ratio = $media_size[0] / $tn_height;
            $newwidth = $tn_height;
            $newheight = round($media_size[1] / $ratio);
        } else {
            $ratio = $media_size[1] / $tn_height;
            $newheight = $tn_height;
            $newwidth = round($media_size[0] / $ratio);
        }
        $media_dim = 'width="' . $newwidth . '" height="' . $newheight . '"';
        return '<img src="' .$media_thumbnail . '" ' . $media_dim . ' border="0" alt="' . strip_tags($this->title) . '" title="' . strip_tags($this->title) . '"/>';
    }
}
?>