<?php
// +---------------------------------------------------------------------------+
// | Media Gallery Plugin 1.5                                                  |
// +---------------------------------------------------------------------------+
// | $Id:: lib-media.php 1057 2007-06-21 23:46:58Z mevans0263                 $|
// +---------------------------------------------------------------------------+
// | Copyright (C) 2006 by the following authors:                              |
// |                                                                           |
// | Author:                                                                   |
// | Mark R. Evans              -   mevans@ecsnet.com                          |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

// this file can't be used on its own
if (!defined ('VERSION')) {
    die ('This file can not be used on its own.');
}

require_once($_MG_CONF['path_html'] . 'classFrame.php');


function MG_displayASF( $aid, $I, $full ) {
    global $_TABLES, $_CONF, $_MG_CONF, $_MG_USERPREFS, $MG_albums;

    $retval = '';

    // set the default playback options...

    $playback_options['autostart']          = $_MG_CONF['asf_autostart'];
    $playback_options['enablecontextmenu']  = $_MG_CONF['asf_enablecontextmenu'];
    $playback_options['stretchtofit']       = $_MG_CONF['asf_stretchtofit'];
    $playback_options['showstatusbar']      = $_MG_CONF['asf_showstatusbar'];
    $playback_options['uimode']             = $_MG_CONF['asf_uimode'];
    $playback_options['height']             = $_MG_CONF['asf_height'];
    $playback_options['width']              = $_MG_CONF['asf_width'];
    $playback_options['bgcolor']            = $_MG_CONF['asf_bgcolor'];
    $playback_options['playcount']          = $_MG_CONF['asf_playcount'];

    $poResult = DB_query("SELECT * FROM {$_TABLES['mg_playback_options']} WHERE media_id='" . $I['media_id'] . "'");
    while ($poRow = DB_fetchArray($poResult)) {
        $playback_options[$poRow['option_name']] = $poRow['option_value'];
    }

    if (isset($_MG_USERPREFS['playback_mode']) && $_MG_USERPREFS['playback_mode'] != -1 ) {
        $playback_type = $_MG_USERPREFS['playback_mode'];
    } else {
        $playback_type = $MG_albums[$aid]->playback_type;
    }
    if ( $I['resolution_x'] > 0 ) {
        $resolution_x = $I['resolution_x'];
        $resolution_y = $I['resolution_y'];
    } else {
        if ( $I['media_resolution_x'] == 0 ) {
            require_once($_MG_CONF['path_html'] . '/getid3/getid3/getid3.php');
            // Needed for windows only
            define('GETID3_HELPERAPPSDIR', 'C:/helperapps/');

            $getID3 = new getID3;
            // Analyze file and store returned data in $ThisFileInfo
            $ThisFileInfo = $getID3->analyze($_MG_CONF['path_html'] . '/mediaobjects/orig/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.' . $I['media_mime_ext']);
            getid3_lib::CopyTagsToComments($ThisFileInfo);
            if ( $ThisFileInfo['video']['resolution_x'] < 1 || $ThisFileInfo['video']['resolution_y'] < 1 ) {
                if (isset($ThisFileInfo['meta']['onMetaData']['width']) && isset($ThisFileInfo['meta']['onMetaData']['height']) ) {
                    $resolution_x = $ThisFileInfo['meta']['onMetaData']['width'];
                    $resolution_y = $ThisFileInfo['meta']['onMetaData']['height'];
                } else {
                    $resolution_x = -1;
                    $resolution_y = -1;
                }
            } else {
                $resolution_x = $ThisFileInfo['video']['resolution_x'];
                $resolution_y = $ThisFileInfo['video']['resolution_y'];
            }
            if ( $resolution_x != 0 ) {
                $sql = "UPDATE " . $_TABLES['mg_media'] . " SET media_resolution_x=" . $resolution_x . ",media_resolution_y=" . $resolution_y . " WHERE media_id='" . $I['media_id'] . "'";
                DB_query( $sql );
            }
        } else {
            $resolution_x = $I['media_resolution_x'];
            $resolution_y = $I['media_resolution_y'];
        }
    }
    switch ($playback_type) {
        case 0 :                    // Popup Window
            $win_width = $playback_options['width'] + 40;
            $win_height = $playback_options['height'] + 40;
            $u_pic = "javascript:showVideo('" . $_MG_CONF['site_url'] . "/video.php?n=" . $I['media_id'] . "'," . $win_height . "," . $win_width . ")";

            if ( $I['media_tn_attached'] == 1 ) {
                $u_image = $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg');
            } else {
                $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/wmp.gif';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/wmp.gif');
            }
            break;
        case 1: // download
            $u_pic = $_MG_CONF['site_url'] . '/download.php?mid=' . $I['media_id'];
            if ( $I['media_tn_attached'] == 1 ) {
                $u_image = $_MG_CONF['site_url'] . 'mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg');
            } else {
                $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/wmp.gif';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/wmp.gif');
            }
            break;
        case 2 :    // inline
            $V = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
            $V->set_file (array ('video' => 'view_asf.thtml'));
            $V->set_var(array(
                'autostart'         => ($playback_options['autostart'] ? 'true' : 'false'),
                'enablecontextmenu' => ($playback_options['enablecontextmenu'] ? 'true' : 'false'),
                'stretchtofit'      => ($playback_options['stretchtofit'] ? 'true' : 'false'),
                'showstatusbar'     => ($playback_options['showstatusbar'] ? 'true' : 'false'),
                'uimode'            => $playback_options['uimode'],
                'playcount'         => $playback_options['playcount'],
                'height'            => $playback_options['height'] + 45,
                'width'             => $playback_options['width'],
                'bgcolor'           => $playback_options['bgcolor'],
                'movie'             => $_MG_CONF['site_url'] . '/mediaobjects/orig/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.' . $I['media_mime_ext'],
                'autostart0'         => ($playback_options['autostart'] ? '1' : '0'),
                'enablecontextmenu0' => ($playback_options['enablecontextmenu'] ? '1' : '0'),
                'stretchtofit0'      => ($playback_options['stretchtofit'] ? '1' : '0'),
                'showstatusbar0'     => ($playback_options['showstatusbar'] ? '1' : '0'),
            ));
            switch ($playback_options['uimode'] ) {
                case 'mini' :
                case 'full' :
                    $V->set_var(array(
                        'showcontrols'         => 'true',
                        'showcontrols0'         => '1',
                    ));
                    break;
                case 'none' :
                    $V->set_var(array(
                        'showcontrols'         => 'false',
                        'showcontrols0'        => '0',
                    ));
                    break;
            }
            $V->parse('output','video');
            $u_image = $V->finish($V->get_var('output'));
            return $u_image;
            break;
        case 3: // use mms links
            $mms_path = ereg_replace('http','mms',$_MG_CONF['site_url']);
            $u_pic = $mms_path . '/mediaobjects/orig/'.  $I['media_filename'][0] . '/' . $I['media_filename'] . '.' . $I['media_mime_ext'];

            if ( $I['media_tn_attached'] == 1 ) {
                $u_image = $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
                $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg');
            } else {
                $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/video.gif';
                $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/video.gif');
            }
            break;
    }

    $imageWidth  = $media_size_disp[0];
    $imageHeight = $media_size_disp[1];

    //frame
    $F = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $F->set_var('media_frame',$MG_albums[$aid]->displayFrameTemplate);
    $F->set_var(array(
        'media_link_start'  => '<a href="' . $u_pic . '">',
        'media_link_end'    => '</a>',
        'url_media_item'    =>  $u_pic,
        'media_thumbnail'   =>  $u_image,
        'media_size'        =>  'width="' . $imageWidth . '" height="' . $imageHeight . '"',
        'media_height'      =>  $imageHeight,
        'media_width'       =>  $imageWidth,
        'border_width'      =>  $imageWidth + 15,
        'border_height'     =>  $imageHeight + 15,
        'media_title'       =>  PLG_replaceTags($I['media_title']),
        'media_tag'         =>  strip_tags($I['media_title']),
        'frWidth'           =>  $imageWidth  - $MG_albums[$aid]->dfrWidth,
        'frHeight'          =>  $imageHeight - $MG_albums[$aid]->dfrHeight,
    ));
    $F->parse('media','media_frame');
    $retval .= $F->finish($F->get_var('media'));
    return $retval;
}

function MG_displayMOV( $aid, $I, $full ) {
    global $_TABLES, $_CONF, $_MG_CONF, $_MG_USERPREFS, $MG_albums, $LANG_MG03;

    $retval = '';

    // set the default playback options...
    $playback_options['autoref']        = $_MG_CONF['mov_autoref'];
    $playback_options['autoplay']       = $_MG_CONF['mov_autoplay'];
    $playback_options['controller']     = $_MG_CONF['mov_controller'];
    $playback_options['kioskmode']      = $_MG_CONF['mov_kioskmode'];
    $playback_options['scale']          = $_MG_CONF['mov_scale'];
    $playback_options['loop']           = $_MG_CONF['move_loop'];
    $playback_options['height']         = $_MG_CONF['mov_height'];
    $playback_options['width']          = $_MG_CONF['mov_width'];
    $playback_options['bgcolor']        = $_MG_CONF['mov_bgcolor'];

    $poResult = DB_query("SELECT * FROM {$_TABLES['mg_playback_options']} WHERE media_id='" . $I['media_id'] . "'");
    while ( $poRow = DB_fetchArray($poResult) ) {
        $playback_options[$poRow['option_name']] = $poRow['option_value'];
    }
    if (isset($_MG_USERPREFS['playback_mode']) && $_MG_USERPREFS['playback_mode'] != -1 ) {
        $playback_type = $_MG_USERPREFS['playback_mode'];
    } else {
        $playback_type = $MG_albums[$aid]->playback_type;
    }

    if ( $I['resolution_x'] > 0 ) {
        $resolution_x = $I['resolution_x'];
        $resolution_y = $I['resolution_y'];
    } else {
        if ( $I['media_resolution_x'] == 0 ) {
            require_once($_MG_CONF['path_html'] . '/getid3/getid3/getid3.php');
            // Needed for windows only
            define('GETID3_HELPERAPPSDIR', 'C:/helperapps/');

            $getID3 = new getID3;
            // Analyze file and store returned data in $ThisFileInfo
            $ThisFileInfo = $getID3->analyze($_MG_CONF['path_html'] . '/mediaobjects/orig/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.' . $I['media_mime_ext']);
            getid3_lib::CopyTagsToComments($ThisFileInfo);
            if ( $ThisFileInfo['video']['resolution_x'] < 1 || $ThisFileInfo['video']['resolution_y'] < 1 ) {
                if (isset($ThisFileInfo['meta']['onMetaData']['width']) && isset($ThisFileInfo['meta']['onMetaData']['height']) ) {
                    $resolution_x = $ThisFileInfo['meta']['onMetaData']['width'];
                    $resolution_y = $ThisFileInfo['meta']['onMetaData']['height'];
                } else {
                    $resolution_x = -1;
                    $resolution_y = -1;
                }
            } else {
                $resolution_x = $ThisFileInfo['video']['resolution_x'];
                $resolution_y = $ThisFileInfo['video']['resolution_y'];
            }
            if ( $resolution_x != 0 ) {
                $sql = "UPDATE " . $_TABLES['mg_media'] . " SET media_resolution_x=" . $resolution_x . ",media_resolution_y=" . $resolution_y . " WHERE media_id='" . $I['media_id'] . "'";
                DB_query( $sql );
            }
        } else {
            $resolution_x = $I['media_resolution_x'];
            $resolution_y = $I['media_resolution_y'];
        }
    }

    switch ($playback_type) {
        case 0 :                    // Popup Window
            $win_width = $playback_options['width'] + 40;
            $win_height = $playback_options['height'] + 40;
            $u_pic = "javascript:showVideo('" . $_MG_CONF['site_url'] . "/video.php?n=" . $I['media_id'] . "'," . $win_height . "," . $win_width . ")";
            if ( $I['media_tn_attached'] == 1 ) {
                $u_image = $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg');
            } else {
                $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/quicktime.gif';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/quicktime.gif');
            }
            break;
        case 1: // download
        case 3: // use mms links
            $u_pic = $_MG_CONF['site_url'] . '/download.php?mid=' . $I['media_id'];
            if ( $I['media_tn_attached'] == 1 ) {
                $u_image = $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
                $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg');
            } else {
                $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/quicktime.gif';
                $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/quicktime.gif');
            }
            break;
        case 2 :    // inline
            $V = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
            $V->set_file (array ('video' => 'view_quicktime.thtml'));
            $V->set_var(array(
                'site_url'      => $_MG_CONF['site_url'],
                'autoref'       => ($playback_options['autoref'] ? 'true' : 'false'),
                'autoplay'      => ($playback_options['autoplay'] ? 'true' : 'false'),
                'controller'    => ($playback_options['controller'] ? 'true' : 'false'),
                'kioskmode'     => ($playback_options['kioskmode'] ? 'true' : 'false'),
                'loop'          => ($playback_options['loop'] ? 'true' : 'false'),
                'scale'         => $playback_options['scale'],
                'height'        => $playback_options['height'] + ($playback_options['controller'] ? 20 : 0),
                'width'         => $playback_options['width'],
                'bgcolor'       => $playback_options['bgcolor'],
                'movie'         => $_MG_CONF['site_url'] . '/mediaobjects/orig/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.' . $I['media_mime_ext'],
                'filename'      => $I['media_original_filename'],
                'lang_noquicktime' => $LANG_MG03['no_quicktime'],
            ));
            $V->parse('output','video');
            $u_image = $V->finish($V->get_var('output'));
            return $u_image;
            break;
    }

    $imageWidth  = $media_size_disp[0];
    $imageHeight = $media_size_disp[1];

    //frame
    $F = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $F->set_var('media_frame',$MG_albums[$aid]->displayFrameTemplate);
    $F->set_var(array(
        'media_link_start'  =>  '<a href="' . $u_pic . '">',
        'media_link_end'    =>  '</a>',
        'url_media_item'    =>  $u_pic,
        'media_thumbnail'   =>  $u_image,
        'media_size'        =>  'width="' . $imageWidth . '" height="' . $imageHeight . '"',
        'media_height'      =>  $imageHeight,
        'media_width'       =>  $imageWidth,
        'border_width'      =>  $imageWidth + 15,
        'border_height'     =>  $imageHeight + 15,
        'media_title'       =>  PLG_replaceTags($I['media_title']),
        'media_tag'         =>  strip_tags($I['media_title']),
        'frWidth'           =>  $imageWidth  - $MG_albums[$aid]->dfrWidth,
        'frHeight'          =>  $imageHeight - $MG_albums[$aid]->dfrHeight,
    ));
    $F->parse('media','media_frame');
    $retval .= $F->finish($F->get_var('media'));
    return $retval;
}

function MG_displaySWF( $aid, $I, $full ) {
    global $_TABLES, $_CONF, $_MG_CONF, $_MG_USERPREFS, $MG_albums, $LANG_MG03;

    $retval = '';

    // set the default playback options...
    $playback_options['play']    = $_MG_CONF['swf_play'];
    $playback_options['menu']    = $_MG_CONF['swf_menu'];
    $playback_options['quality'] = $_MG_CONF['swf_quality'];
    $playback_options['height']  = $_MG_CONF['swf_height'];
    $playback_options['width']   = $_MG_CONF['swf_width'];
    $playback_options['loop']    = $_MG_CONF['swf_loop'];
    $playback_options['scale']   = $_MG_CONF['swf_scale'];
    $playback_options['wmode']   = $_MG_CONF['swf_wmode'];
    $playback_options['allowscriptaccess'] = $_MG_CONF['swf_allowscriptaccess'];
    $playback_options['bgcolor']    = $_MG_CONF['swf_bgcolor'];
    $playback_options['swf_version'] = $_MG_CONF['swf_version'];
    $playback_options['flashvars']   = $_MG_CONF['swf_flashvars'];

    $poResult = DB_query("SELECT * FROM {$_TABLES['mg_playback_options']} WHERE media_id='" . $I['media_id'] . "'");
    while ( $poRow = DB_fetchArray($poResult) ) {
        $playback_options[$poRow['option_name']] = $poRow['option_value'];
    }
    if (isset($_MG_USERPREFS['playback_mode']) && $_MG_USERPREFS['playback_mode'] != -1 ) {
        $playback_type = $_MG_USERPREFS['playback_mode'];
    } else {
        $playback_type = $MG_albums[$aid]->playback_type;
    }
    if ( $I['resolution_x'] > 0 ) {
        $resolution_x = $I['resolution_x'];
        $resolution_y = $I['resolution_y'];
    } else {
        if ( $I['media_resolution_x'] == 0 ) {
            require_once($_MG_CONF['path_html'] . '/getid3/getid3/getid3.php');
            // Needed for windows only
            define('GETID3_HELPERAPPSDIR', 'C:/helperapps/');

            $getID3 = new getID3;
            // Analyze file and store returned data in $ThisFileInfo
            $ThisFileInfo = $getID3->analyze($_MG_CONF['path_html'] . '/mediaobjects/orig/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.' . $I['media_mime_ext']);
            getid3_lib::CopyTagsToComments($ThisFileInfo);
            if ( $ThisFileInfo['video']['resolution_x'] < 1 || $ThisFileInfo['video']['resolution_y'] < 1 ) {
                if (isset($ThisFileInfo['meta']['onMetaData']['width']) && isset($ThisFileInfo['meta']['onMetaData']['height']) ) {
                    $resolution_x = $ThisFileInfo['meta']['onMetaData']['width'];
                    $resolution_y = $ThisFileInfo['meta']['onMetaData']['height'];
                } else {
                    $resolution_x = -1;
                    $resolution_y = -1;
                }
            } else {
                $resolution_x = $ThisFileInfo['video']['resolution_x'];
                $resolution_y = $ThisFileInfo['video']['resolution_y'];
            }
            if ( $resolution_x != 0 ) {
                $sql = "UPDATE " . $_TABLES['mg_media'] . " SET media_resolution_x=" . $resolution_x . ",media_resolution_y=" . $resolution_y . " WHERE media_id='" . $I['media_id'] . "'";
                DB_query( $sql );
            }
        } else {
            $resolution_x = $I['media_resolution_x'];
            $resolution_y = $I['media_resolution_y'];
        }
    }
    switch ($playback_type) {
        case 0 :                    // Popup Window
            $win_width  = $playback_options['width'] + 40;
            $win_height = $playback_options['height'] + 40;
            $u_pic = "javascript:showVideo('" . $_MG_CONF['site_url'] . "/video.php?n=" . $I['media_id'] . "'," . $win_height . "," . $win_width . ")";
            if ( $I['media_tn_attached'] == 1 ) {
                $u_image = $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg');
            } else {
                $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/flash.gif';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/flash.gif');
            }
            break;
        case 1: // download
        case 3: // mms - not supported for flash
            $u_pic = $_MG_CONF['site_url'] . '/download.php?mid=' . $I['media_id'];

            if ( $I['media_tn_attached'] == 1 ) {
                $u_image = $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
                $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg');
            } else {
                $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/flash.gif';
                $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/flash.gif');
            }
            break;
        case 2 :    // inline
            $S = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
            $S->set_file(array('swf' => 'swfobject.thtml'));
            $S->set_var(array(
                'site_url'  => $_MG_CONF['site_url'],
            ));
            $S->parse('output','swf');
            $u_image = $S->finish($S->get_var('output'));

            $V = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
            $V->set_file (array ('video' => 'view_swf.thtml'));
            $V->set_var(array(
                'site_url'  => $_MG_CONF['site_url'],
                'lang_noflash' => $LANG_MG03['no_flash'],
                'play'      => ($playback_options['play'] ? 'true' : 'false'),
                'menu'      => ($playback_options['menu'] ? 'true' : 'false'),
                'loop'      => ($playback_options['loop'] ? 'true' : 'false'),
                'scale'     => $playback_options['scale'],
                'wmode'     => $playback_options['wmode'],
                'flashvars' => $playback_options['flashvars'],
                'quality'   => $playback_options['quality'],
                'height'    => $playback_options['height'],
                'width'     => $playback_options['width'],
                'asa'       => $playback_options['allowscriptaccess'],
                'bgcolor'   => $playback_options['bgcolor'],
                'swf_version' => $playback_options['swf_version'],
                'filename'  => $I['media_original_filename'],
                'id'        => $I['media_filename'] . rand(),
                'id2'       => $I['media_filename'] . rand(),
                'movie'     => $_MG_CONF['site_url'] . '/mediaobjects/orig/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.' . $I['media_mime_ext'],
            ));

            $V->set_block('video', 'flashvar','fvar');
            $flasharray = array();
            $flasharray = explode('&',$playback_options['flashvars']);

            foreach( $flasharray as $var ) {
                $temp = split("=",$var);
                $variable = $temp[0];
                $value = implode("=",array_slice($temp,1));
                $V->set_var(array(
                    'flashvar'      => 'so.addVariable("' . $variable . '","' . $value . '");' . LB,
                ));
                $V->parse('fvar','flashvar',true);
            }
            $V->parse('output','video');
            $u_image .= $V->finish($V->get_var('output'));
            return $u_image;
            break;
    }

    $imageWidth  = $media_size_disp[0];
    $imageHeight = $media_size_disp[1];

    //frame
    $F = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $F->set_var('media_frame',$MG_albums[$aid]->displayFrameTemplate);
    $F->set_var(array(
        'media_link_start'  =>  '<a href="' . $u_pic . '">',
        'media_link_end'    =>  '</a>',

        'url_media_item'    =>  $u_pic,
        'media_thumbnail'   =>  $u_image,
        'media_size'        =>  'width="' . $imageWidth . '" height="' . $imageHeight . '"',
        'media_height'      =>  $imageHeight,
        'media_width'       =>  $imageWidth,
        'border_width'      =>  $imageWidth + 15,
        'border_height'     =>  $imageHeight + 15,
        'media_title'       =>  PLG_replaceTags($I['media_title']),
        'media_tag'         =>  strip_tags($I['media_title']),
        'frWidth'           =>  $imageWidth  - $MG_albums[$aid]->dfrWidth,
        'frHeight'          =>  $imageHeight - $MG_albums[$aid]->dfrHeight,
    ));
    $F->parse('media','media_frame');
    $retval .= $F->finish($F->get_var('media'));
    return $retval;
}


function MG_displayFLV ( $aid, $I, $full ) {
    global $_TABLES, $_CONF, $_MG_CONF, $_MG_USERPREFS, $MG_albums, $LANG_MG03;

    $retval = '';

    // set the default playback options...
    $playback_options['play']    = $_MG_CONF['swf_play'];
    $playback_options['menu']    = $_MG_CONF['swf_menu'];
    $playback_options['quality'] = $_MG_CONF['swf_quality'];
    $playback_options['height']  = $_MG_CONF['swf_height'];
    $playback_options['width']   = $_MG_CONF['swf_width'];
    $playback_options['loop']    = $_MG_CONF['swf_loop'];
    $playback_options['scale']   = $_MG_CONF['swf_scale'];
    $playback_options['wmode']   = $_MG_CONF['swf_wmode'];
    $playback_options['allowscriptaccess'] = $_MG_CONF['swf_allowscriptaccess'];
    $playback_options['bgcolor']    = $_MG_CONF['swf_bgcolor'];
    $playback_options['swf_version'] = $_MG_CONF['swf_version'];
    $playback_options['flashvars']   = $_MG_CONF['swf_flashvars'];

    $poResult = DB_query("SELECT * FROM {$_TABLES['mg_playback_options']} WHERE media_id='" . $I['media_id'] . "'");
    while ( $poRow = DB_fetchArray($poResult) ) {
        $playback_options[$poRow['option_name']] = $poRow['option_value'];
    }
    if (isset($_MG_USERPREFS['playback_mode']) && $_MG_USERPREFS['playback_mode'] != -1 ) {
        $playback_type = $_MG_USERPREFS['playback_mode'];
    } else {
        $playback_type = $MG_albums[$aid]->playback_type;
    }

    if ( $I['resolution_x'] > 0 ) {
        $resolution_x = $I['resolution_x'];
        $resolution_y = $I['resolution_y'];
    } else {
        if ( $I['media_resolution_x'] == 0 && $I['remote_media'] == 0 ) {
            require_once($_MG_CONF['path_html'] . '/getid3/getid3/getid3.php');
            // Needed for windows only
            define('GETID3_HELPERAPPSDIR', 'C:/helperapps/');

            $getID3 = new getID3;
            // Analyze file and store returned data in $ThisFileInfo
            $ThisFileInfo = $getID3->analyze($_MG_CONF['path_html'] . '/mediaobjects/orig/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.' . $I['media_mime_ext']);
            getid3_lib::CopyTagsToComments($ThisFileInfo);
            if ( $ThisFileInfo['video']['resolution_x'] < 1 || $ThisFileInfo['video']['resolution_y'] < 1 ) {
                if (isset($ThisFileInfo['meta']['onMetaData']['width']) && isset($ThisFileInfo['meta']['onMetaData']['height']) ) {
                    $resolution_x = $ThisFileInfo['meta']['onMetaData']['width'];
                    $resolution_y = $ThisFileInfo['meta']['onMetaData']['height'];
                } else {
                    $resolution_x = -1;
                    $resolution_y = -1;
                }
            } else {
                $resolution_x = $ThisFileInfo['video']['resolution_x'];
                $resolution_y = $ThisFileInfo['video']['resolution_y'];
            }
            if ( $resolution_x != 0 ) {
                $sql = "UPDATE " . $_TABLES['mg_media'] . " SET media_resolution_x=" . $resolution_x . ",media_resolution_y=" . $resolution_y . " WHERE media_id='" . $I['media_id'] . "'";
                DB_query( $sql );
            }
        } else {
            $resolution_x = 320; //$I['media_resolution_x'];
            $resolution_y = 240; //$I['media_resolution_y'];
        }
    }

    switch ($playback_type) {
        case 0 :                    // Popup Window
            $win_width  = $playback_options['width'] + 40;
            $win_height = $playback_options['height'] + 40;
            $u_pic = "javascript:showVideo('" . $_MG_CONF['site_url'] . "/video.php?n=" . $I['media_id'] . "'," . $win_height . "," . $win_width . ")";
            if ( $I['media_tn_attached'] == 1 ) {
                $u_image = $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg');
            } else {
                $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/flv.png';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/flv.png');
            }
            break;
        case 1: // download
        case 3: // mms - not supported for flash
            $u_pic = $_MG_CONF['site_url'] . '/download.php?mid=' . $I['media_id'];

            if ( $I['media_tn_attached'] == 1 ) {
                $u_image = $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
                $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg');
            } else {
                $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/flv.png';
                $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/flv.png');
            }
            break;
        case 2 :    // inline
            $flashvars = '';
            $S = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
            $S->set_file(array('swf' => 'swfobject.thtml'));
            $S->set_var(array(
                'site_url'  => $_MG_CONF['site_url'],
            ));
            $S->parse('output','swf');
            $u_image = $S->finish($S->get_var('output'));

            if ( $playback_options['play'] == 1 ) {
                $splash = '';
            } else {
                $splash = 'splashImageFile: \'' . $_MG_CONF['site_url'] . '/';
                if ( $I['media_tn_attached'] == 1 ) {
                    $flashvars .= '&thumbUrl=' . $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
                }
            }
            $flashvars .= '&Width=' . $playback_options['width'];
            $flashvars .= '&Height=' . $playback_options['height'];

            if ($MG_albums[$aid]->allow_download == 1 ) {
                $flashvars .= '&allowDl=true';
            } else {
                $flashvars .= '&allowDl=false';
            }
            if ( $I['media_title'] != '' ) {
                $flashvars .= '&title=' . urlencode($I['media_title']);
            } else {
                $flashvars .= '&title=' . urlencode($I['media_original_filename']);
            }
            if ( $playback_options['play'] ) {
                $flashvars .= '&autoplay=true';
            } else {
                $flashvars .= '&autoplay=false';
            }
            if ( $I['remote_media'] == 0 ) {
	            $movie = urlencode($_MG_CONF['site_url'] . '/mediaobjects/orig/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.' . $I['media_mime_ext']);
            } else {
	            $movie = $I['remote_url'];
	            $I['media_original_filename'] = $movie;
            }

            $V = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
            if ( $I['remote_media'] == 1 ) {
	            $V->set_file(array('video' => 'view_flv_stream.thtml'));
            } else {
            	$V->set_file (array ('video' => 'view_flv.thtml'));
        	}
            $V->set_var(array(
                'site_url'  => $_MG_CONF['site_url'],
                'lang_noflash' => $LANG_MG03['no_flash'],
                'play'      => ($playback_options['play'] ? 'true' : 'false'),
                'menu'      => ($playback_options['menu'] ? 'true' : 'false'),
                'loop'      => ($playback_options['loop'] ? 'true' : 'false'),
                'scale'     => $playback_options['scale'],
                'wmode'     => $playback_options['wmode'],
                'flashvars' => $flashvars,
                'quality'   => $playback_options['quality'],
                'height'    => $playback_options['height'],
                'width'     => $playback_options['width'],
                'asa'       => $playback_options['allowscriptaccess'],
                'bgcolor'       => $playback_options['bgcolor'],
                'swf_version'   => '9', // $playback_options['swf_version'],
                'filename'      => $I['media_original_filename'],
                'id'            => $I['media_filename'] . rand(),
                'id2'           => $I['media_filename'] . rand(),
                'resolution_x'  => $resolution_x,
                'resolution_y'  => $resolution_y,
                'splash'        => $splash,
                'movie'         => $movie, // urlencode($_MG_CONF['site_url'] . '/mediaobjects/orig/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.' . $I['media_mime_ext']),
                'lang_download' => $LANG_MG03['download'],
                'lang_large'    => $LANG_MG03['large'],
                'lang_normal'   => $LANG_MG03['normal'],
            ));

            if ( $I['remote_media'] == 1 ) {
	            $urlParts = array();
	            $urlParts = parse_url($I['remote_url']);

	            $pathParts = array();
	            $pathParts = explode('/',$urlParts['path']);

	            $ppCount = count($pathParts);
	            $pPath = '';
	            for ($i=1; $i<$ppCount-1;$i++) {
		            $pPath .= '/' . $pathParts[$i];
	            }
	            $videoFile = $pathParts[$ppCount-1];

		        $pos = strrpos($videoFile, '.');
		        if($pos === false) {
		            $basefilename = $videoFile;
		        } else {
		            $basefilename = substr($videoFile,0,$pos);
		        }

	           	$streamingServerURL = $urlParts['scheme'] . '://' . $urlParts['host'] . $pPath;
	           	$V->set_var(array(
	           		'streamingServerURL'	=> $streamingServerURL,
	           		'videoFile'				=> $basefilename,
	           	));
    		}

            $V->parse('output','video');
            $u_image .= $V->finish($V->get_var('output'));
            return $u_image;
            break;
    }

    $imageWidth  = $media_size_disp[0];
    $imageHeight = $media_size_disp[1];

    //frame
    $F = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $F->set_var('media_frame',$MG_albums[$aid]->displayFrameTemplate);
    $F->set_var(array(
        'media_link_start'  =>  '<a href="' . $u_pic . '">',
        'media_link_end'    =>  '</a>',

        'url_media_item'    =>  $u_pic,
        'media_thumbnail'   =>  $u_image,
        'media_size'        =>  'width="' . $imageWidth . '" height="' . $imageHeight . '"',
        'media_height'      =>  $imageHeight,
        'media_width'       =>  $imageWidth,
        'border_width'      =>  $imageWidth + 15,
        'border_height'     =>  $imageHeight + 15,
        'media_title'       =>  PLG_replaceTags($I['media_title']),
        'media_tag'         =>  strip_tags($I['media_title']),
        'frWidth'           =>  $imageWidth  - $MG_albums[$aid]->dfrWidth,
        'frHeight'          =>  $imageHeight - $MG_albums[$aid]->dfrHeight,
    ));
    $F->parse('media','media_frame');
    $retval .= $F->finish($F->get_var('media'));
    return $retval;
}

function MG_displayMP3( $aid, $I, $full ) {
    global $_TABLES, $_CONF, $_MG_CONF, $_MG_USERPREFS, $MG_albums, $LANG_MG03;

    $retval = '';

    // set the default playback options...

    $playback_options['autostart']          = $_MG_CONF['mp3_autostart'];
    $playback_options['autostart_tf']       = ($_MG_CONF['mp3_autostart'] ? 'true' : 'false');
    $playback_options['enablecontextmenu']  = $_MG_CONF['mp3_enablecontextmenu'];
    $playback_options['enablecontextmenu_tf']       = ($_MG_CONF['mp3_enablecontextmenu'] ? 'true' : 'false');
    $playback_options['stretchtofit']       = $_MG_CONF['mp3_stretchtofit'];
    $playback_options['scale']              = ($_MG_CONF['mp3_stretchtofit'] ? 'aspect' : 'none');
    $playback_options['showstatusbar']      = $_MG_CONF['mp3_showstatusbar'];
    $playback_options['uimode']             = $_MG_CONF['mp3_uimode'];
    $playback_options['loop']               = $_MG_CONF['mp3_loop'];
    $playback_options['height']             = $_MG_CONF['mp3_height'];
    $playback_options['width']              = $_MG_CONF['mp3_width'];

    $poResult = DB_query("SELECT * FROM {$_TABLES['mg_playback_options']} WHERE media_id='" . $I['media_id'] . "'");
    while ( $poRow = DB_fetchArray($poResult) ) {
        $playback_options[$poRow['option_name']] = $poRow['option_value'];
        $playback_options[$poRow['option_name']. '_tf'] = ( $poRow['option_value'] ? 'true' : 'false');
    }
    $playback_options['height']             = $_MG_CONF['mp3_height'];
    $playback_options['width']              = $_MG_CONF['mp3_width'];

    if (isset($_MG_USERPREFS['playback_mode']) && $_MG_USERPREFS['playback_mode'] != -1 ) {
        $playback_type = $_MG_USERPREFS['playback_mode'];
    } else {
        $playback_type = $MG_albums[$aid]->playback_type;
    }

    switch ($playback_type) {
        case 0 :                    // Popup Window
            if ( $I['media_tn_attached'] == 1 ) {
                $win_height = 240; // $playback_options['height'] + 40;
            } else {
                $win_height = $playback_options['height'] + 40;
            }

            $win_width = $playback_options['width'] + 40;

            if ( $_MG_CONF['mp3_player'] == 0 ) {
                $player = 0;
            }
            if ($_MG_CONF['mp3_player'] == 1 ) {
                $player = 1;
            }
            if ( $_MG_CONF['mp3_player'] == 2 ) {
                $player = 2;
            }
            if ( isset($_MG_USERPREFS['mp3_player']) ) {
                if ($_MG_USERPREFS['mp3_player'] == 0 ) {
                    $player = 0;
                }
                if ($_MG_USERPREFS['mp3_player'] == 1 ) {
                    $player = 1;
                }
                if ( $_MG_USERPREFS['mp3_player'] == 2 ) {
                    $player = 2;
                }
            }

            if ( $player == 2 ) {
                $win_height = 320;
                $win_width = 600;
            }
            if ( $player == 0 ) {
                $win_height = 60;
                $win_width = 320;
            }

            $u_pic = "javascript:showVideo('" . $_MG_CONF['site_url'] . "/video.php?n=" . $I['media_id'] . "'," . $win_height . "," . $win_width . ")";
            if ( $I['media_tn_attached'] == 1 ) {
                $u_image = $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg');
            } else {
                $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/audio.gif';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/audio.gif');
            }
            break;
        case 1: // download
            $u_pic = $_MG_CONF['site_url'] . '/download.php?mid=' . $I['media_id'];
            if ( $I['media_tn_attached'] == 1 ) {
                $u_image = $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg');
            } else {
                $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/audio.gif';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/audio.gif');
            }
            break;
        case 2 :    // inline
            if ( $I['media_tn_attached'] == 1 ) {
                $u_tn = $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg');
                $border_width = $media_size_disp[0] + 15;
                $u_pic = '<div class=out style="width:' . $border_width . 'px"><div class="in ltin tpin"><img src="' . $u_tn . '"></div></div>';
                $playback_options['height'] = 50;
                $playback_options['width']  = 300;
            } else {
                $u_pic='';
                $playback_options['height'] = 50;
                $playback_options['width']  = 300;
            }
            $V = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
            if ( $_MG_CONF['mp3_player'] == 0 ) {
                $tfile = 'view_mp3_wmp.thtml';
            }
            if ($_MG_CONF['mp3_player'] == 1 ) {
                $tfile = 'view_mp3_qt.thtml';
            }
            if ($_MG_CONF['mp3_player'] == 2 ) {
                $tfile = 'view_mp3_swf.thtml';
            }
            if ( isset( $_MG_USERPREFS['mp3_player']) ) {
                if ($_MG_USERPREFS['mp3_player'] == 0 ) {
                    $tfile = 'view_mp3_wmp.thtml';
                }
                if ($_MG_USERPREFS['mp3_player'] == 1 ) {
                    $tfile = 'view_mp3_qt.thtml';
                }
                if ( $_MG_USERPREFS['mp3_player'] == 2) {
                    $tfile = 'view_mp3_swf.thtml';
                }
            }
            if ( $I['mime_type'] == 'audio/x-ms-wma' ) {
                $tfile = 'view_mp3_wmp.thtml';
            }

            require_once($_MG_CONF['path_html'] . '/getid3/getid3/getid3.php');
            $getID3 = new getID3;
            // Analyze file and store returned data in $ThisFileInfo
            $ThisFileInfo = $getID3->analyze($_MG_CONF['path_html'] . '/mediaobjects/orig/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.' . $I['media_mime_ext']);
            getid3_lib::CopyTagsToComments($ThisFileInfo);

            if ( isset($ThisFileInfo['tags']['id3v1']['title'][0]) ) {
                $mp3_title = str_replace(' ','+',$ThisFileInfo['tags']['id3v1']['title'][0]);
            } else {
                if ( isset($ThisFileInfo['tags']['id3v2']['title'][0] ) ) {
                    $mp3_title = str_replace(' ','+',$ThisFileInfo['tags']['id3v2']['title'][0]);
                } else {
                    $mp3_title = str_replace(' ','+',$I['media_original_filename']);
                }
            }
            $mp3_artist = $ThisFileInfo['tags']['id3v1']['artist'];

            $S = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
            $S->set_file(array('swf' => 'swfobject.thtml'));
            $S->set_var(array(
                'site_url'  => $_MG_CONF['site_url'],
            ));
            $S->parse('output','swf');
            $u_image = $S->finish($S->get_var('output'));


            $V->set_file (array ('video' => $tfile));
            $V->set_var(array(
                'u_pic'             =>  $u_pic,
                'u_tn'              =>  $u_tn,
                'autostart'         => ($playback_options['autostart'] ? 'true' : 'false'),
                'enablecontextmenu' => ($playback_options['enablecontextmenu'] ? 'true' : 'false'),
                'stretchtofit'      => ($playback_options['stretchtofit'] ? 'true' : 'false'),
                'showstatusbar'     => ($playback_options['showstatusbar'] ? 'true' : 'false'),
                'loop'              => ($playback_options['loop'] ? 'true' : 'false'),
                'playcount'         => ($playback_options['loop'] ? '9999' : '1'),
                'uimode'            => $playback_options['uimode'],
                'height'            => $playback_options['height'],
                'width'             => $playback_options['width'],
                'movie'             => $_MG_CONF['site_url'] . '/mediaobjects/orig/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.' . $I['media_mime_ext'],
                'site_url'      => $_MG_CONF['site_url'],
                'mp3_title'     => $mp3_title,
                'mp3_artist'    => $mp3_artist,
                'allow_download'    => ($MG_albums[$aid]->allow_download ? 'true' : 'false'),
                'lang_artist'       => $LANG_MG03['artist'],
                'lang_album'        => $LANG_MG03['album'],
                'lang_song'         => $LANG_MG03['song'],
                'lang_track'        => $LANG_MG03['track'],
                'lang_genre'        => $LANG_MG03['genre'],
                'lang_year'         => $LANG_MG03['year'],
                'lang_download'     => $LANG_MG03['download'],
                'lang_info'         => $LANG_MG03['info'],
                'lang_noflash' => $LANG_MG03['no_flash'],
                'swf_version'   => '9',
            ));
            $V->parse('output','video');
            $u_image .= $V->finish($V->get_var('output'));
            return $u_image;
            break;
        case 3: // use mms links
            $mms_path = ereg_replace('http','mms',$_MG_CONF['site_url']);
            $u_pic = $mms_path . '/mediaobjects/orig/'.  $I['media_filename'][0] . '/' . $I['media_filename'] . '.' . $I['media_mime_ext'];

            if ( $I['media_tn_attached'] == 1 ) {
                $u_image = $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
                $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg');
            } else {
                $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/audio.gif';
                $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/audio.gif');
            }
            break;
    }

    $imageWidth  = $media_size_disp[0];
    $imageHeight = $media_size_disp[1];

    $F = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $F->set_var('media_frame',$MG_albums[$aid]->displayFrameTemplate);
    $F->set_var(array(
        'media_link_start'  =>  '<a href="' . $u_pic . '">',
        'media_link_end'    =>  '</a>',

        'url_media_item'    =>  $u_pic,
        'media_thumbnail'   =>  $u_image,
        'media_size'        =>  'width="' . $imageWidth . '" height="' . $imageHeight . '"',
        'media_height'      =>  $imageHeight,
        'media_width'       =>  $imageWidth,
        'border_width'      =>  $imageWidth + 15,
        'border_height'     =>  $imageHeight + 15,
        'media_title'       =>  PLG_replaceTags($I['media_title']),
        'media_tag'         =>  strip_tags($I['media_title']),
        'frWidth'           =>  $imageWidth  - $MG_albums[$aid]->dfrWidth,
        'frHeight'          =>  $imageHeight - $MG_albums[$aid]->dfrHeight,
    ));
    $F->parse('media','media_frame');
    $retval = $F->finish($F->get_var('media'));
    return $retval;
}

function MG_displayOGG( $aid, $I, $full ) {
    global $_TABLES, $_CONF, $_MG_CONF, $MG_albums;

    $retval = '';

    $u_pic = $_MG_CONF['site_url'] . '/download.php?mid=' . $I['media_id'];

    if ( $I['media_tn_attached'] == 1 ) {
        $u_image = $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
        $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg');
    } else {
        $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/audio.gif';
        $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/audio.gif');
    }

    $imageWidth  = $media_size_disp[0];
    $imageHeight = $media_size_disp[1];

    //frame
    $F = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $F->set_var('media_frame',$MG_albums[$aid]->displayFrameTemplate);
    $F->set_var(array(
        'media_link_start'  =>  '<a href="' . $u_pic . '">',
        'media_link_end'    =>  '</a>',

        'url_media_item'    =>  $u_pic,
        'media_thumbnail'   =>  $u_image,
        'media_size'        =>  'width="' . $imageWidth . '" height="' . $imageHeight . '"',
        'media_height'      =>  $imageHeight,
        'media_width'       =>  $imageWidth,
        'border_width'      =>  $imageWidth + 15,
        'border_height'     =>  $imageHeight + 15,
        'media_title'       =>  PLG_replaceTags($I['media_title']),
        'media_tag'         =>  strip_tags($I['media_title']),
        'frWidth'           =>  $imageWidth  - $MG_albums[$aid]->dfrWidth,
        'frHeight'          =>  $imageHeight - $MG_albums[$aid]->dfrHeight,
    ));
    $F->parse('media','media_frame');
    $retval = $F->finish($F->get_var('media'));
    return $retval;
}

function MG_displayGeneric( $aid, $I, $full ) {
    global $_TABLES, $_CONF, $_MG_CONF, $MG_albums;

    $retval = '';

    $u_pic = $_MG_CONF['site_url'] . '/download.php?mid=' . $I['media_id'];
    if ( $I['media_tn_attached'] == 1 ) {
        $u_image = $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg';
        $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/tn/' . $I['media_filename'][0] . '/tn_' . $I['media_filename'] . '.jpg');
    } else {
        switch ( $I['mime_type'] ) {
            case 'application/pdf' :
                $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/pdf.gif';
                $media_size_orig = $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/pdf.gif');
                break;
            case 'application/zip' :
            case 'application/x-compressed' :
            case 'application/x-gzip' :
            case 'application/x-gzip' :
            case 'multipart/x-gzip' :
            case 'application/arj' :
                $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/zip.gif';
                $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/zip.gif');
                break;
            default :
                $u_image     = $_MG_CONF['site_url'] . '/mediaobjects/generic.gif';
                $media_size_disp  = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/generic.gif');
                break;
        }
    }

    $imageWidth  = $media_size_disp[0];
    $imageHeight = $media_size_disp[1];

    $F = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $F->set_var('media_frame',$MG_albums[$aid]->displayFrameTemplate);
    $F->set_var(array(
        'media_link_start'  =>  '<a href="' . $u_pic . '">',
        'media_link_end'    =>  '</a>',
        'url_media_item'    =>  $u_pic,
        'media_thumbnail'   =>  $u_image,
        'media_size'        =>  'width="' . $imageWidth . '" height="' . $imageHeight . '"',
        'media_height'      =>  $imageHeight,
        'media_width'       =>  $imageWidth,
        'border_width'      =>  $imageWidth + 15,
        'border_height'     =>  $imageHeight + 15,
        'media_title'       =>  PLG_replaceTags($I['media_title']),
        'media_tag'         =>  strip_tags($I['media_title']),
        'frWidth'           =>  $imageWidth  - $MG_albums[$aid]->dfrWidth,
        'frHeight'          =>  $imageHeight - $MG_albums[$aid]->dfrHeight,
    ));
    $F->parse('media','media_frame');
    $retval = $F->finish($F->get_var('media'));
    return $retval;
}


function MG_displayTGA($aid,$I,$full,$mediaObject) {
    global $_CONF, $_MG_CONF, $MG_albums, $_USER;

    $retval = '';
    $media_link_start = '';
    $media_link_end   = '';

    $media_size_disp = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/disp/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.jpg');

    if ( $MG_albums[$aid]->full == 2 || $_MG_CONF['discard_original'] == 1 || ( $MG_albums[$aid]->full == 1 && $_USER['uid'] > 1 )) {
        $u_pic = '#';
        $media_link_start = '';
    } else {
        $media_link_start =
        $media_link_start = '<a href="' . $_MG_CONF['site_url'] . '/download.php?mid=' . $I['media_id'] . '">';
        $media_link_end = '</a>';
        $u_pic      = $_MG_CONF['site_url'] . '/download.php?mid=' . $I['media_id'] . '"';
    }
    $u_image    = $_MG_CONF['site_url'] . '/mediaobjects/disp/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.jpg';

    $imageWidth  = $media_size_disp[0];
    $imageHeight = $media_size_disp[1];

    $F = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $F->set_var('media_frame',$MG_albums[$aid]->displayFrameTemplate);
    $F->set_var(array(
        'media_link_start'  => $media_link_start,
        'media_link_end'    => $media_link_end,
        'url_media_item'    =>  $u_pic,
        'media_thumbnail'   =>  $u_image,
        'media_size'        =>  'width="' . $imageWidth . '" height="' . $imageHeight . '"',
        'media_height'      =>  $imageHeight,
        'media_width'       =>  $imageWidth,
        'border_width'      =>  $imageWidth + 15,
        'border_height'     =>  $imageHeight + 15,
        'media_title'       =>  PLG_replaceTags($I['media_title']),
        'media_tag'         =>  strip_tags($I['media_title']),
        'frWidth'           =>  $imageWidth  - $MG_albums[$aid]->dfrWidth,
        'frHeight'          =>  $imageHeight - $MG_albums[$aid]->dfrHeight,
    ));
    $F->parse('media','media_frame');
    $retval = $F->finish($F->get_var('media'));
    return $retval;
}

function MG_displayPSD($aid,$I,$full,$mediaObject) {
    global $_CONF, $_MG_CONF, $MG_albums, $_USER;

    $retval = '';
    $media_link_start = '';
    $media_link_end   = '';

    $media_size_disp = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/disp/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.jpg');

    if ( $MG_albums[$aid]->full == 2 || $_MG_CONF['discard_original'] == 1 || ( $MG_albums[$aid]->full == 1 && $_USER['uid'] > 1 )) {
        $u_pic = '#';
        $media_link_start = '';
    } else {
        $u_pic      = $_MG_CONF['site_url'] . '/download.php?mid=' . $I['media_id'] . '"';
        $media_link_start = '<a href="' . $_MG_CONF['site_url'] . '/download.php?mid=' . $I['media_id'] . '">';
        $media_link_end   = '</a>';
    }
    $u_image    = $_MG_CONF['site_url'] . '/mediaobjects/disp/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.jpg';

    $imageWidth  = $media_size_disp[0];
    $imageHeight = $media_size_disp[1];
    $F = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $F->set_var('media_frame',$MG_albums[$aid]->displayFrameTemplate);
    $F->set_var(array(
        'media_link_start'  =>  $media_link_start,
        'media_link_end'    =>  $media_link_end,
        'url_media_item'    =>  $u_pic,
        'media_thumbnail'   =>  $u_image,
        'media_size'        =>  'width="' . $imageWidth . '" height="' . $imageHeight . '"',
        'media_height'      =>  $imageHeight,
        'media_width'       =>  $imageWidth,
        'border_width'      =>  $imageWidth + 15,
        'border_height'     =>  $imageHeight + 15,
        'media_title'       =>  PLG_replaceTags($I['media_title']),
        'media_tag'         =>  strip_tags($I['media_title']),
        'frWidth'           =>  $imageWidth  - $MG_albums[$aid]->dfrWidth,
        'frHeight'          =>  $imageHeight - $MG_albums[$aid]->dfrHeight,
    ));
    $F->parse('media','media_frame');
    $retval = $F->finish($F->get_var('media'));
    return $retval;
}

function MG_displayEmbed($aid,$I,$full,$mediaObject) {
    global $_CONF, $_MG_CONF, $MG_albums, $_USER;

    $retval = '';
    $F = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $F->set_file('media_frame','embed.thtml');
    $F->set_var(array(
    	'embed_string'		=>  $I['remote_url'],
        'media_title'       =>  PLG_replaceTags($I['media_title']),
        'media_tag'         =>  strip_tags($I['media_title']),
    ));
    $F->parse('media','media_frame');
    $retval = $F->finish($F->get_var('media'));
    return $retval;
}


function MG_displayJPG($aid,$I,$full,$mid,$sortOrder) {
    global $_CONF, $_MG_CONF, $MG_albums, $_USER;

    $retval = '';
    $media_size_disp = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/disp/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.jpg');
    $media_size_orig = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/orig/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.' . $I['media_mime_ext']);

    $media_link_start = '';
    $media_link_end   = '';

    if ( $media_size_orig == FALSE || $MG_albums[$aid]->full == 2 || $_MG_CONF['discard_original'] == 1 || ( $MG_albums[$aid]->full == 1 && (!isset($_USER['uid']) || $_USER['uid'] < 2 ) )) {
        $u_pic = '#';
        $media_link_start = '';
    } else {
        if ( $full == 0 && $_MG_CONF['full_in_popup'] ) {
            $popup_x = $media_size_orig[0] + 75;
            $popup_y = $media_size_orig[1] + 100;
            $u_pic  = 'javascript:showVideo(\'' . $_MG_CONF['site_url'] . '/popup.php?s=' . $mid .'&amp;sort=' . $sortOrder . "'," . $popup_y . "," . $popup_x . ")";
            $media_link_start = '<a href="' . 'javascript:showVideo(\'' . $_MG_CONF['site_url'] . '/popup.php?s=' . $mid .'&amp;sort=' . $sortOrder . "'," . $popup_y . "," . $popup_x . ")\">";
            $media_link_end = '</a>';
        } else {
            $u_pic      = $_MG_CONF['site_url'] . '/media.php?f=' . ($full ? '0' : '1') . '&amp;s=' . $mid;
            $media_link_start = '<a href="' . $_MG_CONF['site_url'] . '/media.php?f=' . ($full ? '0' : '1') . '&amp;s=' . $mid . '">';
            $media_link_end = '</a>';

        }
    }

    if ( $full == 1 ) {
        $u_image    = $_MG_CONF['site_url'] . '/mediaobjects/orig/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.' . $I['media_mime_ext'];
    } else {
        if ( $media_size_disp == false ) {
            $u_image = $_MG_CONF['site_url'] . '/mediaobjects/missing.png';
            $media_size_disp[0] = 200;
            $media_size_orig[1] = 150;
        } else {
            $u_image    = $_MG_CONF['site_url'] . '/mediaobjects/disp/' . $I['media_filename'][0] . '/' . $I['media_filename'] . '.jpg';
        }
    }

    $imageWidth  = $full ? $media_size_orig[0] : $media_size_disp[0];
    $imageHeight = $full ? $media_size_orig[1] : $media_size_disp[1];

    $F = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $F->set_var('media_frame',$MG_albums[$aid]->displayFrameTemplate);
    $F->set_var(array(
        'url_media_item'    =>  $u_pic,
        'media_link_start'  =>  $media_link_start,
        'media_link_end'    =>  $media_link_end,
        'media_thumbnail'   =>  $u_image,
        'media_size'        =>  'width="' . $imageWidth . '" height="' . $imageHeight . '"',
        'media_height'      =>  $imageHeight,
        'media_width'       =>  $imageWidth,
        'border_width'      =>  $imageWidth + 15,
        'border_height'     =>  $imageHeight + 15,
        'media_title'       =>  PLG_replaceTags($I['media_title']),
        'media_tag'         =>  strip_tags($I['media_title']),
        'frWidth'           =>  $imageWidth  - $MG_albums[$aid]->dfrWidth,
        'frHeight'          =>  $imageHeight - $MG_albums[$aid]->dfrHeight,
    ));
    $F->parse('media','media_frame');
    $retval = $F->finish($F->get_var('media'));
    return $retval;
}


function MG_displayMediaImage( $mediaObject, $full, $sortOrder, $comments ) {
    global $MG_albums, $_POST, $_TABLES, $_CONF, $_MG_CONF, $LANG_MG00, $LANG_MG01, $LANG_MG03, $LANG_MG04, $LANG_ACCESS, $LANG01, $album_jumpbox, $glversion, $_USER, $_MG_USERPREFS;
    global $_DB_dbms, $mgLightBox, $LANG04;

    $retval = '';

    $aid  = DB_getItem($_TABLES['mg_media_albums'], 'album_id','media_id="' . $mediaObject . '"');

    if ( $MG_albums[$aid]->access == 0 ) {
        $retval = COM_startBlock ($LANG_ACCESS['accessdenied'], '',COM_getBlockTemplate ('_msg_block', 'header'))
                 . '<br />' . $LANG_MG00['access_denied_msg']
                 . COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
        return array($LANG_MG00['access_denied_msg'],$retval);
    }

    $mid = $mediaObject;

    $orderBy = MG_getSortOrder($aid,$sortOrder);

    if ( $_DB_dbms == "mssql" ) {
        $sql = "SELECT *,CAST(media_desc AS TEXT) AS media_desc FROM {$_TABLES['mg_media_albums']} as ma LEFT JOIN " . $_TABLES['mg_media'] . " as m " .
                " ON ma.media_id=m.media_id WHERE ma.album_id=" . $aid . $orderBy;
    } else {
        $sql = "SELECT * FROM {$_TABLES['mg_media_albums']} as ma LEFT JOIN " . $_TABLES['mg_media'] . " as m " .
                " ON ma.media_id=m.media_id WHERE ma.album_id=" . $aid . $orderBy;
    }
    $result = DB_query( $sql );
    $nRows = DB_numRows( $result );

    $total_media = $nRows;
    $media = array();
    while ( $row = DB_fetchArray($result) ) {
        $media[] = $row;
        $ids[] = $row['media_id'];
    }

    $key = array_search($mid,$ids);
    if ( $key === false ) {
        $retval  = COM_startBlock ($LANG_ACCESS['accessdenied'], '',COM_getBlockTemplate ('_msg_block', 'header'))
                 . '<br />' . $LANG_MG00['access_denied_msg']
                 . COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
        return array($LANG_MG00['access_denited_msg'], $retval);
    }

    $mediaObject = $key;

    if ( $MG_albums[$aid]->full == 2 || $_MG_CONF['discard_original'] == 1 || ( $MG_albums[$aid]->full == 1 && $_USER['uid'] > 1 )) {
        $full = 0;
    }
    if ( $full )
        $disp = 'orig';
    else
        $disp = 'disp';

    if ( $MG_albums[$aid]->enable_comments == 0 ) {
        $comments = 0;
    }

    $nFrame = new mgFrame();
    $nFrame->constructor( $MG_albums[$aid]->display_skin );
    $MG_albums[$aid]->displayFrameTemplate = $nFrame->getTemplate();
    $MG_albums[$aid]->dfrWidth = $nFrame->frame['wHL'] + $nFrame->frame['wHR'];
    $MG_albums[$aid]->dfrHeight = $nFrame->frame['hVT'] + $nFrame->frame['hVB'];
    $retval .= $nFrame->getCSS();

    $T = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $T->set_file (array(
        'page'          => 'view_image.thtml',
        'rateselect'    => 'rate_entry.thtml',
        'rateresults'   => 'rate_results.thtml',
        'shutterfly'    => 'digibug.thtml',
    ));
    $T->set_var('header', $LANG_MG00['plugin']);
    $T->set_var('site_url',$_MG_CONF['site_url']);
    $T->set_var('plugin','mediagallery');

    // construct the album jumpbox...
    $level = 0;
    $album_jumpbox = '<form name="jumpbox" action="' . $_MG_CONF['site_url'] . '/album.php' . '" method="get" style="margin:0;padding:0">';
    $album_jumpbox .= $LANG_MG03['jump_to'] . ':&nbsp;<select name="aid" onChange="forms[\'jumpbox\'].submit()">';
    $MG_albums[0]->buildJumpBox($aid);
    $album_jumpbox .= '</select>';
    $album_jumpbox .= '&nbsp;<input type="submit" value="' . $LANG_MG03['go'] . '" />';
    $album_jumpbox .= '<input type="hidden" name="page" value="1">';
    $album_jumpbox .= '</form>';

    // Update the views count... But only for non-admins

    if (!$MG_albums[0]->owner_id/*SEC_hasRights('mediagallery.admin')*/) {
        $media_views = $media[$mediaObject]['media_views'] + 1;
        DB_query("UPDATE " . $_TABLES['mg_media'] . " SET media_views=" . $media_views . " WHERE media_id='" . $media[$mediaObject]['media_id'] . "'");
    }

    $columns_per_page   = ($MG_albums[$aid]->display_columns == 0 ? $_MG_CONF['ad_display_columns'] : $MG_albums[$aid]->display_columns);
    $rows_per_page      = ($MG_albums[$aid]->display_rows == 0 ? $_MG_CONF['ad_display_rows'] : $MG_albums[$aid]->display_rows);

    if (isset($_MG_USERPREFS['display_rows']) && $_MG_USERPREFS['display_rows'] > 0 ) {
        $rows_per_page = $_MG_USERPREFS['display_rows'];
    }
    if (isset($_MG_USERPREFS['display_columns'] ) && $_MG_USERPREFS['display_columns'] > 0 ) {
        $columns_per_page = $_MG_USERPREFS['display_columns'];
    }
    $media_per_page     = $columns_per_page * $rows_per_page;

    if ( $MG_albums[$aid]->albums_first ) {
        $childCount = $MG_albums[$aid]->getChildCount();
        $page = intval(($mediaObject + $childCount) / $media_per_page) + 1;
    } else {
        $page = intval(($mediaObject)  / $media_per_page) + 1;
    }

    $media_size_tn   = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/tn/' . $media[$mediaObject]['media_filename'][0] . '/' . $media[$mediaObject]['media_filename'] . '.jpg');
    $media_size_disp = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/disp/' . $media[$mediaObject]['media_filename'][0] . '/' . $media[$mediaObject]['media_filename'] . '.jpg');
    $media_size_orig = @getimagesize($_MG_CONF['path_html'] . 'mediaobjects/orig/' . $media[$mediaObject]['media_filename'][0] . '/' . $media[$mediaObject]['media_filename'] . '.' . $media[$mediaObject]['media_mime_ext']);

    if ($media_size_orig == false ) {
        $full = 0;
        $disp = 'disp';
    }

    $aOffset = $MG_albums[$aid]->getOffset();
    $aPage = intval(($aOffset)  / ($_MG_CONF['album_display_columns'] * $_MG_CONF['album_display_rows'])) + 1;
    $birdseed = '<a href="' . $_CONF['site_url'] . '/index.php">' . $LANG_MG03['home'] . '</a> ' . $_MG_CONF['seperator'] . ' <a href="' . $_MG_CONF['site_url'] . '/index.php?page=' . $aPage . '">' . $_MG_CONF['menulabel'] . '</a> ' . $MG_albums[$aid]->getPath(1,$sortOrder,$page) . '</a>';

    mg_usage('media_view',$MG_albums[$aid]->title, $media[$mediaObject]['media_title'],$media[$mediaObject]['media_id']);

    // hack for tga files...
    if ( $media[$mediaObject]['mime_type'] == 'image/x-targa' || $media[$mediaObject]['mime_type'] == 'image/tga' ) {
        $full = 0;
        $disp = 'disp';
    }

    switch( $media[$mediaObject]['mime_type'] ) {
        case 'video/x-ms-asf' :
        case 'video/x-ms-asf-plugin' :
        case 'video/avi' :
        case 'video/msvideo' :
        case 'video/x-msvideo' :
        case 'video/avs-video' :
        case 'video/x-ms-wmv' :
        case 'video/x-ms-wvx' :
        case 'video/x-ms-wm' :
        case 'application/x-troff-msvideo' :
        case 'application/x-ms-wmz' :
        case 'application/x-ms-wmd' :
            $u_image = MG_displayASF($aid,$media[$mediaObject],$full);
            break;
        case 'audio/x-ms-wma' :
            $u_image = MG_displayMP3($aid,$media[$mediaObject],$full);
            break;
        case 'video/mpeg' :
        case 'video/x-motion-jpeg' :
        case 'video/quicktime' :
        case 'video/mpeg' :
        case 'video/x-mpeg' :
        case 'video/x-mpeq2a' :
        case 'video/x-qtc' :
            $u_image = MG_displayMOV($aid,$media[$mediaObject],$full);
            break;
        case 'embed' :
	        $u_image = MG_displayEmbed($aid,$media[$mediaObject],$full,$mediaObject);
			break;
        case 'application/x-shockwave-flash' :
           	$u_image = MG_displaySWF($aid,$media[$mediaObject],$full);
            break;
        case 'video/x-flv' :
            $u_image = MG_displayFLV($aid,$media[$mediaObject],$full);
            break;
        case 'audio/mpeg' :
        case 'audio/x-mpeg' :
        case 'audio/mpeg3' :
        case 'audio/x-mpeg-3' :
            $u_image = MG_displayMP3($aid,$media[$mediaObject],$full);
            break;
        case 'application/ogg' :
        case 'application/x-ogg' :
            $u_image = MG_displayOGG($aid,$media[$mediaObject],$full);
            break;
        case 'image/x-targa' :
        case 'image/tga' :
            $u_image = MG_displayTGA($aid,$media[$mediaObject],$full,$mediaObject);
            break;
        case 'image/photoshop' :
        case 'image/x-photoshop' :
        case 'image/psd' :
        case 'application/photoshop' :
        case 'application/psd' :
            $u_image = MG_displayPSD($aid,$media[$mediaObject],$full,$mediaObject);
            break;
        case 'image/gif' :
        case 'image/jpeg' :
        case 'image/jpg' :
        case 'image/png' :
        case 'image/bmp' :
            $u_image = MG_displayJPG($aid,$media[$mediaObject],$full, $media[$mediaObject]['media_id'], $sortOrder);
            break;
        default :
            switch( $media[$mediaObject]['media_mime_ext']) {
                case 'jpg' :
                case 'gif' :
                case 'png' :
                case 'bmp' :
                    $u_image = MG_displayJPG($aid,$media[$mediaObject],$full, $media[$mediaObject]['media_id'], $sortOrder);
                    break;
                case 'asf' :
                    $u_image = MG_displayASF($aid,$media[$mediaObject],$full);
                    break;
                default :
                    $u_image = MG_displayGeneric($aid,$media[$mediaObject],$full, $media[$mediaObject]['media_id'], $sortOrder);
                    break;
            }
    }

    $mid = $media[$mediaObject]['media_id'];

    $media_date = MG_getUserDateTimeFormat( $media[$mediaObject]['media_time'] );

    // pull the ratings...

    $rate_select = '<select name="rating" class="select">';
    $rate_select .= '<option value="">--</option>';
    for ($i=10; $i>0; $i--) {
        $rate_select .= '<option value="' . $i . '">' . $i . '</option>';
    }
    $rate_select .= '</select>';

    if ( $MG_albums[$aid]->enable_rating ) {
        $T->set_var(array(
            'form_action_rate' => $_MG_CONF['site_url'] . '/media.php?s=' . $media[$mediaObject]['media_id'] . '&amp;f=' . $full . '&amp;sort=' . $sortOrder,
            'mid'           =>  $media[$mediaObject]['media_id'],
            'lang_rate'     =>  $LANG_MG03['rate'],
            'rate_select'   =>  $rate_select,
        ));
        $T->parse('rate_entry','rateselect');

        $T->set_var(array(
            'media_rating'  =>  $media[$mediaObject]['media_rating'],
            'media_votes'   =>  $media[$mediaObject]['media_votes'],
            'lang_rating'   =>  $LANG_MG03['rating'],
            'lang_votes'    =>  $LANG_MG03['votes'],
        ));
        $T->parse('rate_results','rateresults');
    }

    if ( $MG_albums[$aid]->allow_download ) {
        $T->set_var(array(
            'download'  => '<a href="' . $_MG_CONF['site_url'] . '/download.php?mid=' . $media[$mediaObject]['media_id'] . '">' . $LANG_MG01['download'] . '</a>',
        ));
    }

    if ( $media[$mediaObject]['media_type'] == 0 && $MG_albums[$aid]->enable_shutterfly ) {
        if ( $_MG_CONF['discard_original'] == 1 ) {
            $sf_picture = $_MG_CONF['site_url'] . '/mediaobjects/disp/' . $media[$mediaObject]['media_filename'][0] . '/' . $media[$mediaObject]['media_filename'] . '.jpg';
        } else {
            $sf_picture = $_MG_CONF['site_url'] . '/mediaobjects/orig/' . $media[$mediaObject]['media_filename'][0] . '/' . $media[$mediaObject]['media_filename'] . '.' . $media[$mediaObject]['media_mime_ext'];
        }
        $T->set_var(array(
            'sf_height'     =>  $media_size_orig[1],
            'sf_width'      =>  $media_size_orig[0],
            'sf_tn_height'  =>  $media_size_tn[1],
            'sf_tn_width'   =>  $media_size_tn[0],
            'sf_thumbnail'  =>  $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $media[$mediaObject]['media_filename'][0] . '/' . $media[$mediaObject]['media_filename'] . '.jpg',
            'sf_picture'    =>  $sf_picture,
            'sf_title'      =>  $media[$mediaObject]['media_title'],
            'lang_print_digibug' =>  $LANG_MG03['print_digibug'],
            'lang_print_shutterfly' => $LANG_MG03['print_shutterfly'],
        ));
        $T->parse('shutterfly_submit','shutterfly');
    }

    if ($MG_albums[$aid]->access == 3 ) {
        $edit_item = '<a href="' . $_MG_CONF['site_url'] . '/admin.php?mode=mediaedit&amp;s=1&amp;album_id=' . $aid . '&amp;mid=' . $mid . '">' . $LANG_MG01['edit'] . '</a>';
    } else {
        $edit_item = '';
    }

    $media_desc = PLG_replaceTags($media[$mediaObject]['media_desc']);
    if ( strlen($media_desc) > 0 ) {
        $media_desc .= '<br /><br />';
    }

    // start of the lightbox slideshow code

    if ( $MG_albums[$aid]->enable_slideshow == 2 ) {
        $mgLightBox = 1;
        $lbSlideShow  = '<noscript><div class="pluginAlert">' . $LANG04[150] . '</div></noscript>' . LB;
        $lbSlideShow .= '<script type="text/javascript">' . LB;
        $lbSlideShow .= 'function openGallery1() {' . LB;
        $lbSlideShow .= '    return Lightbox.open([' . LB;

        $orderBy = MG_getSortOrder($aid,$sortOrder);
        $sql = "SELECT * FROM " .
                $_TABLES['mg_media_albums'] . " as ma LEFT JOIN " . $_TABLES['mg_media'] . " as m " .
                " ON ma.media_id=m.media_id
                WHERE ma.album_id=" . $aid .
                $orderBy;

        $result = DB_query( $sql );
        $lbss_count = 0;
        while ( $row = DB_fetchArray( $result ) ) {
            if ($row['media_type'] != 0 || $row['media_filename'] == '') {
                continue;
            }
            $PhotoURL = $_MG_CONF['site_url'] . "/mediaobjects/disp/" . $row['media_filename'][0] .'/' . $row['media_filename'] . '.jpg';
            $PhotoPath = $_MG_CONF['path_html'] . "/mediaobjects/disp/" . $row['media_filename'][0] .'/' . $row['media_filename'] . '.jpg';
            $imgsize = @getimagesize($PhotoPath);
            if ( $imgsize == false ) {
                continue;
            }
            $PhotoCaption = $row['media_title'];
            $PhotoCaption = str_replace(";", " ",  $PhotoCaption);
            $PhotoCaption = str_replace("\"", " ", $PhotoCaption);
            $PhotoCaption = str_replace("\n", " ", $PhotoCaption);
            $PhotoCaption = str_replace("\r", " ", $PhotoCaption);
            $PhotoCaption = str_replace("'"," ", $PhotoCaption);
            if ( $lbss_count !=0 ) {
                $lbSlideShow .= ',' . LB;
            }
            $lbss_count++;
            $lbSlideShow .= "['" . $PhotoURL . "','" . $PhotoCaption . "']";
        }
        $lbSlideShow .= '], 0);' . LB;
        $lbSlideShow .= '}' . LB;
        $lbSlideShow .= '</script>' . LB;
        $T->set_var('lbslideshow',$lbSlideShow);
    } else {
        $T->set_var('lbslideshow','');
    }

    // end of the lightbox slideshow code

    switch ( $MG_albums[$aid]->enable_slideshow ) {
        case 0 :
            $url_slideshow = '';
            break;
        case 1 :
            $url_slideshow = '<a href="' . $_MG_CONF['site_url'] . '/slideshow.php?aid=' . $aid . '&amp;sort=' . $sortOrder . '"><b>' . $LANG_MG03['slide_show'] . '</b></a>';
            break;
        case 2:
            $url_slideshow = '<span id="mgslideshow" class="jsenabled_show" style="display:none"><a href="#" onclick="return openGallery1()"><b>' . $LANG_MG03['slide_show'] . '</b></a></span>';
            break;
        case 3:
            $url_slideshow = '<a href="' . $_MG_CONF['site_url'] . '/fslideshow.php?aid=' . $aid . '&amp;src=disp"><b>' . $LANG_MG03['slide_show'] . '</b></a>';
            break;
        case 4:
            $url_slideshow = '<a href="' . $_MG_CONF['site_url'] . '/fslideshow.php?aid=' . $aid . '&amp;src=orig"><b>' . $LANG_MG03['slide_show'] . '</b></a>';
            break;
    }

    $T->set_var(array(
        'birdseed'      =>  $birdseed,
        'slide_show'    =>  $url_slideshow, //$MG_albums[$aid]->enable_slideshow ? '<a href="' . $_MG_CONF['site_url'] . '/slideshow.php?aid=' . $aid . '&amp;sort=' . $sortOrder . '"><b>' . $LANG_MG03['slide_show'] . '</b></a>' : '',
        'image_detail'  =>  $u_image,
        'border_height' =>  ($full ? $media_size_orig[1] + 30 : $media_size_disp[1] + 30),
        'border_width'  =>  ($full ? $media_size_orig[0] + 30 : $media_size_disp[0] + 30),
        'media_title'   =>  PLG_replaceTags($media[$mediaObject]['media_title']),
        'album_title'   =>  $MG_albums[$aid]->title,
        'media_desc'    =>  $media_desc,
        'media_time'    =>  $media_date[0],
        'media_views'   =>  ($MG_albums[$aid]->enable_views ? $media[$mediaObject]['media_views'] : ''),
        'media_comments' => ($MG_albums[$aid]->enable_comments ? $media[$mediaObject]['media_comments'] . '<br />' : ''),
        'pagination'    =>  generate_pic_pagination($_MG_CONF['site_url'] . "/media.php?f=" . ($full ? '1' : '0') . "&amp;sort=" . $sortOrder, $nRows, 1, $mediaObject, $media, TRUE),
        'media_number'  =>  sprintf("%s %d %s %d", $LANG_MG03['image'], $mediaObject + 1 , $LANG_MG03['of'], $total_media ),
        'jumpbox'       =>  $album_jumpbox,
        'edit_item'     =>  $edit_item,
        'site_url'      =>  $_MG_CONF['site_url'],
    ));

    $getid3link = '';
    $getid3linkend = '';

    $T->set_var(array(
        'getid3'    => $getid3link,
        'getid3end' => $getid3linkend,
    ));
    if ( $getid3link != '' ) {
        $T->set_var('media_properties',$LANG_MG03['media_properties']);
    } else {
        $T->set_var('media_properties','');
    }

    if ( $MG_albums[$aid]->enable_keywords == 1 && !empty($media[$mediaObject]['media_keywords'])) {
        $T->set_var(array(
            'media_keywords'    => $media[$mediaObject]['media_keywords'],
            'lang_keywords'     => $LANG_MG01['keywords']
        ));
    } else {
        $T->set_var(array(
            'media_keywords'    => '',
            'lang_keywords'     => '',
         ));
    }

    if ( $media['mediaObject']['media_user_id'] == '' || !isset($media['mediaObject']['media_user_id'] ) ) {
        $media['mediaObject']['media_user_id'] = 0;
    }
    $owner_name = DB_getItem ($_TABLES['users'],'username', "uid = {$media[$mediaObject]['media_user_id']}");
    $owner_link = '<a href="' . $_CONF['site_url'] . '/users.php?mode=profile&amp;uid=' . $media[$mediaObject]['media_user_id'] . '">' . $owner_name . '</a>';
    $T->set_var('owner_username',$owner_link);

    if ( ($MG_albums[$aid]->exif_display==2 || $MG_albums[$aid]->exif_display==3) && $media[$mediaObject]['media_type']==0 ) {
        require_once($_MG_CONF['path_html'] . 'lib-exif.php');

        $haveEXIF = MG_haveEXIF($media[$mediaObject]['media_id']);
        if ( $haveEXIF ) {
            $T->set_var(array(
                'property'      =>  $_MG_CONF['site_url'] . '/property.php?mid=' . $media[$mediaObject]['media_id'],
                'lang_property' =>  $LANG_MG04['exif_header'],
            ));
        }
    }

    if ($MG_albums[0]->owner_id || $_MG_CONF['enable_media_id'] == 1) {
        $T->set_var(array(
            'media_id'  => $media[$mediaObject]['media_id']
        ));
    }

    // Language specific vars

    $T->set_var(array(
        'lang_comments'     => ($MG_albums[$aid]->enable_comments ? $LANG_MG03['comments'] : ''),
        'lang_views'        => ($MG_albums[$aid]->enable_views ? $LANG_MG03['views'] : ''),
        'lang_title'        => $LANG_MG01['title'],
        'print_shutterfly'  => $LANG_MG03['print_shutterfly'],
        'lang_uploaded_by'  => $LANG_MG01['uploaded_by'],
        'album_id'          => $aid,
    ));

    if ( ($MG_albums[$aid]->exif_display == 1 || $MG_albums[$aid]->exif_display == 3) && ($media[$mediaObject]['media_type'] == 0) ) {
        require_once($_MG_CONF['path_html'] . 'lib-exif.php');
        $haveEXIF = MG_haveEXIF($media[$mediaObject]['media_id']);

        if ( $haveEXIF ) {
            $exifData = MG_readEXIF($media[$mediaObject]['media_id'],2);

            $T->set_var(array(
                'exif_info'         => $exifData
            ));
        }
    }

    if ( ($MG_albums[$aid]->enable_postcard == 1 && $_USER['uid'] > 1 ) || ($MG_albums[$aid]->enable_postcard == 2) ) {
        if ( $media[$mediaObject]['media_type'] == 0 ) {
            $postcard_link = '<a href="' . $_MG_CONF['site_url'] . '/postcard.php?mode=edit&amp;mid=' . $media[$mediaObject]['media_id'] . '"><img src="' . $_MG_CONF['site_url'] . '/images/icon_envelopeSmall.gif" border="0" alt="' . $LANG_MG01['send_postcard'] . '"></a>';
            $T->set_var('postcard_link', $postcard_link);
        }
    }
    $T->parse('output','page');

    $retval .= $T->finish($T->get_var('output'));

    if ($comments) {
        if ( $glversion[1] < 4 ) {
            if ($MG_albums[$aid]->enable_comments) {
                if ($media[$mediaObject]['media_title'] == '' ) {
                    $title = htmlspecialchars("Media Comment");
                } else {
                    $title = htmlspecialchars($media[$mediaObject]['media_title']);
                }

                if ( DB_count($_TABLES['comments'],'sid',$mid) > 0 ) {
                    if ($MG_albums[$aid]->access == 3 || $MG_albums[0]->owner_id/*SEC_hasRights('mediagallery.admin')*/){
                        $delete_option = true;
                    } else {
                        $delete_option = false;
                    }
                    $retval .= "<p>" . COM_userComments($mid,$title,'mediagallery','ASC',$_CONF['comment_mode'],0,1,0,$delete_option);
                } else {
                    $retval .= ' <center><a href="' . $_CONF['site_url'] . '/comment.php?sid=' . $mid . '&amp;title=' . $title . '&amp;pid=0&amp;type=mediagallery' . '">' . $LANG01[60] . '</a></center>';
                }
            }
        } else {
        // Geeklog 1.4 Comment support
            $mid = $media[$mediaObject]['media_id'];
            if ($MG_albums[$aid]->enable_comments == 1){
                require_once ( $_CONF['path_system'] . 'lib-comment.php' );
                if ($MG_albums[$aid]->access == 3 || $MG_albums[0]->owner_id){
                    $delete_option = true;
                } else {
                    $delete_option = false;
                }
                if ( DB_count($_TABLES['comments'],'sid',$mid) > 0  || $_MG_CONF['commentbar'] ) {
                    $cid        = $mid;
                    $page       = 0;
                    $comorder   = COM_applyFilter($_POST['order']);
                    $commode    = COM_applyFilter($_POST['mode']);
                    $commentbar = CMT_userComments ($cid,$media[$mediaObject]['media_title'],
                                  'mediagallery',$comorder,$commode,0,$page,false,$delete_option);
                    $retval    .= $commentbar;
                } else {
                    $retval .= ' <center><a href="' . $_CONF['site_url'] . '/comment.php?sid=' . $mid . '&amp;title=' . $title . '&amp;pid=0&amp;type=mediagallery' . '">' . $LANG01[60] . '</a></center>';
                }
            }
        }
    }

    return array(strip_tags($media[$mediaObject]['media_title']),$retval);
}
?>