<?php
// +---------------------------------------------------------------------------+
// | Media Gallery Plugin 1.5                                                  |
// +---------------------------------------------------------------------------+
// | $Id:: caption.php 1046 2007-06-21 05:26:22Z mevans0263                   $|
// | Batch caption editing routines                                            |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2006 by the following authors:                              |
// |                                                                           |
// | Author: mevans@ecsnet.com                                                 |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

// this file can't be used on its own
if (!defined ('VERSION')) {
    die ('This file can not be used on its own.');
}


function MG_batchCaptionEdit( $album_id, $start, $actionURL = '' ) {
    global $_CONF, $_TABLES, $_MG_CONF, $LANG_MG00, $LANG_MG01, $_POST, $_DB_dbms;

    if ($actionURL == '' ) {
        $actionURL = $_MG_CONF['site_url'] . '/index.php';
    }

    $rowclass = 0;

    // need to check and see that we have permission to do this!
    // BUG put it here! - don't look just for mediagallery.admin, actually check
    // and see if we have write priviledges to this album...

    $result = DB_query("SELECT * FROM {$_TABLES['mg_albums']} WHERE album_id=" . $album_id);
    $nRows = DB_numRows($result);
    if ( $nRows > 0 ) {
        $A = DB_fetchArray($result);
    } else {
        $display .= COM_startBlock ('', '',COM_getBlockTemplate ('_admin_block', 'header'));
        $T = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
        $T->set_file('admin','error.thtml');
        $T->set_var('site_url', $_CONF['site_url']);
        $T->set_var('site_admin_url', $_CONF['site_admin_url']);
        $T->set_var('errormessage',$LANG_MG00['access_denied_msg']);
        $T->parse('output', 'admin');
        $display .= $T->finish($T->get_var('output'));
        $display .= COM_endBlock (COM_getBlockTemplate ('_admin_block', 'footer'));
        $display .= MG_siteFooter();
        return $display;
    }

    $access = SEC_hasAccess (   $A['owner_id'],
                                $A['group_id'],
                                $A['perm_owner'],
                                $A['perm_group'],
                                $A['perm_members'],
                                $A['perm_anon']
                            );

    if ( $access != 3 ) {
        $display .= COM_startBlock ('', '',COM_getBlockTemplate ('_admin_block', 'header'));
        $T = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
        $T->set_file('admin','error.thtml');
        $T->set_var('site_url', $_CONF['site_url']);
        $T->set_var('site_admin_url', $_CONF['site_admin_url']);
        $T->set_var('errormessage',$LANG_MG00['access_denied_msg']);
        $T->parse('output', 'admin');
        $display .= $T->finish($T->get_var('output'));
        $display .= COM_endBlock (COM_getBlockTemplate ('_admin_block', 'footer'));
        $display .= MG_siteFooter();
        return $display;
    }

    $retval = '';

    $T = new Template($_CONF['path'] . 'plugins/mediagallery/templates');

    $T->set_file (array(
        'admin'     =>  'batch_caption_edit.thtml',
        'empty'     =>  'album_page_noitems.thtml',
        'media'     =>  'batch_caption_media_items.thtml'
    ));

    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('album_id',$album_id);

    $retval .= COM_startBlock ($LANG_MG01['batch_caption_editor'] . ' - ' . '<a href="' . $_MG_CONF['site_url'] . '/album.php?aid=' . $album_id . '">' . strip_tags($A['album_title']) . '</a>', '',
                               COM_getBlockTemplate ('_admin_block', 'header'));

    if ( $_DB_dbms == "mssql" ) {
        $sql = "SELECT *,CAST(media_desc AS TEXT) as media_desc FROM " .
                $_TABLES['mg_media_albums'] .
                " as ma INNER JOIN " .
                $_TABLES['mg_media'] .
                " as m ON ma.media_id=m.media_id" .
                " WHERE ma.album_id=" . $album_id .
                " ORDER BY ma.media_order DESC LIMIT " . $start . ",9;";
    } else {
        $sql = "SELECT * FROM " .
                $_TABLES['mg_media_albums'] .
                " as ma INNER JOIN " .
                $_TABLES['mg_media'] .
                " as m ON ma.media_id=m.media_id" .
                " WHERE ma.album_id=" . $album_id .
                " ORDER BY ma.media_order DESC LIMIT " . $start . ",9;";
    }
    $result = DB_query( $sql );
    $nRows = DB_numRows( $result );

    if ( $nRows == 0 ) {
        // we have nothing in the album at this time...
        $T->set_var(array(
            'noitems'  =>  $LANG_MG01['no_media_objects']
        ));
        $T->parse('noitems','empty');
    } else {
        $mediaObject = array();

        $T->set_block('media', 'ImageColumn', 'IColumn');
        $T->set_block('media', 'ImageRow','IRow');

        for ($x = 0; $x < $nRows; $x+=3 ) {
            $T->set_var('IColumn','');

            for ($j = $x; $j < ($x + 3); $j++) {
                if ($j >= $nRows) {
                    break;
                }

                $row = DB_fetchArray( $result );

                $mediaObject[] = $row;

                switch ( $row['media_type']) {
                    case 0 :
                        $thumbnail  = $_MG_CONF['site_url'] . '/mediaobjects/tn/' . $row['media_filename'][0] .'/' . $row['media_filename'] . '.jpg';
                        $pThumbnail = $_MG_CONF['path_html'] . 'mediaobjects/tn/' . $row['media_filename'][0] .'/' . $row['media_filename'] . '.jpg';
                        break;
                    case 1 :
                        switch ( $row['media_mime_ext'] ) {
                            case 'swf' :
                                $thumbnail = $_MG_CONF['site_url'] . '/mediaobjects/flash.gif';
                                $pThumbnail = $_MG_CONF['path_html'] . 'mediaobjects/flash.gif';
                                break;
                            case 'mov' :
                            case 'mp4' :
                                $thumbnail = $_MG_CONF['site_url'] . '/mediaobjects/quicktime.gif';
                                $pThumbnail = $_MG_CONF['path_html'] . 'mediaobjects/quicktime.gif';
                                break;
                            case 'asf' :
                                $thumbnail = $_MG_CONF['site_url'] . '/mediaobjects/wmp.gif';
                                $pThumbnail = $_MG_CONF['path_html'] . 'mediaobjects/wmp.gif';
                                break;
                            default :
                                $thumbnail  = $_MG_CONF['site_url'] . '/mediaobjects/video.gif';
                                $pThumbnail = $_MG_CONF['path_html'] . 'mediaobjects/video.gif';
                                break;
                        }
                        break;
                    case 2 :
                        $thumbnail  = $_MG_CONF['site_url'] . '/mediaobjects/audio.gif';
                        $pThumbnail = $_MG_CONF['path_html'] . 'mediaobjects/audio.gif';
                        break;
                    case 4 :
                        switch ($row['media_mime_ext']) {
                            case 'zip' :
                            case 'arj' :
                            case 'rar' :
                            case 'gz'  :
                                $thumbnail  = $_MG_CONF['site_url'] . '/mediaobjects/zip.gif';
                                $pThumbnail  = $_MG_CONF['path_html'] . 'mediaobjects/zip.gif';
                                break;
                            case 'pdf' :
                                $thumbnail  = $_MG_CONF['site_url'] . '/mediaobjects/pdf.gif';
                                $pThumbnail  = $_MG_CONF['path_html'] . 'mediaobjects/pdf.gif';
                                break;
                            default :
                                $thumbnail  = $_MG_CONF['site_url'] . '/mediaobjects/generic.gif';
                                $pThumbnail  = $_MG_CONF['path_html'] . 'mediaobjects/generic.gif';
                                break;
                        }
                        break;
                    case 5 :
                        $thumbnail  = $_MG_CONF['site_url'] . '/mediaobjects/remote.png';
                        $pThumbnail  = $_MG_CONF['path_html'] . 'mediaobjects/remote.png';
                        break;

                }
                $img_size = @getimagesize($pThumbnail);
                if ( $img_size != false ) {
                    if ( $img_size[0] > $img_size[1] ) {
                        $ratio = $img_size[0] / 200;
                        $width = 200;
                        $height = round($img_size[1] / $ratio);
                    } else {
                        $ratio = $img_size[1] / 200;
                        $height = 200;
                        $width = round($img_size[0] / $ratio);
                    }
                }

                $T->set_var(array(
                    'rowclass'          => ($rowclass % 2) ? '1' : '2',
                    'media_id'      =>      $row['media_id'],
                    'u_thumbnail'   =>      $thumbnail,
                    'media_title'   =>      $row['media_title'],
                    'media_desc'    =>      $row['media_desc'],
                    'height'        =>      $height,
                    'width'         =>      $width,
                    'lang_title'        => $LANG_MG01['title'],
                    'lang_description'  => $LANG_MG01['description'],

                ));
                $start++;
                $rowclass++;
                $T->parse('IColumn','ImageColumn',true);
            }
            $T->parse('IRow','ImageRow',true);
        }
        $T->parse('mediaitems','media');
    }

    $T->set_var(array(
        'album_id'          => $album_id,
        'url_album'         => $_MG_CONF['site_url'] . '/album.php?aid=' . $album_id,
        's_form_action'     => $_MG_CONF['site_url'] . '/admin.php?album_id=' . $album_id . '&start=' . $start,
        'action'            => 'batchcaptionsave',
        'start'             => $start,
        'lang_cancel'       => $LANG_MG01['cancel'],
        'lang_save_exit'    => $LANG_MG01['save_exit'],
        'input_next'        => ($start >= $A['media_count'] ? '' : '<input type="submit" name="mode" value="' . $LANG_MG01['save_next_batch'] . '">'),
        'lang_save_next_batch' => $LANG_MG01['save_next_batch'],
        'lang_batch_caption_help' => $LANG_MG01['batch_caption_help']
    ));
    $T->parse('output','admin');
    $retval .= $T->finish($T->get_var('output'));
    $retval .= COM_endBlock (COM_getBlockTemplate ('_admin_block', 'footer'));
    return $retval;
}


function MG_batchCaptionSave( $album_id, $start, $actionURL ) {
    global $_USER, $_CONF, $_TABLES, $_MG_CONF, $LANG_MG00, $LANG_MG01, $_POST;

    $media_title = array();
    $media_desc  = array();
    $media_id    = array();

    $media_title = $_POST['media_title'];
    $media_desc  = $_POST['media_desc'];
    $media_id    = $_POST['media_id'];

    $total_media = count($media_id);

    for ($i=0; $i < $total_media; $i++ ) {
        if ( $_MG_CONF['htmlallowed'] ) {
            $title    = addslashes(COM_checkWords(COM_stripslashes($media_title[$i])));
            $desc     = addslashes(COM_checkWords($media_desc[$i]));
        } else {
            $title    = addslashes(htmlspecialchars(strip_tags(COM_checkWords(COM_stripslashes($media_title[$i])))));
            $desc     = addslashes(htmlspecialchars(strip_tags(COM_checkWords(COM_stripslashes($media_desc[$i])))));
        }

        $sql = "UPDATE " . $_TABLES['mg_media'] . " SET media_title='" . $title . "', `media_desc` ='" . $desc  . "' WHERE media_id='" . $media_id[$i] ."'";
        DB_query($sql);
    }
    require_once($_MG_CONF['path_html'] . 'maint/rssfeed.php');
    MG_buildAlbumRSS( $album_id );

    echo COM_refresh($actionURL);
    exit;
}
?>