<?php
// +---------------------------------------------------------------------------+
// | Media Gallery Plugin 1.5                                                  |
// +---------------------------------------------------------------------------+
// | $Id:: rotate.php 1046 2007-06-21 05:26:22Z mevans0263                    $|
// | Image rotation administration routines                                    |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2006 by the following authors:                              |
// |                                                                           |
// | Author: mevans@ecsnet.com                                                 |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

// this file can't be used on its own
if (!defined ('VERSION')) {
    die ('This file can not be used on its own.');
}


function MG_rotateMedia( $album_id, $media_id, $direction, $actionURL='') {
    global $_TABLES, $_MG_CONF, $_POST;

    require_once($_MG_CONF['path_html'] . 'lib-upload.php');

    switch( $direction ) {
        case 'right' :
            $IM_rotate = "90";
            $NP_rotate = "270";
            $GD_rotate = "270";
            $JT_rotate = "90";
            break;
        case 'left' :
            $IM_rotate = "-90";
            $NP_rotate = "90";
            $GD_rotate = "90";
            $JT_rotate = "270";
            break;
        default :
            COM_errorLog("Invalid direction passed to rotate");
            exit;
    }

    $sql = "SELECT * FROM " . $_TABLES['mg_media'] . " WHERE media_id='" . $media_id . "'";
    $result=DB_query($sql);
    $row = DB_fetchArray($result);
    if ( DB_error() != 0 )  {
        COM_errorLog("ERROR: Unable to retrieve media object data");
        echo COM_refresh( $actionURL );
        exit;
    }
    $filename = $row['media_filename'];

    $tn     = $_MG_CONF['path_html'] . 'mediaobjects/tn/'   . $filename[0] . '/' . $filename . '.jpg';
    $disp   = $_MG_CONF['path_html'] . 'mediaobjects/disp/' . $filename[0] . '/' . $filename . '.jpg';
    $orig   = $_MG_CONF['path_html'] . 'mediaobjects/orig/' . $filename[0] . '/' . $filename . '.' . $row['media_mime_ext'];

    if ( $_MG_CONF['jpegtran_enabled'] == 1 ) {
        $tn_of   = $tn . '.rt';
        $disp_of = $disp . '.rt';
        $orig_of = $orig . '.rt';

        MG_execWrapper('"' . $_MG_CONF['jpegtran_path'] . "/jpegtran" . '"' . " -rotate " . $JT_rotate . " -trim \"$tn\" > \"$tn_of\"");
        MG_execWrapper('"' . $_MG_CONF['jpegtran_path'] . "/jpegtran" . '"' . " -rotate " . $JT_rotate . " -trim \"$disp\" > \"$disp_of\"");
        if ( $row['media_mime_ext'] == 'jpg' && $_MG_CONF['discard_original'] != 1) {
            if ($_MG_CONF['verbose'] ) {
                MG_execWrapper('"' . $_MG_CONF['jpegtran_path'] . "/jpegtran" . '"' . " -verbose -rotate " . $JT_rotate . " -trim $orig > $orig_of");
            } else {
                MG_execWrapper('"' . $_MG_CONF['jpegtran_path'] . "/jpegtran" . '"' . " -rotate " . $JT_rotate . " -trim $orig > $orig_of");
            }
        }

        if ( $_MG_CONF['jhead_enabled'] == 1 ) {
            $rc = MG_execWrapper('"' . $_MG_CONF['jhead_path'] . "/jhead" . '"' . " -te " . $disp . " " . $disp_of);
            if ( $row['media_mime_ext'] == 'jpg' && $_MG_CONF['discard_original'] != 1) {
                $rc = MG_execWrapper('"' . $_MG_CONF['jhead_path'] . "/jhead" . '"' . " -te " . $orig . " " . $orig_of);
            }
        }
        $rc = @copy($tn_of, $tn);
        $rc = @copy($disp_of, $disp);
        if ( $row['media_mime_ext'] == 'jpg' && $_MG_CONF['discard_original'] != 1) {
            $rc = @copy($orig_of, $orig);
            if ( $rc == TRUE ) {
                @unlink($orig_of);
            }
        }
        @unlink($disp_of);
        @unlink($tn_of);
    } else {
        $tn_of   = $tn . '.rt';
        $disp_of = $disp . '.rt';
        $orig_of = $orig . '.rt';

        switch ( $_MG_CONF['graphicspackage'] ) {
            case 0 : // ImageMagick
                MG_execWrapper('"' . $_MG_CONF['graphicspackage_path'] . "/convert" . '"' . " -quality 100 -rotate " . $IM_rotate . " $tn $tn");
                MG_execWrapper('"' . $_MG_CONF['graphicspackage_path'] . "/convert" . '"' . " -quality 100 -rotate " . $IM_rotate . " $disp $disp");
                if ( $row['media_mime_ext'] == 'jpg' && $_MG_CONF['discard_original'] != 1) {
                    MG_execWrapper('"' . $_MG_CONF['graphicspackage_path'] . "/convert" . '"' . " -quality 100 -rotate " . $IM_rotate . " $orig $orig_of");
                    if ( $_MG_CONF['jhead_enabled'] == 1 ) {
                        $rc = MG_execWrapper('"' . $_MG_CONF['jhead_path'] . "/jhead" . '"' . " -te " . $orig . " " . $orig_of);
                    }
                    $rc = copy($orig_of, $orig);
                    if ( $rc == TRUE ) {
                        @unlink($orig_of);
                    }
                }
                break;
            case 1 : // NetPBM
                $pamflip = '/pamflip';
                $cmd = '"' . $_MG_CONF['graphicspackage_path'] . "/jpegtopnm" . '" ' . $tn   . " | " . '"' . $_MG_CONF['graphicspackage_path'] . $pamflip .'" -r' . $NP_rotate . " > " . $tn . ".PNM";
                MG_execWrapper($cmd);
                MG_execWrapper('"' . $_MG_CONF['graphicspackage_path'] . "/pnmtojpeg" . '"' . " -quality=100 " . $tn . ".PNM > " . $tn);
                @unlink($tn . ".PNM");
                MG_execWrapper('"' . $_MG_CONF['graphicspackage_path'] . "/jpegtopnm" . '" ' . $disp . " | " . '"' . $_MG_CONF['graphicspackage_path'] . $pamflip . '" -r' . $NP_rotate . " > " . $disp . ".PNM");
                MG_execWrapper('"' . $_MG_CONF['graphicspackage_path'] . "/pnmtojpeg" . '"' . " -quality=100 " . $disp . ".PNM > " . $disp);
                @unlink($disp . ".PNM");

                if ( $row['media_mime_ext'] == 'jpg' && $_MG_CONF['discard_original'] != 1) {
                    MG_execWrapper('"' . $_MG_CONF['graphicspackage_path'] . "/jpegtopnm" . '" ' . $orig . " | " . '"' . $_MG_CONF['graphicspackage_path'] . $pamflip . '" -r' . $NP_rotate . " > " . $orig . ".PNM");
                    MG_execWrapper('"' . $_MG_CONF['graphicspackage_path'] . "/pnmtojpeg" . '"' . " -quality=100 " . $orig . ".PNM > " . $orig_of);
                    @unlink($disp . ".PNM");
                    if ( $_MG_CONF['jhead_enabled'] == 1 ) {
                        $rc = MG_execWrapper('"' . $_MG_CONF['jhead_path'] . "/jhead" . '"' . " -te " . $orig . " " . $orig_of);
                    }
                    $rc = copy($orig_of, $orig);
                    if ( $rc == TRUE ) {
                        @unlink($orig_of);
                    }
                }
                break;
            case 2 : // GD Libraries
                MG_gdRotate($tn, $tn, $GD_rotate);
                MG_gdRotate($disp,$disp,$GD_rotate);
                if ( $row['media_mime_ext'] == 'jpg' && $_MG_CONF['discard_original'] != 1) {
                    MG_gdRotate($orig,$orig_of,$GD_rotate);
                    if ( $_MG_CONF['jhead_enabled'] == 1 ) {
                        $rc = MG_execWrapper('"' . $_MG_CONF['jhead_path'] . "/jhead" . '"' . " -te " . $orig . " " . $orig_of);
                    }
                    $rc = copy($orig_of, $orig);
                    if ( $rc == TRUE ) {
                        @unlink($orig_of);
                    }
                }
                break;
        }
    }
    if ( $actionURL == -1 )
        return true;

    echo COM_refresh( $actionURL . '&t=' . time() );
    exit;
}


function MG_gdRotate( $src, $dest, $angle ) {

    $curImg = imagecreatefromjpeg($src);

    if ($angle == 180){
        $dst_img = imagerotate($curImg, $angle, 0);
    } else {
        $width  = imagesx($curImg);
        $height = imagesy($curImg);
        if ($width > $height){
            $size = $width;
        } else {
            $size = $height;
        }

        if (function_exists("imagecreatetruecolor")) {
            $dst_img = imagecreatetruecolor($size,$size);
        } else {
            $dst_img = imagecreate($size,$size);
        }

        imagecopy($dst_img, $curImg, 0, 0, 0, 0, $width, $height);
        imagedestroy($curImg);

        $rotate_img = imagerotate($dst_img, $angle, 0);
        imagedestroy($dst_img);
        if (function_exists("imagecreatetruecolor")) {
            $final_img = imagecreatetruecolor($height, $width);
        } else {
            $final_img = imagecreate($width,$height);
        }

        if ((($angle == 90) && ($width > $height)) || (($angle == 270) && ($width < $height))){
            imagecopy($final_img, $rotate_img, 0, 0, 0, 0, $size, $size);
        }

        if ((($angle == 270) && ($width > $height)) || (($angle == 90) && ($width < $height))){
            imagecopy($final_img, $rotate_img, 0, 0, $size - $height, $size - $width, $size, $size);
        }
        imagedestroy($rotate_img);

    }
    imagejpeg($final_img,$dest,100);
    imagedestroy($final_img);
}
?>