<?php
// +---------------------------------------------------------------------------+
// | Media Gallery Plugin 1.5                                                  |
// +---------------------------------------------------------------------------+
// | $Id:: media.php 1046 2007-06-21 05:26:22Z mevans0263                     $|
// +---------------------------------------------------------------------------+
// | Copyright (C) 2006 by the following authors:                              |
// |                                                                           |
// | Author:                                                                   |
// | Mark R. Evans              -   mevans@ecsnet.com                          |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

global $_MG_CONF, $_USER, $LANG_LOGIN;

require_once('../lib-common.php');
require_once($_MG_CONF['path_html'] . 'classAlbum.php');
require_once($_MG_CONF['path_html'] . 'lib-media.php');

if (!function_exists('MG_usage')) {
    // The plugin is disabled
    $display = COM_siteHeader();
    $display .= COM_startBlock('Plugin disabled');
    $display .= '<br />The Media Gallery plugin is currently disabled.';
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}


if ( (!isset($_USER['uid']) || $_USER['uid'] < 2) && $_MG_CONF['loginrequired'] == 1 )  {
    $display = MG_siteHeader();
    $display .= COM_startBlock ($LANG_LOGIN[1], '',COM_getBlockTemplate ('_msg_block', 'header'));
    $login = new Template($_CONF['path_layout'] . 'submit');
    $login->set_file (array ('login'=>'submitloginrequired.thtml'));
    $login->set_var ('login_message', $LANG_LOGIN[2]);
    $login->set_var ('site_url', $_CONF['site_url']);
    $login->set_var ('lang_login', $LANG_LOGIN[3]);
    $login->set_var ('lang_newuser', $LANG_LOGIN[4]);
    $login->parse ('output', 'login');
    $display .= $login->finish ($login->get_var('output'));
    $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    $display .= COM_siteFooter();
    echo $display;
    exit;
}

function MG_updateMediaRating($mid, $rating) {
    global $_CONF, $_MG_CONF, $_TABLES, $LANG_MG02,$_COOKIE;

    if ( $rating == '' ) {
        return;
    }

    $cookie_rated=array();

    $cookie_name = $_CONF['cookie_name'] . '_';
    $cookie_rated = isset($_COOKIE[$cookie_name.'rated']) ? unserialize(stripslashes($_COOKIE[$cookie_name.'rated'])) : array();

    if ($rating && $rating <= 10 && $mid) {
        if ( !in_array('m'.$mid, $cookie_rated )) {

            COM_clearSpeedlimit($_CONF['commentspeedlimit'],'mgrate');
            $last = COM_checkSpeedlimit ('mgrate');
            if ( $last > 0 ) {
                $display = MG_siteHeader();
                $display .= MG_errorHandler( sprintf($LANG_MG02['rate_speedlimit'],$last ) );
                $display .= MG_siteFooter();
                echo $display;
                exit;
            }
            $cookie_rated[] = 'm' . $mid;
            $cookie_expire = time() + 60 * 60 * 24 * 4;
            $rc = setcookie($cookie_name.'rated', serialize($cookie_rated), $cookie_expire, $_CONF['cookie_path'], $_CONF['cookiedomain'], $_CONF['cookiesecure']);


            $sql = "SELECT media_votes,media_rating FROM {$_TABLES['mg_media']} WHERE media_id='" . $mid . "'";

            $result     = DB_query($sql);
            $row        = DB_fetchArray($result);
            $old_votes  = $row['media_votes'];
            $old_rating = $row['media_rating'];
            $new_rating = (($old_rating * $old_votes) + $rating) / ($old_votes + 1);
            $new_rating = sprintf("%.2f", $new_rating);
            $sql = "UPDATE {$_TABLES['mg_media']} SET media_votes = ($old_votes + 1), media_rating = '$new_rating'
                            WHERE media_id='" . $mid . "'";
            DB_query($sql);
            COM_updateSpeedlimit ('mgrate');
            $msg = 4;
        } else {
            $msg = 5;
        }
    }   else {
        $msg = 6;
    }
    return $msg;
}

/*
* Main Function
*/

ob_start();

$msg = '';
$msg = COM_applyFilter($_REQUEST['msg'],true);

if (isset($_POST['submit']) ) {
    $mid    = COM_applyFilter($_POST['mid']);
    $rating = COM_applyFilter($_POST['rating'],true);
    $msg    = MG_updateMediaRating($mid,$rating);
}

if (isset($_REQUEST['aid'])) {
    $album_id = COM_applyFilter($_REQUEST['aid']);
}

if ( isset($_REQUEST['f'])) {
    $full = COM_applyFilter($_REQUEST['f'],true);
} else {
    $full = 0;
}

if ( isset($_REQUEST['s'])) {
    $mediaObject = COM_applyFilter($_REQUEST['s'],true);
}

if ( isset($_REQUEST['sort'])) {
    $sortOrder = COM_applyFilter($_REQUEST['sort'],true);
}

list($ptitle,$retval) = MG_displayMediaImage( $mediaObject, $full, $sortOrder,1 );

echo MG_siteHeader($ptitle);

echo COM_showMessage( $msg, 'mediagallery' );
echo $retval;
echo MG_siteFooter();

$data = ob_get_contents();
ob_end_clean();
echo $data;
?>