<?php
// +---------------------------------------------------------------------------+
// | Media Gallery Plugin 1.5                                                  |
// +---------------------------------------------------------------------------+
// | $Id:: search.php 1046 2007-06-21 05:26:22Z mevans0263                    $|
// +---------------------------------------------------------------------------+
// | Copyright (C) 2006 by the following authors:                              |
// |                                                                           |
// | Author:                                                                   |
// | Mark R. Evans              - mevans@ecsnet.com                            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');
require_once($_MG_CONF['path_html'] . 'classMedia.php');

if (!function_exists(MG_usage)) {
    // The plugin is disabled
    $display = COM_siteHeader();
    $display .= COM_startBlock('Plugin disabled');
    $display .= '<br />The Media Gallery plugin is currently disabled.';
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

if ( (!isset($_USER['uid']) || $_USER['uid'] < 2) && $_MG_CONF['loginrequired'] == 1 )  {
    $display = MG_siteHeader();
    $display .= COM_startBlock ($LANG_LOGIN[1], '',
              COM_getBlockTemplate ('_msg_block', 'header'));
    $login = new Template($_CONF['path_layout'] . 'submit');
    $login->set_file (array ('login'=>'submitloginrequired.thtml'));
    $login->set_var ('login_message', $LANG_LOGIN[2]);
    $login->set_var ('site_url', $_CONF['site_url']);
    $login->set_var ('lang_login', $LANG_LOGIN[3]);
    $login->set_var ('lang_newuser', $LANG_LOGIN[4]);
    $login->parse ('output', 'login');
    $display .= $login->finish ($login->get_var('output'));
    $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    $display .= COM_siteFooter();
    echo $display;
    exit;
}

function MG_displaySearchBox($msg = '') {
    global $_CONF, $_MG_CONF, $_TABLES, $LANG_MG01, $LANG_MG03;

    $T = new Template($_CONF['path'] . 'plugins/mediagallery/templates');

    $T->set_file (array(
        'search'    =>  'search.thtml',
    ));
    $T->set_var('site_url', $_CONF['site_url']);

    $cat_select = '<select name="cat_id">';
    $cat_select .= '<option value="">' . $LANG_MG03['all_categories'] . '</option>';
    $result = DB_query("SELECT * FROM {$_TABLES['mg_category']} ORDER BY cat_id ASC");
    $nRows = DB_numRows($result);
    for ( $i=0; $i < $nRows; $i++ ) {
        $row = DB_fetchArray($result);
        $cat_select .= '<option value="' . $row['cat_id'] . '">' . $row['cat_name'] . '</option>';
    }
    $cat_select .= '</select>';

    $keytype = '<select name="keyType">';
    $keytype .= '<option value="phrase">' . $LANG_MG03['exact_phrase'] . '</option>';
    $keytype .= '<option value="all">' . $LANG_MG03['all'] . '</option>';
    $keytype .= '<option value="any">' . $LANG_MG03['any'] . '</option>';
    $keytype .= '</select>';

    $swhere = '<select name="shwere">';
    $swhere .= '<option value="0">' . $LANG_MG03['title_desc_keywords'] . '</option>';
    $swhere .= '<option value="1">' . $LANG_MG03['keywords_only'] . '</option>';
    $swhere .= '<option value="2">' . $LANG_MG03['title_desc_only'] . '</option>';
    $swhere .= '</select>';

    $nresults = '<select name="numresults">';
    $nresults .= '<option value="10">10</option>';
    $nresults .= '<option value="20">20</option>';
    $nresults .= '<option value="30">30</option>';
    $nresults .= '<option value="40">40</option>';
    $nresults .= '<option value="50">50</option>';
    $nresults .= '</select>';

    $userselect = '<select name="uid">';
    $userselect .= '<option value="0">' . $LANG_MG01['all_users'] . '</option>';
    $sql = "SELECT uid,username,fullname FROM {$_TABLES['users']} WHERE uid > 1 ORDER BY username";
    $result = DB_query($sql);
    while ($U = DB_fetchArray($result) ) {
	    $userselect .= '<option value="' . $U['uid'] . '">' . $U['username'] . '</option>' . LB;
    }
    $userselect .= '</select>';



    $T->set_var(array(
        'msg'               => $msg,
        's_form_action'     => $_MG_CONF['site_url'] . '/search.php',
        'mode'              => 'search',
        'action'            => '',
        'cat_select'        => $cat_select,
        'keytype_select'    => $keytype,
        'swhere_select'     => $swhere,
        'nresults_select'   => $nresults,
        'user_select'		=> $userselect,
        'lang_search_title' => $LANG_MG03['advanced_search'],
        'lang_search_query' => $LANG_MG03['search_query'],
        'lang_search_help'  => $LANG_MG03['search_help'],
        'lang_options'      => $LANG_MG03['options'],
        'lang_keywords'     => $LANG_MG03['keywords'],
        'lang_category'     => $LANG_MG03['category'],
        'lang_all_fields'   => $LANG_MG03['all_fields'],
        'lang_keyword_only' => $LANG_MG03['keywords_only'],
        'lang_return_results' => $LANG_MG03['return_results'],
        'lang_search_for'   => $LANG_MG03['search_for'],
        'lang_search_in'    => $LANG_MG03['search_in'],
        'lang_results'      => $LANG_MG03['results'],
        'lang_per_page'     => $LANG_MG03['per_page'],
        'lang_search'       => $LANG_MG01['search'],
        'lang_cancel'       => $LANG_MG01['cancel'],
        'lang_user'			=> $LANG_MG01['select_user'],
    ));

    $T->parse('output','search');
    $retval .= $T->finish($T->get_var('output'));
    return $retval;
}

/**
* this searches for pages matching the user query and returns an array of
* for the header and table rows back to search.php where it will be formated and
* printed
*
* @query            string          Keywords user is looking for
* @datestart        date/time       Start date to get results for
* @dateend          date/time       End date to get results for
* @topic            string          The topic they were searching in
* @type             string          Type of items they are searching
* @author           string          Get all results by this author
*
*/
function MG_search($id,$page) {
    global $MG_albums, $_USER, $_TABLES, $_CONF, $_MG_CONF, $LANG_MG00, $LANG_MG01,$LANG_MG03;

    // pull the query from the search database...

    $result = DB_query("SELECT * FROM {$_TABLES['mg_sort']} WHERE sort_id='" . $id . "'");
    $nrows  = DB_numRows($result);
    if ( $nrows < 1 ) {
        print "Bad search id";
        exit;
    }
    $S = DB_fetchArray($result);

    if ($_USER['uid'] < 2 ) {
        $sort_user = 1;
    } else {
        $sort_user = $_USER['uid'];
    }
    if ( $sort_user != $S['sort_user'] ) {
        die("Hack Attempt");
    }
    $sqltmp = stripslashes($S['sort_query']);
    $numresults = $S['sort_results'];

    $sql = "SELECT DISTINCT * FROM " .
            $_TABLES['mg_media'] . " as m " .
            " INNER JOIN " . $_TABLES['mg_media_albums'] . " as ma " .
            " ON m.media_id=ma.media_id " . $sqltmp . " ORDER BY m.media_time DESC;";

    $page  = $page - 1;
    $begin = $page * $numresults;
    $end   = ($page * $numresults) + ($numresults - 1);

    $result = DB_query($sql);

    $mycount = DB_numRows($result);

    if ( $mycount < 1 ) {
        return(MG_displaySearchBox('<div class="mgPluginAlert">' . $LANG_MG03['no_search_found'] . '</div>'));
    }

    $arrayCounter = 0;
    $mediaRows = 0;
    if ( $mycount > 0 ) {
        for ($i=0; $i < $mycount; $i++)     {
            $row = DB_fetchArray( $result );
            if ( $MG_albums[$row['album_id']]->access == 0 || ($MG_albums[$row['album_id']]->hidden == 1 && $MG_albums[0]->owner_id != 1) ) {
                continue;
            }
            $media = new Media();
            $media->constructor($row,$row['album_id']);
            $MG_media[$arrayCounter] = $media;
            $arrayCounter++;
            $mediaRows++;
        }
    }
    if ( $mediaRows == 0 ) {
        return(MG_displaySearchBox('<div class="mgPluginAlert">' . $LANG_MG03['no_search_found'] . '</div>'));
    }

    $retval .= COM_startBlock ($LANG_MG03['search_results'], '',
                               COM_getBlockTemplate ('_admin_block', 'header'));

    $T = new Template($_CONF['path'] . 'plugins/mediagallery/templates');
    $T->set_file (array ('results' => 'search_results.thtml'));

    $T->set_var(array(
        'pagination'        => COM_printPageNavigation($_MG_CONF['site_url'] . '/search.php?id=' . $id, $page+1,ceil($mediaRows / $numresults),'&amp;page='),
        'keywords'          => $keywords,
        'stype'             => $stype,
        'category'          => $category,
        'skeywords'         => $skeywords,
        'numresults'        => $numresults,
        'sortyby'           => $sortby,
        'sortydirection'    => $sortdirection,
        'page'              => $page,
        'lang_title'        => $LANG_MG01['title'],
        'lang_description'  => $LANG_MG01['description'],
        'lang_views'        => $LANG_MG03['views'],
    ));

    $T->set_block('results', 'SearchRow', 'sRow');

    $howmany = $begin + $numresults;
    if ( $howmany > $mediaRows )
        $howmany = $mediaRows;

    for ($i=$begin; $i < $howmany; $i++ ) {
        $media_title = $MG_media[$i]->title;
        if ( $media_title == '' ) {
            $album_title = $MG_albums[$MG_media[$i]->album_id]->title;
            $media_title = $album_title . ' - <em>' . $LANG_MG01['no_caption'] . '</em>';
        }
        $tn = $MG_media[$i]->displayRawThumb();
        $url =  $_MG_CONF['site_url'] . '/media.php?s=' . $MG_media[$i]->id;

        $media_date = COM_getUserDateTimeFormat($MG_media[$i]->time);
        $row = array('<a href="' . $url . '">' . $media_title . "</a>",
                     $media_date[0],$MG_media[$i]->views);

        $T->set_var(array(
            'result_row'    => $rowcounter,
            'rowclass'      => ($rowcounter % 2) ? '2' : '1',
            'tn'            => '<a href="' . $url . '">' . $tn . "</a>",
            'media_url'     => $row[0],
            'media_date'    => $row[1],
            'media_views'   => $row[2],
            'media_description' => $MG_media[$i]->description,
        ));
        $T->parse('sRow','SearchRow',true);
        $rowcounter++;
    }



    $T->parse('output', 'results');
    $retval .= $T->finish($T->get_var('output'));
    $retval .= COM_endBlock (COM_getBlockTemplate ('_admin_block', 'footer'));
    return $retval;
}


/*
* Main Function
*/


$mode = COM_applyFilter ($_REQUEST['mode']);
$display  = MG_siteHeader();

if ($mode == $LANG_MG01['search'] && !empty ($LANG_MG01['search'])) {
    $keywords       = COM_applyFilter($_REQUEST['keywords']);
    $stype          = COM_applyFilter($_REQUEST['keyType']);
    $category       = COM_applyFilter($_REQUEST['cat_id']);
    $skeywords      = COM_applyFilter($_REQUEST['swhere']);
    $numresults     = COM_applyFilter($_REQUEST['numresults'],true);
    $users			= COM_applyFilter($_REQUEST['uid'],true);
    $sortyby        = 'title';
    $sortdirection  = 'DESC';

    if ( $keywords == '' ) {
        $display .= MG_errorHandler( $LANG_MG03['search_error'] );
        $display .= MG_siteFooter();
        echo $display;
        exit;
    }
    if ( $keywords == '*' ) {
        $keywords = '';
    }

    // build the query and put into our database...

    $sqltmp = " WHERE 1=1 ";
    if ( $stype == 'phrase' ) { // search phrase
        switch ( $skeywords ) {
            case 0 :
                $sqltmp .= "AND (m.media_title LIKE '%$keywords%' OR m.media_desc LIKE '%$keywords%' OR m.media_keywords LIKE '%$keywords%')";
                break;
            case 1 :
                $sqltmp .= "AND (m.media_keywords LIKE '%$keywords%')";
                break;
            case 2 :
                $sqltmp .= "AND (m.media_title LIKE '%$keywords%' OR m.media_desc LIKE '%$keywords%')";
                break;
        }
    } else if ( $stype == 'any') {
        $sqltmp .= ' AND ';
        $tmp = '';
        $mywords = explode( ' ', $keywords );
        foreach( $mywords AS $mysearchitem ) {
            $mysearchitem = addslashes( $mysearchitem );
            switch ( $skeywords ) {
                case 0 :
                    $tmp .= "( m.media_title LIKE '%$mysearchitem%' OR m.media_desc LIKE '%$mysearchitem%' OR m.media_keywords LIKE '%$mysearchitem%') OR ";
                    break;
                case 1 :
                    $tmp .= "( m.media_keywords LIKE '%$mysearchitem%') OR ";
                    break;
                case 2 :
                    $tmp .= "( m.media_title LIKE '%$mysearchitem%' OR m.media_desc LIKE '%$mysearchitem%') OR ";
                    break;
            }
        }
        $tmp = substr($tmp, 0, strlen($tmp) - 3);
        $sqltmp .= "($tmp)";
    } else if ( $stype == 'all' ) {
        $sqltmp .= 'AND ';
        $tmp = '';
        $mywords = explode( ' ', $keywords );
        foreach( $mywords AS $mysearchitem ) {
            $mysearchitem = addslashes( $mysearchitem );
            switch ( $skeywords ) {
                case 0 :
                    $tmp .= "( m.media_title LIKE '%$mysearchitem%' OR m.media_desc LIKE '%$mysearchitem%' OR m.media_keywords LIKE '%$mysearchitem%') AND ";
                    break;
                case 1 :
                    $tmp .= "( m.media_keywords LIKE '%$mysearchitem%') AND ";
                    break;
                case 2 :
                    $tmp .= "( m.media_title LIKE '%$mysearchitem%' OR m.media_desc LIKE '%$mysearchitem%') AND ";
                    break;
            }
        }
        $tmp = substr($tmp, 0, strlen($tmp) - 4);
        $sqltmp .= "($tmp)";
    } else {
        $sqltmp = "WHERE (m.media_title LIKE '%$keywords%' OR m.media_desc LIKE '%$keywords%' OR m.media_keywords LIKE '%$keywords%')";
    }

    if ( $category != 0 ) {
        $sqltmp .= " AND m.media_category=" . $category;
    }
    if ( $users > 0 ) {
	    $sqltmp .= " AND m.media_user_id=" . $users;
    }
    $sqltmp = addslashes($sqltmp);

    $sort_id = COM_makesid();
    if ( $_USER['uid'] < 2 ) {
        $sort_user = 1;
    } else {
        $sort_user = $_USER['uid'];
    }
    $sort_datetime = time();

    $sql = "INSERT INTO {$_TABLES['mg_sort']} (sort_id,sort_user,sort_query,sort_results,sort_datetime)
            VALUES ('$sort_id',$sort_user,'$sqltmp',$numresults,$sort_datetime)";
    $result = DB_query($sql);
    if ( DB_error() ) {
        COM_errorLog("Media Gallery: Error placing sort query into database");
    }

    $sort_purge = time() - 3660; // 43200;
    DB_query("DELETE FROM {$_TABLES['mg_sort']} WHERE sort_datetime < " . $sort_purge);

    $display .= MG_search($sort_id,1);

} elseif ($mode == $LANG_MG01['cancel']) {
    echo COM_refresh ($_MG_CONF['site_url'] . '/index.php');
    exit;
} elseif (isset($_GET['id']) ) {
    $id = COM_applyFilter($_GET['id']);
    $page = COM_applyFilter($_GET['page']);
    if ( $page < 1 )
      $page = 1;
    $display .= MG_search($id,$page);
} else {
    $display .= MG_displaySearchBox('');
}

$display .= MG_siteFooter();
echo $display;

?>
